#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/20/90";
#endif
#define YYBYACC 1
#line 2 "pars.yacc"

/* $Id: pars.yacc,v 1.4 1995/06/30 22:32:11 pturner Exp pturner $
 * 
 * evaluate expressions, commands, parameter files
 * 
 */

#define PARS			

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <math.h>
#include <ctype.h>
#include <sys/param.h>

#include "globals.h"
#include "protos.h"

#ifndef M_PI
#     define M_PI  3.14159265358979323846
#endif

#ifndef TRUE
#     define TRUE 1
#endif

#ifndef FALSE
#     define FALSE 0
#endif

double result, resx, resy;	/* return value if expression */
double nonl_parms[10];

double drand48(void);
long lrand48(void);
double erf(double arg); /* doesn't seem to be in ANSI C */
double erfc(double arg); /* doesn't seem to be in ANSI C */
double rnorm(double mean, double sdev);
double fx(double x);
double normp(double b, double *s);
double invnorm(double p);
double invt(double p, int n);
double *getvptr(int gno, int setno, int v);
double vmin(double *x, int n);
double vmax(double *x, int n);
void yyerror(char *s);

static int interr;

static double *freelist[100]; 	/* temporary vectors */
static int fcnt;		/* number allocated */

int naxis = 0;	/* current axis */
int curline, curbox, curellipse, curstring, curleg, curgrid;

int gotbatch, gotparams, gotread; /* these guys attempt to avoid reentrancy problems */
int readtype, readsrc, readxformat;
char batchfile[256], paramfile[256], readfile[256];

static char f_string[512];	/* buffer for string to parse */
static int pos = 0;
static double *aa, *bb, *cc, *dd, *xx, *yy;
static int setindex, lxy, ls;
static int setsetno;
static int whichgraph;
static int whichset;

extern int change_gno;
extern int change_type;

#line 76 "pars.yacc"
typedef union {
    double val;
    long ival;
    double *ptr;
    long func;
    long pset;
    char *str;
} YYSTYPE;
#line 88 "y.tab.c"
#define ABS 257
#define ACOS 258
#define ASIN 259
#define ATAN 260
#define ATAN2 261
#define CEIL 262
#define COS 263
#define DEG 264
#define DX 265
#define DY 266
#define ERF 267
#define ERFC 268
#define EXP 269
#define FLOOR 270
#define HYPOT 271
#define INDEX 272
#define INT 273
#define INVN 274
#define INVT 275
#define IRAND 276
#define JDAY 277
#define JDAY0 278
#define LGAMMA 279
#define LN 280
#define LOG 281
#define LOGISTIC 282
#define MAXP 283
#define MINP 284
#define MOD 285
#define NORM 286
#define NORMP 287
#define PI 288
#define RAD 289
#define RAND 290
#define RNORM 291
#define SETNO 292
#define SIN 293
#define SQR 294
#define SQRT 295
#define TAN 296
#define INUM 297
#define VX1 298
#define VX2 299
#define VY1 300
#define VY2 301
#define WX1 302
#define WX2 303
#define WY1 304
#define WY2 305
#define DELAYP 306
#define DOUBLEBUFFER 307
#define DOWN 308
#define ABSOLUTE 309
#define ABORT 310
#define ACTIVATE 311
#define ACTIVE 312
#define ALT 313
#define ALTERNATE 314
#define ALTXAXIS 315
#define ALTYAXIS 316
#define ANGLE 317
#define ANNOTATE 318
#define APPEND 319
#define AREA 320
#define ARRANGE 321
#define ARROW 322
#define ASCENDING 323
#define AUTO 324
#define AUTOSCALE 325
#define AUTOTICKS 326
#define AVG 327
#define AXIS 328
#define AXES 329
#define BACKBUFFER 330
#define BACKGROUND 331
#define BAR 332
#define BATCH 333
#define BLOCK 334
#define BIN 335
#define BOTH 336
#define BOTTOM 337
#define BOX 338
#define BOXPLOT 339
#define CD 340
#define CELLS 341
#define CENTER 342
#define CHAR 343
#define CHRSTR 344
#define CLEAR 345
#define CLICK 346
#define CMAP 347
#define COLOR 348
#define COMMENT 349
#define COPY 350
#define CYCLE 351
#define DECIMAL 352
#define DEF 353
#define DEFAULT 354
#define DELETE 355
#define DEVICE 356
#define DESCENDING 357
#define DFT 358
#define DIFFERENCE 359
#define DISK 360
#define DRAW2 361
#define DROP 362
#define DXDX 363
#define DXP 364
#define DYDY 365
#define DYP 366
#define ECHO 367
#define EDIT 368
#define ELSE 369
#define END 370
#define ERRORBAR 371
#define EXIT 372
#define EXPONENTIAL 373
#define FALSEP 374
#define FFT 375
#define FILEP 376
#define FILL 377
#define FIND 378
#define FIXEDPOINT 379
#define FLUSH 380
#define FOCUS 381
#define FOLLOWS 382
#define FONTP 383
#define FOREGROUND 384
#define FORMAT 385
#define FRONTBUFFER 386
#define FRAMEP 387
#define GETP 388
#define GRAPH 389
#define GRAPHNO 390
#define GRAPHS 391
#define GRAPHTYPE 392
#define GRID 393
#define HARDCOPY 394
#define HBAR 395
#define HBOXPLOT 396
#define HGAP 397
#define HIDDEN 398
#define HORIZONTAL 399
#define HPGLL 400
#define HPGLP 401
#define HISTO 402
#define IF 403
#define IGNORE 404
#define IHL 405
#define IMAGE 406
#define IN 407
#define INIT 408
#define INOUT 409
#define INTEGRATE 410
#define INTERP 411
#define INVDFT 412
#define INVFFT 413
#define JUST 414
#define KILL 415
#define LABEL 416
#define LAYOUT 417
#define LEAVE 418
#define LEFT 419
#define LEGEND 420
#define LENGTH 421
#define LEVEL 422
#define LEVELS 423
#define LINE 424
#define LINESTYLE 425
#define LINETO 426
#define LINEWIDTH 427
#define LINK 428
#define LOAD 429
#define LOCATOR 430
#define LOCTYPE 431
#define LOGX 432
#define LOGY 433
#define LOGXY 434
#define MAJOR 435
#define MIFL 436
#define MIFP 437
#define MINOR 438
#define MISSINGP 439
#define MOVE 440
#define MOVE2 441
#define MOVETO 442
#define NEGATE 443
#define NO 444
#define NONE 445
#define NORMAL 446
#define NXY 447
#define OFF 448
#define OFFSETX 449
#define OFFSETY 450
#define ON 451
#define OP 452
#define ORIENT 453
#define OUT 454
#define PAGE 455
#define PARA 456
#define PARALLEL 457
#define PARAMETERS 458
#define PARAMS 459
#define PATTERN 460
#define PERIMETER 461
#define PERP 462
#define PERPENDICULAR 463
#define PIE 464
#define PIPE 465
#define PLACE 466
#define POINT 467
#define POLAR 468
#define POLY 469
#define POWER 470
#define PREC 471
#define PREPEND 472
#define PRINT 473
#define PS 474
#define PSCOLORP 475
#define PSMONOP 476
#define PSCOLORL 477
#define PSMONOL 478
#define PUSH 479
#define POP 480
#define PUTP 481
#define RAWSPICE 482
#define READ 483
#define REDRAW 484
#define REGRESS 485
#define REGNUM 486
#define REGIONS 487
#define RENDER 488
#define REVERSE 489
#define RIGHT 490
#define RISER 491
#define ROT 492
#define RUNAVG 493
#define RUNMED 494
#define RUNSTD 495
#define RUNMIN 496
#define RUNMAX 497
#define SAMPLE 498
#define SAVEALL 499
#define SCALE 500
#define SCIENTIFIC 501
#define SET 502
#define SETNUM 503
#define SETS 504
#define SIGN 505
#define SIZE 506
#define SKIP 507
#define SLEEP 508
#define SLICE 509
#define SMITH 510
#define SORT 511
#define SOURCE 512
#define SPEC 513
#define SPECIFIED 514
#define SPECTRUM 515
#define STACK 516
#define STACKEDBAR 517
#define STACKEDHBAR 518
#define STACKEDLINE 519
#define STAGGER 520
#define START 521
#define STARTTYPE 522
#define STATUS 523
#define STOP 524
#define STRING 525
#define SUBTITLE 526
#define SWAPBUFFER 527
#define SYMBOL 528
#define TICKP 529
#define TICKLABEL 530
#define TICKMARKS 531
#define TIME 532
#define TITLE 533
#define TO 534
#define TOP 535
#define TRUEP 536
#define TYPE 537
#define UP 538
#define VELOCITY 539
#define VERTICAL 540
#define VGAP 541
#define VIEW 542
#define WITH 543
#define WORLD 544
#define WRITE 545
#define X 546
#define X0 547
#define X1 548
#define XAXES 549
#define XAXIS 550
#define XCOR 551
#define XMAX 552
#define XMIN 553
#define XY 554
#define XYARC 555
#define XYBOX 556
#define XYBOXPLOT 557
#define XYFIXED 558
#define XYHILO 559
#define XYRT 560
#define XYSEG 561
#define XYSTRING 562
#define XYDX 563
#define XYDY 564
#define XYDXDX 565
#define XYDYDY 566
#define XYDXDY 567
#define XYX2Y2 568
#define XYXX 569
#define XYYY 570
#define XYZ 571
#define XYZW 572
#define XYUV 573
#define TSV 574
#define Y 575
#define Y0 576
#define Y1 577
#define Y2 578
#define Y3 579
#define Y4 580
#define Y5 581
#define YAXES 582
#define YAXIS 583
#define YES 584
#define YMAX 585
#define YMIN 586
#define ZEROXAXIS 587
#define ZEROYAXIS 588
#define ABOVE 589
#define BELOW 590
#define POLYI 591
#define POLYO 592
#define GENERAL 593
#define DDMMYY 594
#define YYMMDD 595
#define MMDDYY 596
#define MMYY 597
#define MMDD 598
#define MONTHDAY 599
#define DAYMONTH 600
#define MONTHS 601
#define MONTHSY 602
#define MONTHL 603
#define DAYOFWEEKS 604
#define DAYOFWEEKL 605
#define DAYOFYEAR 606
#define HMS 607
#define MMDDHMS 608
#define MMDDYYHMS 609
#define YYMMDDHMS 610
#define DEGREESLON 611
#define DEGREESMMLON 612
#define DEGREESMMSSLON 613
#define MMSSLON 614
#define DEGREESLAT 615
#define DEGREESMMLAT 616
#define DEGREESMMSSLAT 617
#define MMSSLAT 618
#define DOT 619
#define STAR 620
#define PLUS 621
#define CROSS 622
#define CIRCLE 623
#define SQUARE 624
#define DIAMOND 625
#define TRIANGLE1 626
#define TRIANGLE2 627
#define TRIANGLE3 628
#define TRIANGLE4 629
#define SPLINE 630
#define LANDSCAPE 631
#define PORTRAIT 632
#define FREE 633
#define FIXED 634
#define STATUSBAR 635
#define LOCATORBAR 636
#define TOOLBAR 637
#define VAR 638
#define NUMBER 639
#define FITPARM 640
#define OR 641
#define AND 642
#define GT 643
#define LT 644
#define LE 645
#define GE 646
#define EQ 647
#define NE 648
#define UMINUS 649
#define NOT 650
#define ELLIPSE 651
#define ACOSH 652
#define ASINH 653
#define ATANH 654
#define COSH 655
#define SINH 656
#define TANH 657
#define ASPLINE 658
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   36,   36,   36,   36,   36,   36,   36,
   17,   17,   17,   17,   17,   17,   17,   17,   18,   18,
   18,   18,   18,   18,   18,   18,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   22,   22,   22,   22,   22,   22,
   22,   27,   27,   27,   27,   27,   27,   27,   27,   27,
   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
   27,   27,   27,   27,   27,   20,   20,   20,   20,   20,
   20,   20,   20,   20,   20,   20,   20,   20,   31,   31,
   31,   31,   19,   19,   19,   19,   19,   19,   35,   37,
   37,   37,   37,   37,   37,   37,   37,   37,   37,   37,
   37,   37,   37,   37,   37,   37,   37,   37,   37,   37,
   37,   37,   37,   37,   37,   37,   37,   37,   34,   34,
   34,   34,   34,   34,   38,   38,   38,   38,   38,   38,
   40,   40,   40,   41,   41,   41,   41,   41,   41,   41,
   39,   39,   39,   39,   39,   42,   42,   46,   46,   46,
   46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
   46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
   46,   46,   46,   46,   46,   46,   46,   46,   43,   43,
   47,   47,   47,   47,   47,   47,   47,   47,   47,   47,
   47,   47,   47,   47,   47,   47,   47,   47,   47,   47,
   47,   47,   47,   47,   47,   47,   47,   47,   47,   47,
   47,   47,   47,   47,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   44,   44,   45,   45,   45,   45,   21,
   21,   21,   21,   21,   21,   24,   24,   24,   24,   24,
    7,    7,    8,    8,   28,   28,   28,   28,   28,   29,
   29,   29,   29,   26,   26,   25,   25,   25,   15,   15,
   15,   15,   15,   14,   14,   14,   30,   30,    9,    9,
   12,   12,   12,   11,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,   11,   13,   13,   13,   16,   16,   16,   16,   16,
   16,   10,   10,   33,   33,   32,   32,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    3,    3,    3,    3,
    3,    5,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,
};
short yylen[] = {                                         2,
    0,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    3,    4,    3,    2,    3,    1,    3,
    1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
    3,    3,    3,    9,    5,    4,    1,    3,    2,    2,
    1,    3,    8,    1,    3,    2,    2,    2,    4,    4,
    6,    2,    2,    2,    7,    2,    2,    3,    3,    2,
    2,    2,    1,    2,    2,    2,    2,    2,    2,    2,
    4,    6,    3,    5,    3,    5,    3,    5,    5,    7,
    5,    7,    4,    4,    8,    4,    8,    2,    2,    3,
    3,    2,    2,    1,    4,    7,    6,    6,    6,   10,
   10,    8,   10,    6,    4,    1,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    3,
    3,    4,    3,    3,    4,    3,    3,    5,    2,    4,
    4,    6,    2,    1,    1,    1,    2,   17,    2,    2,
    2,    3,    2,    2,    8,    3,    3,    3,    3,    3,
    4,    4,    2,    2,    2,    3,    2,    2,    8,    3,
    3,    3,    3,    3,    4,    4,    2,    2,    3,    2,
    2,    2,    8,    3,    3,    3,    3,    3,    4,    4,
    2,    2,    2,    3,    2,    2,    4,    3,    3,    3,
    3,    3,    3,    4,    3,    3,    4,    5,    4,    4,
    5,    3,    3,    3,    4,    3,    4,    4,    8,    3,
    3,    3,    3,    5,    8,    3,    3,    3,    3,    2,
    3,    3,    3,    3,    2,    3,    3,    3,    3,    4,
    2,    3,    3,    3,    3,    3,    3,    4,    5,    5,
    4,    4,    4,    4,    3,    3,    4,    3,    3,    3,
    3,    4,    2,    3,    3,    3,    3,    3,    4,    2,
    3,    4,    4,    3,    3,    3,    4,    4,    3,    5,
    6,    6,    4,    4,    3,    3,    3,    3,    3,    3,
    4,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    2,    1,
    1,    2,    2,    2,    2,    2,    3,    3,    3,    3,
    3,    3,    3,    3,    2,    2,    3,    3,    2,    3,
    3,    3,    3,    3,    4,    4,    4,    2,    1,    2,
    1,    2,    3,    2,    1,    1,    1,    1,    1,    1,
    2,    2,    2,    1,    2,    2,    2,    2,    3,    2,
    2,    2,    2,    2,    1,    1,    2,    1,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    1,    2,
    2,    3,    3,    2,    2,    3,    3,    3,    3,    3,
    3,    3,    3,    2,    2,    2,    2,    3,    1,    2,
    1,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    3,    3,    3,    3,    2,    2,    3,
    2,    2,    2,    3,    1,    2,    2,    2,    2,    4,
    2,    3,    2,    2,    2,    1,    2,    2,    2,    3,
    1,    1,    2,    2,    2,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    6,    6,    8,    5,
   10,    5,    3,    3,    3,    5,    5,    7,    5,    7,
    3,    3,    5,    7,    1,    1,    3,    5,    1,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    4,
    4,    4,    4,    4,    4,    4,    4,    6,    4,    4,
    4,    1,    4,    4,    4,    4,    6,    6,    6,    6,
    1,    1,    4,    4,    6,    6,    4,    4,    4,    4,
    8,    6,    6,    6,    4,    4,    1,    1,    1,    6,
    6,    6,    6,    4,    4,    4,    4,    4,    4,    5,
    3,    3,    3,    3,    3,    3,    3,    3,    2,    3,
    2,    1,    1,    4,    3,    4,    6,    8,    5,    7,
    3,    5,    3,    3,    3,    3,    3,    3,    4,    4,
    4,    4,    4,    4,    4,    6,    4,    4,    4,    1,
    4,    4,    4,    4,    6,    3,    3,    3,    3,    3,
    3,    3,    3,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    4,    4,    6,    4,    8,
   14,    4,    4,    4,    8,    6,    6,    6,    4,    4,
    1,    1,    1,    6,    4,    4,    4,    4,    4,    4,
    5,    3,    3,    3,    3,    3,    3,    3,    3,    2,
    3,    2,
};
short yydefred[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  722,
  723,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  714,  715,  716,  717,  718,  719,  720,  721,    0,
    0,    0,    0,  367,  368,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  136,    0,
    0,  490,    0,    0,    0,   44,  491,   94,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  492,
  493,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  134,  135,    0,    0,   37,
    0,    0,  485,  487,  486,  489,  488,    0,    0,  472,
    0,    0,    0,    0,   41,    0,    0,   63,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  558,  560,    0,
  365,  559,  561,  562,  563,  564,  565,  566,    0,  366,
  369,  370,    0,    0,    0,    0,    0,  672,  673,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  361,   13,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   65,  510,  509,   60,   66,    0,    0,    0,    0,
  109,  107,  108,    0,    0,    0,    0,    0,    0,  482,
  481,  374,  371,   62,    0,  303,  302,  304,  305,  282,
  283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
  293,  294,  295,  296,  297,  298,  299,  300,  301,    0,
    0,    0,    0,    0,    0,    0,    0,  700,    0,    0,
    0,    0,    0,  724,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  741,  742,  743,
    0,  725,    0,    0,    0,    0,    0,  153,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  143,   39,  140,
  170,  139,  182,  154,    0,   52,    0,    0,    0,    0,
    0,    0,    0,    0,   17,    0,    0,    0,   40,  115,
  114,  111,  113,  112,  514,  515,  516,  517,  518,  520,
  519,  521,  522,  523,  524,  525,  526,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  118,   61,    0,    0,    0,    0,    0,
    0,  253,   67,    0,    0,    0,    0,    0,    0,  473,
    0,    0,    0,  260,    0,  475,  474,    0,  364,    0,
    0,    0,    0,   92,   93,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  231,    0,    0,  181,    0,    0,    0,    0,
    0,  171,   54,   53,    0,    0,    0,  110,    0,    0,
    0,  547,  550,    0,    0,  549,  551,  548,  546,   57,
   56,    0,   28,   27,   26,   25,   24,   23,   21,   22,
    0,    0,    0,   68,    0,    0,  119,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   29,  133,    0,
    0,    0,    0,    0,    0,   64,    0,  494,  495,  116,
    0,  137,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  185,  225,    0,    0,    0,    0,    0,    0,
  220,    0,    0,    0,    0,  117,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   69,
    0,   70,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  372,  373,    0,   46,   48,   47,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  167,    0,    0,    0,    0,    0,    0,  157,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    5,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    6,    0,    2,    3,
    4,    0,    0,    8,  479,    0,    0,    0,  478,    0,
  331,  476,  477,    0,    0,  480,    0,    0,    0,    0,
  330,    0,  329,   10,    7,    0,    0,    9,   11,   12,
    0,    0,    0,    0,  385,  360,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   75,
    0,   38,    0,  375,  378,  380,  377,  376,   42,  123,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  149,    0,  498,    0,  150,    0,  147,  148,  553,  552,
  146,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  204,    0,  206,  202,  203,    0,
    0,    0,    0,  257,  258,  255,  256,  254,    0,    0,
  264,    0,    0,    0,    0,    0,  269,  265,  261,    0,
  310,  316,  311,  317,  307,  308,  309,  314,  318,  312,
  313,  306,  315,  266,  706,  707,  708,  709,  710,  711,
  712,  713,    0,    0,  363,   18,    0,    0,    0,   90,
   91,    0,    0,    0,    0,  237,    0,  251,  248,  235,
  233,  236,  249,  250,  232,    0,  234,    0,    0,    0,
    0,    0,  178,  177,  176,  175,  174,    0,   59,    0,
    0,    0,    0,    0,   58,  320,  321,  319,  322,   45,
    0,    0,   14,   20,  120,  121,    0,  126,  124,    0,
    0,   31,    0,   32,   33,  325,  326,  323,  324,  327,
  328,   30,    0,    0,    0,   77,   73,    0,    0,    0,
  575,  681,    0,    0,  556,  557,    0,    0,    0,  190,
  195,  192,  193,  189,  188,  191,    0,  228,  226,  229,
  227,    0,    0,    0,    0,    0,    0,  196,  223,  221,
  224,  222,    0,  279,  276,  278,  277,  280,  275,  217,
  216,  219,  218,    0,  142,  169,  184,  156,    0,    0,
    0,    0,    0,  127,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  163,    0,    0,  164,  161,  162,
  160,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  761,  670,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  358,    0,    0,    0,    0,    0,  483,  484,    0,  346,
    0,  335,    0,  334,  349,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  332,    0,  345,    0,    0,    0,
    0,    0,  466,  384,    0,  455,    0,    0,    0,    0,
    0,    0,  383,    0,    0,    0,    0,  513,    0,    0,
  511,    0,    0,    0,    0,    0,    0,  512,    0,    0,
    0,    0,  388,  399,    0,  386,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  421,    0,
  419,    0,  611,  690,  612,  692,  614,  694,  616,    0,
    0,  697,  619,  698,  620,  701,  623,  702,  624,  703,
  625,  704,  626,    0,    0,  105,  726,  633,  727,  634,
    0,    0,    0,    0,    0,  732,  638,  733,  639,  734,
  640,    0,    0,    0,    0,    0,    0,    0,    0,  739,
  645,  740,  646,    0,    0,  745,  654,  747,  656,  748,
  657,  749,  658,    0,   95,  379,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  151,  152,    0,  675,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   84,  205,  207,
  208,    0,    0,  259,  274,  262,  263,  267,    0,    0,
  273,    0,  268,    0,    0,    0,    0,    0,    0,  230,
    0,    0,    0,  241,    0,  238,    0,  242,  243,  247,
  252,    0,  179,  180,    0,   36,    0,    0,   86,    0,
    0,   15,  122,  125,    0,    0,    0,    0,    0,   71,
    0,    0,    0,    0,    0,    0,  554,  555,   83,    0,
  194,    0,    0,    0,  199,  197,  200,    0,  281,    0,
    0,    0,  130,    0,    0,    0,    0,    0,  165,  166,
    0,  691,  613,  693,  615,  695,  617,  699,  621,  746,
  655,  750,  659,    0,    0,    0,    0,  350,  353,  352,
    0,    0,  354,  503,  500,  501,  502,  499,  351,  347,
  348,  338,  340,    0,  337,  344,  343,    0,  341,    0,
    0,    0,  467,  468,  469,    0,  464,  463,  506,  505,
  504,  461,  457,  456,  465,  458,  459,    0,  400,    0,
    0,  395,  404,  398,  405,    0,    0,    0,    0,    0,
    0,  389,    0,    0,    0,    0,    0,    0,  390,    0,
    0,  414,  401,  417,  415,  416,    0,  387,  436,  427,
    0,  452,  451,  426,  425,  449,  437,  429,  431,  430,
  453,  433,  434,  432,  435,  440,  424,  428,  544,  545,
  543,  441,  438,  439,    0,    0,    0,    0,  422,  423,
  448,    0,  420,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   76,  689,    0,    0,  729,
    0,    0,    0,  674,    0,  676,    0,    0,    0,  270,
    0,    0,    0,   78,   74,    0,    0,    0,  576,    0,
    0,  128,    0,  239,  240,    0,    0,    0,    0,    0,
    0,    0,    0,   81,    0,  577,    0,    0,    0,  508,
  507,  682,  679,    0,    0,    0,  198,  201,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  356,  355,    0,    0,    0,  462,    0,  406,  412,  410,
  408,  402,  407,  413,  411,  409,  403,    0,  450,  445,
  444,  447,  446,  454,  696,  618,    0,  628,  629,  627,
    0,  636,    0,    0,    0,    0,  736,  642,  737,  643,
  738,  644,    0,  651,  652,  650,    0,    0,    0,    0,
    0,    0,    0,    0,  104,  271,    0,    0,   72,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   97,
    0,    0,    0,   51,    0,    0,  132,    0,    0,    0,
    0,    0,    0,    0,   98,   99,  460,    0,    0,    0,
    0,  705,  728,  744,    0,  677,    0,    0,    0,   82,
    0,  578,    0,    0,  680,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   55,    0,    0,    0,
  730,    0,  735,  641,    0,    0,   43,   85,    0,    0,
  102,    0,   87,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  678,    0,    0,    0,    0,    0,    0,    0,
    0,  103,    0,  100,  101,    0,    0,    0,    0,    0,
    0,  731,    0,    0,    0,    0,
};
short yydgoto[] = {                                     171,
 1028,  683,  174,  175,  176,  327,  242, 1061,  225,  771,
  384, 1114, 1452, 1392, 1369,  461,  472,  178,  912,  834,
  179,  180,  181,  642,  765,  500,  270,  182,  183, 1533,
  890,  927, 1319,  184,  185,  186,  643,  187,  656,  188,
  243, 1115, 1140, 1093, 1084, 1116, 1141,
};
short yysindex[] = {                                   5738,
    9,   56,  107,  109,  111,  148,  166,  194,    0,    0,
    0,  206,  262,  264,  266,  271,    0,  272,  274,  283,
  288,  309,  325,  349,  353,  371,  409,  427,  430,  432,
  437,  438,    0,    0,    0,  442,    0,  444,  448,  451,
  452,    0,    0,    0,    0,    0,    0,    0,    0, -609,
 -370, -370, -358,    0,    0, -173,   12, -483,  872, -370,
  147, 5416, 6790,  160, -194, -101,  -96, -355,    0,  138,
  -95,    0,  519, 9213,  218,    0,    0,    0,  -22, 8846,
 -370,   14,  222, 2065, 1641,  211,  546,   33,  548,    0,
    0,  -49, 6140, 7115,  -31,  -27, -417,  -18, -208, -322,
 9213,  -82,   75,  810,  198,    0,    0,  277,12995,    0,
  590,  -15,    0,    0,    0,    0,    0,  287,  -33,    0,
   -7,  133,  -62, -529,    0, 6465, -267,    0, 9213,  113,
  462, 5416,  542, 8587, -216, 8671,  -24,    0,    0,  872,
    0,    0,    0,    0,    0,    0,    0,    0,  872,    0,
    0,    0,  625, -208, -208, -208,  247,    0,    0, 9268,
 9268, 7440,  642,  643,  654,  659,  660,  662,  663, 9268,
    0, 1664, 1319,  691,  694,  696,  346,  698,13199,  699,
  700,  687,  707,  754,  774,  782,  -32,    0,    0, 9268,
 9268, 9268, 9268, 9268, 9268, 9268, 9268, 9268, 9268, 9268,
 9268, 9672, 9268, 9268,  156,  161,  162, 9268, 9268, 9268,
 9268, 9268, 9268, 9268, 9268, 9268, 9268, 9268, 9268, 9268,
 9268,    0,    0,    0,    0,    0,  758,  170,  761, -208,
    0,    0,    0,  308,  173,  177, -208,  179,  180,    0,
    0,    0,    0,    0,  183,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  479,
  784,  787,  791,  797,  798,  799,  802,    0,  803,  804,
  806,  814,  815,    0,  816,  817,  818,  819,  820,  821,
  822,  823,  825,  826,  833,  835,  851,    0,    0,    0,
  852,    0,  860,  865,  868,  869,  190,    0,   13,  834,
  293,  297, -438,  864,  893,  790, 9213, 9213,  875,  900,
  901,  909,  920,  921, 9213, 1247,  881,    0,    0,    0,
    0,    0,    0,    0,  922,    0,  938,  453,  482,  350,
 -501,  351,  352,  486,    0,  491,  834, 1551,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  647,  358, -208,  369,  370,
  372,    0,    0,  492, -352,  506, -141, -370, -208,    0,
  509, 2217, -146,    0,  513,    0,    0,  -32,    0,  379,
  517,  391,  531,    0,    0,  536,  537,  805,  538,  416,
  417,  418,  419,  428,  431,  433, -438,  435,  436, 9213,
 9213, 2962,    0, -503,  445,    0,  834,  446,  449, -438,
 3431,    0,    0,    0, -208,  553,  450,    0, 1025,  557,
 3440,    0,    0,  454,   64,    0,    0,    0,    0,    0,
    0, 9213,    0,    0,    0,    0,    0,    0,    0,    0,
  755,  732,  456,    0,  748,  -59,    0,  756,  -47,  595,
  464, 9213,  469,  470, -412, 9213,  772,    0,    0,  473,
  475,  104, 9213, -207,  485,    0, -116,    0,    0,    0,
 9213,    0,  609,  477,  757,  487,  834,  488,  489, -438,
  490, 3472,    0,    0,  494,  499,  507,  511, 4222,  559,
    0,  515,  518,  521,  522,    0,  587,  523, -208,  525,
  530, -438,  539,  540,  541,  551,  558, 4364,  570,    0,
  573,    0,  574,  578, 9213, 9213, 9213, 9213, 5272,  781,
 -285, 9213,    0,    0,  645,    0,    0,    0, 9268, 9213,
 1112, 1135, 1172,  790, 1113, 1156,  881, 1113, 1156,  582,
    0,   96,  834,  583,  584, -438, 5648,    0, 9268, 9268,
 9268, 9268, 9268, 9268,  722, 3143,   78, 9213, 9213, 9213,
 9213, 9213, 9213, 9213, 9213, 9268, 9268, 9268, 9268, 9213,
 9268,    0, 9213, 9268, 9268, 9268, 9268, 9268, 9268, 9268,
 9268, 9268, 9268, 9268, 9268, 9268,    0, 9268,    0,    0,
    0, 9268, 9213,    0,    0,  882,  143, -336,    0, 8846,
    0,    0,    0, 9213,  596,    0,  605, 7765, 5416, 9213,
    0,  606,    0,    0,    0,  726,  746,    0,    0,    0,
  280,  602,12977,12989,    0,    0, 5197, 3339, 5687, 3570,
 5809, 3654, 5849, 7732, 6157, 4080, 5899,11434, 6215,11774,
 6260,11839, 6466,11917, 6527,11926, 6540,12042, 6552, 6867,
  191, 6564,12065, 6588,12090, 6605, 6944, 1210, 1215, 1216,
 6828,12145, 6852,12264, 6882,12274, 6617,12167, 6891,12416,
 6927,12700, 6936,12710, 7177,12297, 7232,12306, 7254,12722,
 7265,12314, 7749,12329, 7766,12338, 7790,12362,  751,    0,
  622,    0,  623,    0,    0,    0,    0,    0,    0,    0,
 9213, 9213, 9213, 9213, 9213, 9213, 9213, 9213, 9213, 9213,
 9213, 9213, 9213, 9213, 9213,  624, 9213, 9213, 9213, 9213,
 9213, 9213, 9213, 9213, 9213, 9213, 9213, 9213, 9213, 9213,
    0,  627,    0,  628,    0,  -10,    0,    0,    0,    0,
    0,  772,  661, 9213, 1113, 1113, 9213, 9213, 9213, 9213,
 9213, 9213, 7809, 9213, 9213, 9213, 9213, 9213, 9213, 9213,
  629,  766,  767,  632,    0,  633,    0,    0,    0,  634,
 1220, 9213,  635,    0,    0,    0,    0,    0,  636, -282,
    0,  637, 8846,  638,  640, 9213,    0,    0,    0,  641,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  400,  644,    0,    0, 1237, 1241, 1243,    0,
    0,  656,   94,  657,  664,    0,  665,    0,    0,    0,
    0,    0,    0,    0,    0,  949,    0,11898,11898, 9213,
  666,  667,    0,    0,    0,    0,    0, 9213,    0,  910,
 1257,  808,  813, 9213,    0,    0,    0,    0,    0,    0,
 8077,  969,    0,    0,    0,    0,  978,    0,    0,  980,
 1281,    0, 8086,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 8402, 1265, 1283,    0,    0,  984, 8536, 1284,
    0,    0, 1270,  399,    0,    0, -286, 8559,  693,    0,
    0,    0,    0,    0,    0,    0, 9213,    0,    0,    0,
    0, 9213,  827,  695,  701,  704, 1293,    0,    0,    0,
    0,    0,  706,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 9213,    0,    0,    0,    0,11898,11898,
11898,11898, 9213,    0,  994,  995, 8623, 1302,11909, 2938,
 5701, 9268,  273,  661,    0,  715,  718,    0,    0,    0,
    0, 9213, 8263,12394, 8651,12402, 8699,12431, 8710,12534,
 8995,12542, 9037,12551, 1314,    0,    0, 1507,  205,  841,
  841,  841,  841,  841,  841,  778,   11,  778,   11,  242,
  426,  242,  426,  516,  242,  426, 8727,11909,10245,  405,
  564,  564,  564,  564,  564,  564,  778,   11,  778,   11,
  377,  426,  377,  426,  377,  426, 6048,11909, 2938, 9049,
    0,  720,  721,  724,  178, -150,    0,    0, -334,    0,
  730,    0,11898,    0,    0, -370,  733, 9213,  734,  735,
  736, 9213,  737,11898,    0, 9082,    0, 1327, 1334,  740,
  741,  744,    0,    0,  878,    0,  747,  749, -249, -377,
  750, -288,    0, -208, 9213, 9213, -208,    0,  752,  759,
    0,  760, 7937, 8262, 9213, 9213, -150,    0,  769,  770,
 -278, 1341,    0,    0,12977,    0,  771, 1043,  884,  773,
  775,12256,  776, -249, -154,  777, -301, -150,  783, 1048,
 -303,  785,  786, 8726, 9130, -277,  788, 1349,    0,12989,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 9213,
 9268,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 9268, 9268,    0,    0,    0,    0,    0,
  800,  801,    0,  812,  824,    0,    0,    0,    0,    0,
    0, 9213, 9213, 9213, 9268, 9213, 9268, 9213, 9268,    0,
    0,    0,    0, 9268, 9268,    0,    0,    0,    0,    0,
    0,    0,    0,  828,    0,    0, 9191, 9237, 9537, 9550,
 9562, 9701, 9710, 9760, 9779, 9941, 9950, 9626, 9964, 9973,
 9986, 1353,10000,10009,10023,10032,10045,10062,10077,10105,
10183,10192,10219,10238,10322,10334,    0,    0, 1350,    0,
  -30,10346,10400,10409,10423,10432,10446,10455,  840,  840,
  516,  516,  516,10272,10468, 1351,  866,    0,    0,    0,
    0,  829,11898,    0,    0,    0,    0,    0, 8846, 1362,
    0,10485,    0,  830,  831,  104, 9213, -120,  772,    0,
 9213,  836,  914,    0, -334,    0,  837,    0,    0,    0,
    0,11898,    0,    0,10508,    0, 9213,  886,    0,11898,
 9213,    0,    0,    0,  838, 9213, 9213, 9213,  839,    0,
 9213,  918, 9213, 9268, -260, 9213,    0,    0,    0, 9213,
    0,11898,10691,  842,    0,    0,    0,  843,    0,10718,
10727, 1041,    0, 9213, 9213, 1368, 1395,  -30,    0,    0,
10750,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 9213, 9213, 9268, 1386,    0,    0,    0,
  844,  845,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,11898,    0,    0,    0,11898,    0, 9213,
  846,  847,    0,    0,    0,  848,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1405,    0,11898,
11898,    0,    0,    0,    0,  849, -208,  854,  858,  862,
11898,    0,  873, -208,  874,  876,  877,11898,    0,11898,
11898,    0,    0,    0,    0,    0, 9213,    0,    0,    0,
  879,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, -264,11898, -262,11898,    0,    0,
    0, 1108,    0,10496,12559,10759,12568,10805,12576, 1412,
 1420, 1418, 1421,10858,10890,10964,12601,11120,12609,11129,
12633,11143,12657,11152,12676,    0,    0, 9213,  880,    0,
 9213,  772, 9213,    0, 9213,    0,  883, 1082, 1432,    0,
  885, 9213, 1430,    0,    0, 1146,11165, 1445,    0,  572,
11182,    0, 1455,    0,    0, 9213,11197, 1115,11898, 1467,
11206,11898,11898,    0,11898,    0,11898,11909, 2938,    0,
    0,    0,    0,11219,11230,  888,    0,    0, 9213, 9213,
 1167,11252,11264, 9213,  772, 9213,11371,11898, 2938, 9213,
    0,    0,11898, 1473, 1479,    0,  889,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,11898,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  895,  897, 9213, 9213,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,11380, 1480,11394,  -19,
11417,11426, 1493, 1477,    0,    0,11898,  899,    0, 9213,
 1039, 9268, -200, 9213, 9213,  904,11449, 9213, 1502,    0,
 9213, 1478, 9213,    0,11479,11502,    0, 1212, 9213,11898,
  -19,11519, 9213,11898,    0,    0,    0, 1521, 1520,11534,
11557,    0,    0,    0, 9213,    0, 9213,  926, 1063,    0,
11898,    0,11909, 2938,    0,11579,11590, 1527, 9213,11898,
 1066,11601, 9213,11612, 9213, 9213,    0,11623, 9213,11634,
    0,  932,    0,    0,11645,11898,    0,    0, 1512,  936,
    0,11898,    0, 9213,11898, 9213,11898,11898,  937,11898,
  939, 1533,    0, 9213, 1538,11898,11656, 1539, 1540,  944,
11898,    0, 9213,    0,    0, 1541,11688,  945, 9213, 1548,
11876,    0, 9213,11885, 9213,11898,
};
short yyrindex[] = {                                   1590,
    0,    0,    0,    0,    0,    0,    0,    0,    7,    0,
    0,    0,    0,    0,    0,    0,   45,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   70,  311,  334,    0,  357,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1581,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1582,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,13237,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 2817,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 3098,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1587,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1592,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1602,    0,    0,
    0,    0,    0,    0,    0, 1607, 1608,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1509,    0,    0,    0,    0,    0, 1611,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1613,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1615,    0,
 1616,    0, 1617, 1618,    0,    0,    0,    0,    0,    0,
 1621,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1036, 1488, 2553, 1076, 1516, 2624,    0,
    0,    0, 1622,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1623,    0, 1625,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1413, 1562,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,13244,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1626, 1637,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1639,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 2331,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 3320,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1640, 1642,
 1643, 1644,    0,    0,    0,    0,    0,    0, 1647, 1648,
    0,    0,    0,    0,    0, 1623, 1625,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 4708, 3714, 3856,
 3998, 4140, 4282, 4424, 4566,  124,  789, 2926, 2952, 1360,
 1158, 2712, 2227, 1829, 2751, 2376,    0,  459,   -1,   15,
   88,  132,  276,  306,  322,  329, 3195, 3265, 3276, 3331,
 2809, 2906, 3003, 3024, 3044, 3062,    0, 1649, 1651,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1652,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1653,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1655,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1658,
    0,  380,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  996,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 2646, 2898,
 1978, 2245, 2394,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1659,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1662,    0,    0,    0,    0,    0,    0,    0, 1663,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1666,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1676,    0,    0,    0, 3167,    0, 2480,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 3179,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1678,    0,    0,    0, 1679,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 5102,
 5138,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 5171,    0,    0,    0,    0,    0,    0, 5210,    0, 5318,
 5352,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 4893,    0, 4975,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 3378,
    0,    0,    0,    0,    0,    0,    0,    0, 1680,    0,
    0, 1681, 1682,    0, 1683,    0, 1688, 1689, 1690,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 4850,  753,    0,
    0,    0, 1692,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 5426,    0,    0,
    0,    0,    0,    0,    0,    0, 1100,    0,    0,    0,
 1130,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1401,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1693,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 3213,    0,    0,    0,    0,    0,    0,    0, 1695,
 2490,    0,    0, 1698,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1702,    0, 1703, 1705,    0,    0,    0,    0,    0, 1715,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1718,    0,    0, 3237,    0,
    0, 1719,    0,    0, 1721,    0, 1723, 1724,    0, 1725,
    0,    0,    0,    0,    0, 1726,    0,    0,    0,    0,
 1727,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1728,
};
short yygindex[] = {                                      0,
    1,  315,    0,    0,    0,   63,  714, -832,  -52, -401,
 -585,    0,    0,  527,-1031,    0, 1268,    0,    0,    0,
    0,    0,    0,    0, 1168, -474,  -99,    0,    0,  137,
    0,    0,    0,    0,    0,    0,    0, 1667, 1343, 1668,
   89,    0,    0,    0,    0,  639,  615,
};
#define YYTABLESIZE 13815
short yytable[] = {                                     226,
  172,  897,  871,  223,  900, 1449,  906,  244,  668,  479,
  796, 1057,  495, 1057,  501, 1315,  622,  918,  189,  231,
 1287,  223, 1530, 1531,  667,  865, 1613,  494,  385,  222,
  487,  227,  526,  872,  337, 1396, 1317,  445,  877,  668,
 1442, 1266,  668,  700, 1062, 1425, 1459,  622,  622,  622,
  622,  622,  614,  622,  631,  667,  668,  615,  667, 1570,
 1493, 1572,  177,  326,  622,  232, 1532,  449,  446,  622,
 1318, 1645,  667,  618,  348, 1422,  514,  907, 1393,  647,
  515,  724, 1530, 1531, 1394,  631,  631,  631,  631,  631,
  975,  631, 1389,  432,  441,  190, 1446,  661,  233,  976,
  622,  451,  631,  769,  616,  770,  741,  631,  935,  502,
  647,  647,  647,  647,  647,  516,  647, 1443, 1007,  614,
  612,  539,  613, 1058,  615, 1058,  512,  647,  661,  519,
  958,  661,  647,  589,  538,  873,  549,  797,  631, 1450,
  618,  662, 1451,  330,  228,  661,  191,  338,  192, 1444,
  193,  835,  836,  837,  838,  839,  840,  841,  842,  517,
  565,  568,  577,  647,  589,  224,  590,  589,  590, 1390,
  586,  616,  662,  540,  991,  662,  908,  909,  910,  911,
  450,  589,  920,  224,  810, 1364, 1365,  194, 1445,  662,
  657,  659,  661,  663,  665,  667,  669,  671,  673,  675,
  677,  679,  682,  684,  686,  195, 1059,  541,  691,  693,
  695,  697,  699,  701,  703,  705,  707,  709,  711,  713,
  715,  717,  567,  567, 1397,  452, 1370, 1269,  553,  331,
 1267, 1166,  567,  196, 1426, 1460,  984,  554,  518,  240,
 1391,  600,  241,  813, 1438,  197,  786,  784, 1571,  785,
 1573,  787,  567,  567,  567,  567,  567,  567,  567,  567,
  567,  567,  567,  567,  567,  567,  567,  603, 1366, 1508,
  567,  567,  567,  567,  567,  567,  567,  567,  567,  567,
  567,  567,  567,  567,  896,  663,  542,  835,  836,  837,
  838,  839,  840,  841,  842,  921,  899,  498,  788,  651,
  498,  198, 1060,  199,  603,  200,  240,  559,  543,  241,
  201,  202,  498,  203,  173,  664,  663,  775,  776,  663,
  648,  332,  204,  350,  453,  783,  454,  205,  490,  814,
  333,  665,  481,  663,  455,  601,  456,  560,  666, 1367,
  414,  415,  811,  649,  386,  818,  664,  742,  206,  664,
 1398,  648,  648,  648,  648,  648,  843,  648, 1439,  351,
  762,  387,  665,  664,  207,  665,  632,  352,  648,  666,
  743,  457,  666,  648,  649,  649,  649,  649,  649,  665,
  649,  550, 1509,  652, 1368, 1440,  666,  491,  208,  610,
  388,  649,  209,  725,  492,  815,  649,  632,  632,  632,
  632,  632,  499,  632,  648,  499,  622,  458,  482,  483,
  210,  484,  816,  600,  632,  240,  689,  499,  241,  632,
  610,  610,  610,  610,  610,  240,  610,  649,  241,  925,
  868,  869,  240,  493,  544,  241,  623,  610,  389,  603,
  390, 1057,  610,  986, 1315, 1279,  614,  612,  211,  613,
  632,  615, 1514,  416,  417,  459,  334,  763,  926, 1314,
 1278,  240,  891,  498,  241,  229,  212,  618,  589,  213,
  601,  214,  764,  610,  566,  569,  215,  216,  551,  353,
  339,  217,  903,  218,  587,  340,  913,  219,  618, 1316,
  220,  221, 1239,  919,  245,  230,  653,  654,  616,  589,
  552,  928,  589,  329,  658,  660,  662,  664,  666,  668,
  670,  672,  674,  676,  678,  680,  589,  685,  687,  616,
  341,  485,  692,  694,  696,  698,  700,  702,  704,  706,
  708,  710,  712,  714,  716,  718, 1435,  335,  486, 1075,
  763,  240,  336,  345,  241,  969,  970,  971,  972,  914,
  391,  240,  977, 1058,  241,  987,  460,  924,  346,  979,
  981,  349,  342, 1052,  343,  393,  410, 1053,  499, 1054,
  835,  836,  837,  838,  839,  840,  841,  842,  603,  993,
  995,  997,  999, 1001, 1003,  411,  412,  413, 1008, 1009,
 1010, 1011, 1012, 1013, 1014, 1015, 1016, 1018, 1020, 1022,
 1024, 1025, 1361, 1027, 1362,  614,  612,  443,  613,  788,
  615,  444, 1037, 1039, 1041, 1043, 1045, 1613,  462,  447,
  474,  567, 1048, 1050,  473,  240,  618, 1080,  241,  480,
  489,  496, 1612, 1055, 1063,  497, 1285,  520, 1074,  668,
 1076,  567,  567,  567,  567,  567,  567,  622,  622,  622,
  622,  622,  622,  622,  622,  667,  667,  616,  567,  567,
  567,  567, 1614,  567,  555,  344,  567,  567,  567,  567,
  567,  567,  567,  567,  567,  567,  567,  567,  567, 1056,
  567,  579,  580, 1500,  567,  631,  631,  631,  631,  631,
  631,  631,  631,  581,  886,  887,  888,  889,  582,  583,
  619,  584,  585,  620, 1081,  621, 1082,  624,  644,  645,
  647,  647,  647,  647,  647,  647,  647,  647,  604,  605,
  606,  607,  608,  609,  610,  611,  646,  240,  661,  661,
  241, 1207, 1208, 1209, 1210, 1211, 1212, 1213, 1214, 1215,
 1216, 1217, 1218, 1219, 1220, 1221,  647, 1223, 1224, 1225,
 1226, 1227, 1228, 1229, 1230, 1231, 1232, 1233, 1234, 1235,
 1236, 1274,  660,  648,  590,  590,  590,  590,  590,  590,
  590,  590,  662,  662, 1242, 1337,  328, 1243, 1244, 1245,
 1246, 1247, 1248,  649, 1249, 1250, 1251, 1252, 1253, 1254,
 1255,  650,  354,  660,  688,  392,  660,  404,  592,  689,
  690, 1506, 1263,  719,  721,  521,  433,  442,  720,  522,
  660,  724,  448,  723,  600,  725, 1272,  727,  728,  598,
 1275,  729,  730,  731,  599,  488,  732, 1276,  761,  592,
  733,  592,  592,  592, 1240, 1241,  734,  735,  736,  513,
  603,  737,  738,  739,  523,  740,  592,  590,  591,  592,
  593,  594,  595,  741,  742,  743,  744,  745,  746,  747,
  748,  749,  750,  527,  751,  752, 1277,  556,  557,  558,
 1292,  601,  753,  980,  754,  578,  600,  600, 1295,  766,
  774,  786,  786,  784, 1300,  785,  787,  787,  524,  528,
  755,  756,  641,  994,  996,  998, 1000, 1002, 1004,  757,
  655,  943,  603,  603,  758,  922,  944,  759,  760,  772,
 1017, 1019, 1021, 1023,  777, 1026,  663,  663, 1029, 1030,
 1031, 1032, 1033, 1034, 1035, 1036, 1038, 1040, 1042, 1044,
 1046,  767, 1047,  788,  788,  768, 1049, 1322,  773,  778,
  779,  945, 1323,  722, 1085, 1086,  664,  664,  780, 1087,
  726,  648,  648,  648,  648,  648,  648,  648,  648,  781,
  782,  529,  665,  665, 1330,  791,  530,  525,  531,  666,
  666,  790,  532, 1331,  649,  649,  649,  649,  649,  649,
  649,  649,  682,  792, 1088,  946,  793,  794,  795,  798,
  799,  800, 1341,  801,  803,  809,  804,  632,  632,  632,
  632,  632,  632,  632,  632,  637,  240,  806,  807,  241,
  808,  812,  923, 1372,  820, 1089,  844,  846, 1090,  847,
  610,  610,  610,  610,  610,  610,  610,  610, 1091,  848,
  138,  139,  729,  849,  850,  851,  637,  637,  637,  637,
  637,  533,  637,  857,  567,  585, 1338,  606,  607,  608,
  609,  610,  611,  637,  858,  859,  860,  861,  637,  142,
  143,  144,  145,  146,  147,  148,  862, 1092, 1374,  863,
  882,  864, 1378,  866,  867,  893,  585,  585,  585,  585,
  585,  922,  585,  874,  875,  586,  880,  876,  881,  637,
  883,  895,  885,  585,  894, 1400, 1401,  901,  585,  898,
  931,  805,  902, 1411, 1418, 1420, 1421,  904,  905,  630,
  817,  915,  819,  916,  929,  930,  586,  586,  586,  586,
  586,  655,  586,  953,  974,  932,  933,  934,  936,  585,
  463,  856,  938,  586, 1456, 1458,  705,  939,  586,  635,
  630,  630,  630,  630,  630,  940,  630,  978,  464,  941,
 1464,  982,  852,  949,  465,  466,  950,  630,  879,  951,
  952,  954,  630,  956, 1466, 1468,  728,  600,  957,  586,
  635,  635,  635,  635,  635,  603,  635,  959,  960,  961,
  983,  853, 1474, 1475, 1476,  463, 1478,  635, 1480,  962,
  467,  468,  635,  630, 1482, 1484,  963,  947,  600,  600,
  600,  600,  600,  464,  600,  917,  138,  139,  965,  465,
  466,  966,  967,  567,  234,  600,  968,  984,  618,  235,
  985,  989,  990,  635, 1005, 1051,  567,  567, 1078,  854,
  469,  855,  470,  948, 1064,  142,  143,  144,  145,  146,
  147,  148,  955, 1065, 1077,  467,  468,  567, 1079,  567,
 1173,  567,  240, 1204,  236,  241,  567,  567, 1174, 1175,
 1205, 1206, 1222, 1262,  237, 1237, 1238, 1256, 1257, 1258,
 1259, 1260, 1261, 1264, 1265, 1268, 1270, 1507, 1271, 1273,
 1281, 1511, 1280,  600, 1282,  469, 1283,  470,  786,  784,
  789,  785, 1291,  787, 1284, 1288,  238, 1517,  239, 1296,
 1297, 1519, 1289, 1290, 1293, 1294, 1521, 1522, 1523,  603,
 1298, 1525, 1302, 1527, 1528, 1299, 1534,  138,  139,  240,
 1535, 1303,  241, 1304, 1305, 1308, 1309, 1310,  617, 1312,
 1313, 1321, 1324, 1325, 1542, 1543, 1328, 1332, 1333, 1326,
  788, 1510, 1327,  471, 1329, 1335,  142,  143,  144,  145,
  146,  147,  148, 1339, 1547, 1548, 1340, 1354, 1358, 1359,
  614,  612, 1360,  613, 1083,  615, 1113, 1139, 1371,  589,
 1381, 1373, 1375, 1376, 1377, 1379,  567, 1382, 1383, 1384,
 1553,  618, 1385, 1386, 1427, 1387, 1430, 1388, 1395, 1431,
 1403, 1448, 1462, 1490, 1497, 1492,  685, 1404, 1405, 1498,
  589,  598,  598,  589,  598, 1501,  598, 1423, 1424, 1429,
  653, 1432,  616, 1433, 1436, 1441, 1513,  589,  567, 1518,
 1526, 1447,  762, 1453, 1454, 1541, 1461, 1568, 1544,  592,
  592,  592,  592,  592,  592,  592,  592,  744, 1470, 1471,
 1545,  653,  653,  653,  653,  653, 1550,  653, 1557,  762,
 1472, 1574, 1581,  762,  762,  762,  762,  762,  653,  762,
 1582, 1583, 1473,  653, 1584, 1465, 1486, 1499, 1503, 1504,
  762, 1604, 1605, 1608, 1512, 1515, 1520, 1524, 1467, 1469,
 1537, 1538, 1551, 1552, 1554, 1555, 1556, 1558, 1597, 1609,
 1611, 1599, 1560, 1601,  653, 1602, 1561,  589, 1616, 1477,
 1562, 1479, 1607, 1481, 1619,  762,  762, 1620, 1483, 1485,
 1627, 1563, 1565, 1635, 1566, 1567, 1617, 1569, 1598, 1636,
 1643, 1603, 1649, 1606,  762,  589, 1624, 1637,  589,  762,
  762,  589,  762, 1638,  762, 1639, 1648, 1650, 1663, 1625,
 1626, 1652, 1658,  600, 1630,  589, 1632, 1661,  786,  784,
 1634,  785,  760,  787, 1600, 1667,  589,  760,  760,  589,
  760, 1671,  760, 1672, 1677, 1678, 1286, 1681, 1683,  603,
 1692,  760, 1694,  589, 1695, 1698, 1700, 1699, 1702, 1704,
 1705,  762, 1706, 1710, 1708, 1640, 1641,  600, 1712,    1,
  106,   19,  786,  784,  802,  785,  359,  787,  760,  562,
  788,  144,  760,  760,  760,  760,  760, 1631,  760,  760,
 1651,  362, 1653,  603, 1656, 1657,   88,   89, 1660,  760,
  172, 1662,  186, 1664,  141,  168,  183,  155, 1529, 1668,
  129,  158,  497, 1670,  496,  245,  637,  637,  637,  637,
  637,  637,  637,  637,  788, 1675,  246, 1676,   16,  211,
 1437,  210,  213,  212,  760,  760,  581,  573,  582, 1682,
  574,  333,  336, 1685,  381, 1687, 1688,  382,   49, 1690,
 1549,  244,   50,  602,  567,  187,  585,  585,  585,  585,
  585,  585,  585,  585, 1696,  131, 1697,  342,  339,  214,
   35,  572,   79,  762, 1701,  762,  762,  570,  583,  579,
  600,  357,  272, 1707,  567,  598,  596,  568,  597, 1711,
  599,   80,  584, 1714,  580, 1716,  586,  586,  586,  586,
  586,  586,  586,  586,   96,  762,  603,  145,  173,  762,
  569,  762,  215,  209,  159,   34,  571,  138,  892,  988,
  630,  630,  630,  630,  630,  630,  630,  630,  762, 1655,
  845,  408,  409, 1428, 1463,  762,    0,  601,    0,    0,
  762,    0,    0,    0,    0,    0,  762,    0, 1363,    0,
  635,  635,  635,  635,  635,  635,  635,  635,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  762,    0,  762,  600,  600,
  600,  600,  600,  600,  600,  600,    0, 1399,    0,  762,
 1402,    0,    0,    0,    0,    0, 1412, 1419,    0,  762,
    0,    0,    0,    0,    0,    0,  762,    0, 1113,  762,
    0,    0,    0,    0,    0,    0,    0,    0,  687,  762,
    0,    0,  760,  762,  760,  760,    0,  762,    0,    0,
  762,    0,    0, 1139,    0,    0,    0,    0,    0,    0,
  762,  762,  762,  762,  762,  687,  762,    0,    0,  687,
  687,  687,  687,  687,  760,  687,    0,    0,  760,    0,
  760,    0,    0,  762,  762,    0,  687,  588,  589,  590,
  591,  592,  593,  594,  595,    0,    0,  760,    0,    0,
    0,    0,    0,    0,  760,    0,    0,    0,    0,  760,
    0,    0,    0,    0,    0,  760,    0,  762,  762,  762,
    0,  687,    0,  405,    0,  762, 1654,    0,    0,    0,
    0,    0,  762,  762,    0,    0,  762,    0,    0,    0,
    0,  762,    0,    0,  760,    0,  760,    0,    0,  762,
    0,    0,    0,  762,    0,   54,   55,    0,  760,  604,
  605,  606,  607,  608,  609,  610,  611,    0,  760,   59,
    0,    0,    0,    0,    0,  760,    0,    0,  760,    0,
    0,    0,    0,    0,    0,    0,    0,  685,  760, 1505,
    0,    0,  760,    0,    0,    0,  760,    0,    0,  760,
  598,  598,  598,  598,  598,  598,  598,  598,    0,  760,
  760,  760,  760,  760,  685,  760,    0,    0,  685,  685,
  685,  685,  685,    0,  685,    0,    0,    0,    0,    0,
    0,    0,  760,  760,    0,  685,    0,    0,    0,    0,
    0,  653,  653,  653,  653,  653,  653,  653,  653,    0,
    0,  762,    0,  762,  762,  762,  762,  762,  762,  762,
  762,    0,    0,    0,    0,    0,  760,  760,  760,    0,
  685,    0,    0,    0,  760,    0,    0,    0,    0,    0,
    0,  760,  760,    0,    0,  760,    0,    0,    0,    0,
  760,    0,    0,    0,    0,    0,    0,    0,  760,    0,
    0,    0,  760,    0,    0,    0,    0,    0,    0,  687,
  403,  687,  687,    0,    0,    0,    0,    0,    0,    0,
 1559,    0,    0,    0,    0,    0,    0, 1564,  762,  762,
  762,  762,  762,  762,  762,  762,    0,    0,    0,    0,
    0,  687,    0,  406,  407,  687,    0,  687,  589,  590,
  591,  592,  593,  594,  595,    0,  760,  760,  760,  760,
  760,  760,  760,  760,  687,    0,    0,    0,    0,    0,
    0,  687,    0,    0,    0,    0,  687,    0,    0,    0,
    0,    0,  687,    0,    0,    0,    0,    0,    0,  140,
  141,  588,  589,  590,  591,  592,  593,  594,  595,    0,
  760,    0,  760,  760,  760,  760,  760,  760,  760,  760,
    0,  687,    0,  687,    0,    0,    0,    0,    0,    0,
    0,    0,  149,  150,    0,  687,    0,  151,  152,    0,
    0,    0,    0,    0,    0,  687,  604,    0,    0,    0,
    0,    0,  687,    0,    0,  687,    0,    0,    0,    0,
    0,    0,    0,    0,  686,  687,    0,    0,  685,  687,
  685,  685,    0,  687,    0,    0,  687,  604,  604,  604,
  604,  604,    0,  604,    0,    0,  687,  687,  687,  687,
  687,  686,  687,    0,  604,  686,  686,  686,  686,  686,
  685,  686,    0,    0,  685,    0,  685,    0,    0,  687,
  687,    0,  686,    0,  588,  589,  590,  591,  592,  593,
  594,  595,    0,  685,    0,    0,    0,    0,    0,    0,
  685,    0,    0,    0,    0,  685,    0,    0,    0,    0,
    0,  685,    0,  687,  687,  687,    0,  686,    0,    0,
  675,  687,    0,    0,    0,    0,    0,  394,  687,  687,
    0,    0,  687,    0,    0,    0,    0,  687,    0,    0,
  685,    0,  685,    0,    0,  687,    0,  675,    0,  687,
    0,    0,  675,  675,  685,  675,    0,  675,    0,    0,
    0,    0,    0,    0,  685,  607,    0,    0,    0,  395,
    0,  685,    0,  675,  685,    0,  396,    0,    0,    0,
    0,    0,    0,  688,  685,    0,    0,    0,  685,    0,
    0,    0,  685,    0,    0,  685,  607,  607,  607,  607,
  607,    0,  607,    0,  675,  685,  685,  685,  685,  685,
  688,  685,    0,  607,  688,  688,  688,  688,  688,    0,
  688,    0,    0,  397,    0,    0,    0,    0,  685,  685,
    0,  688,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  398,    0,    0,    0,    0,  687,    0,  687,
  687,  687,  687,  687,  687,  687,  687,    0,    0,    0,
  399,    0,  685,  685,  685,    0,  688,    0,    0,  587,
  685,    0,    0,    0,    0,    0,    0,  685,  685,  588,
    0,  685,    0,    0,    0,    0,  685,    0,    0,    0,
    0,    0,  240,    0,  685,  241,    0,    0,  685,    0,
  587,  587,  587,  587,  587,  686,  587,  686,  686,    0,
  588,  588,  588,  588,  588,    0,  588,  587,    0,    0,
    0,    0,  587,    0,    0,    0,    0,  588,  821,    0,
    0,    0,  588,    0,    0,  822,    0,  686,    0,    0,
    0,  686,  671,  686,    0,    0,    0,    0,  400,    0,
    0,    0,    0,  587,    0,    0,    0,    0,    0,    0,
  686,  401,    0,  588,    0,    0,    0,  686,    0,    0,
    0,    0,  686,  671,  671,  671,  671,  671,  686,  671,
    0,  402,    0,    0,    0,    0,    0,    0,    0,    0,
  671,  823,  824,    0,    0,    0,  685,    0,  685,  685,
  685,  685,  685,  685,  685,  685,    0,  686,    0,  686,
    0,    0,    0,  669,    0,    0,    0,    0,    0,    0,
    0,  686,    0,    0,    0,    0,  671,    0,  825,  826,
  827,  686,    0,    0,    0,  683,    0,    0,  686,    0,
    0,  686,    0,    0,  669,  669,  669,  669,  669,    0,
  669,  686,    0,    0,  688,  686,  688,  688,    0,  686,
    0,  669,  686,    0,  828,    0,  683,    0,  683,  683,
  683,    0,  686,  686,  686,  686,  686,    0,  686,    0,
    0,    0,    0,  683,    0,    0,  688,    0,    0,    0,
  688,    0,  688,    0,    0,  686,  686,  669,    0,    0,
    0,  589,    0,    0,    0,    0,  829,    0,    0,  688,
    0,    0,    0,  830,  831,    0,  688,    0,  683,    0,
    0,  688,    0,    0,    0,    0,    0,  688,  686,  686,
  686,  686,  589,  602,  602,  589,  602,  686,  602,    0,
  589,    0,    0,    0,  686,  686,    0,    0,  686,  589,
  832,    0,    0,  686,  833,    0,  688,    0,  688,    0,
    0,  686,    0,    0,    0,  686,    0,  688,    0,    0,
  688,  589,  606,  606,  589,  606,    0,  606,    0,    0,
  688,    0,    0,    0,    0,    0,    0,  688,  589,    0,
  688,    0,    0,    0,    0,    0,    0,    0,  589,    0,
  688,    0,    0,    0,  688,    0,  585,    0,  688,    0,
    0,  688,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  688,  688,  688,  688,  688,    0,  688,    0,  589,
  601,  601,  589,  601,    0,  601,    0,    0,  585,  585,
    0,  585,    0,  585,  688,  688,  589,  604,  604,  604,
  604,  604,  604,  604,  604,    0,    0,    0,    0,  585,
    0,    0,    0,  686,    0,  686,  686,  686,  686,  686,
  686,  686,  686,    0,    0,    0,    0,    0,  688,  688,
  688,    0,    0,    0,    0,    0,  688,  684,    0,    0,
  585,    0,    0,  688,  688,  599,    0,  688,    0,    0,
    0,    0,  688,    0,    0,    0,  683,    0,  683,  683,
  688,    0,    0,    0,  688,  589,    0,    0,  684,    0,
  684,  684,  684,    0,    0,    0,  599,  599,  599,  599,
  599,    0,  599,    0,    0,  684,    0,    0,  683,    0,
    0,  596,  683,  599,  683,    0,  589,    0,  594,  589,
  594,  675,  675,  675,  675,  675,  675,  675,  675,  614,
  612,  683,  613,  589,  615,    0,    0,    0,  683,    0,
  684,    0,  596,  683,  596,  596,  596,    0,  600,  683,
  618,    0,    0,  786,  784,  870,  785,    0,  787,  596,
    0,    0,  589,    0,    0,    0,  607,  607,  607,  607,
  607,  607,  607,  607,  603,    0,    0,    0,  683,    0,
  683,  616,  688,  603,  688,  688,  688,  688,  688,  688,
  688,  688,  683,  589,  605,  605,  589,  605,    0,  605,
    0,    0,  683,  589,    0,  788,    0,    0,    0,  683,
  589,    0,  683,    0,  603,  603,  603,  603,  603,    0,
  603,  609,  683,    0,    0,    0,  683,    0,    0,    0,
  683,  603,    0,  683,  589,  608,  608,  589,  608,    0,
  608,    0,    0,  683,  683,  683,  683,  683,    0,  683,
    0,  589,  609,  609,  609,  609,  609,  586,  609,    0,
    0,    0,    0,    0,    0,    0,  683,  683,    0,  609,
  587,  587,  587,  587,  587,  587,  587,  587,    0,    0,
  588,  588,  588,  588,  588,  588,  588,  588,    0,  586,
  586,    0,  586,    0,  586,    0,    0,    0,    0,    0,
  683,  683,  683,    0,    0,    0,    0,    0,  683,    0,
  586,    0,    0,    0,    0,  683,  683,    0,    0,  683,
    0,    0,    0,    0,  683,    0,  674,    0,  684,  600,
  684,  684,  683, 1006,  598,  596,  683,  597,  676,  599,
    0,  586,    0,  671,  671,  671,  671,  671,  671,  671,
  671,    0,    0,  674,  589,  603,    0,    0,  674,  674,
  684,  674,    0,  674,  684,  676,  684,    0,    0,    0,
  676,  676,  677,  676,    0,  676,    0,    0,    0,  674,
    0,    0,    0,  684,    0,  589,  601,  593,  589,  593,
  684,  676,    0,    0,    0,  684,  678,    0,    0,  677,
    0,  684,  589,    0,  677,  677,    0,  677,    0,  677,
  674,    0,    0,    0,  669,  669,  669,  669,  669,  669,
  669,  669,  676,  678,  591,  677,    0,    0,  678,  678,
  684,  678,  684,  678,  683,  589,  683,  683,  683,  683,
  683,  683,  683,  683,  684,    0,    0,    0,    0,  678,
    0,    0,    0,    0,  684,  591,  677,  591,  591,  591,
    0,  684,    0,    0,  684,    0,  589,    0,  597,  589,
  597,    0,  591,    0,  684,    0,    0,    0,  684,  587,
  678,    0,  684,  589,    0,  684,    0,    0,    0,    0,
  595,    0,    0,    0,    0,  684,  684,  684,  684,  684,
    0,  684,  602,  602,  602,  602,  602,  602,  602,  602,
    0,  587,  587,    0,  587,    0,  587,    0,  684,  684,
    0,  595,    0,  595,  595,  595,    0,    0,    0, 1143,
  614,  612,  587,  613,    0,  615,    0,  588,  595,    0,
    0,  606,  606,  606,  606,  606,  606,  606,  606,    0,
    0,  618,  684,  684,  684,    0,    0,    0,    0,    0,
  684,    0,    0,  587,    0,    0,    0,  684,  684,  588,
  588,  684,  588,    0,  588,    0,  684,    0,    0,    0,
    0,    0,  616,    0,  684,    0,    0,    0,  684,    0,
  588,    0,    0,    0,    0,    0,    0,    0,    0,  601,
  601,  601,  601,  601,  601,  601,  601,  585,  585,  585,
  585,  585,  585,  585,  585,    0,    0,  600,    0,    0,
    0,  588,  786,  784,  878,  785,  600,  787,    0,    0,
    0,  786,  784,  884,  785,    0,  787,    0,    0,    0,
    0,    0,    0,  603,    0,    0,    0,    0,    0,    0,
    0,    0,  603,    0,    0,    0,    0,    0,  600,    0,
    0,    0,    0,  786,  784,  937,  785,    0,  787,    0,
    0,    0,    0,    0,  788,    0,    0,    0,    0,    0,
    0,    0,    0,  788,  603,    0,  684,    0,  684,  684,
  684,  684,  684,  684,  684,  684,  599,  599,  599,  599,
  599,  599,  599,  599,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  788,  594,  594,  594,  594,
  594,  594,  594,  594,    0,    0,    0,    0,  604,  605,
  606,  607,  608,  609,  610,  611,    0,    0,    0,    0,
    0,    0,  596,  596,  596,  596,  596,  596,  596,  596,
    0,    0,  588,  589,  590,  591,  592,  593,  594,  595,
 1145,  614,  612,    0,  613,    0,  615,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  618,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  605,  605,  605,  605,  605,  605,  605,
  605,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  616,  603,  603,  603,  603,  603,  603,
  603,  603,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  608,  608,  608,  608,  608,  608,
  608,  608,    0,    0, 1147,  614,  612,    0,  613,    0,
  615,    0,  609,  609,  609,  609,  609,  609,  609,  609,
    0,    0,    0,    0,    0,    0,  618,    0,    0,    0,
    0,    0,    0,  758,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  586,  586,
  586,  586,  586,  586,  586,  586,    0,  616,    0,    0,
    0,    0,    0,    0,  758,    0,    0,  758,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  758,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  588,  589,  590,  591,  592,  593,  594,
  595,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  758,  674,  674,  674,
  674,  674,  674,  674,  674,    0,    0,    0,    0,  676,
  676,  676,  676,  676,  676,  676,  676,    0,    0,    0,
    0,    0,    0,    0,    0,  593,  593,  593,  593,  593,
  593,  593,  593,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  677,  677,  677,  677,  677,  677,  677,
  677,    0,    0,    0,    0,  752,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  678,  678,  678,
  678,  678,  678,  678,  678,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  752,    0,    0,  752,
    0,    0,    0,    0,    0,  591,  591,  591,  591,  591,
  591,  591,  591,  752,    0,    0,  597,  597,  597,  597,
  597,  597,  597,  597,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  752,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  587,  587,  587,  587,  587,  587,  587,  587,    0,    0,
    0,  595,  595,  595,  595,  595,  595,  595,  595,  604,
  605,  606,  607,  608,  609,  610,  611,    0,    0,    0,
    0,    0,    0,    0,  758,    0,  758,  758,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  753,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  588,  588,
  588,  588,  588,  588,  588,  588,  758,    0,    0,    0,
  758,    0,  758,    0,    0,    0,    0,    0,  753,    0,
    0,  753,    0,    0,    0,    0,    0,    0,    0,  758,
    0,    0,    0,    0,    0,  753,  758,    0,    0,    0,
    0,  758,    0,    0,    0,    0,    0,  758,    0,    0,
    0,  588,  589,  590,  591,  592,  593,  594,  595,    0,
  588,  589,  590,  591,  592,  593,  594,  595,    0,    0,
  753,    0,    0,    0,    0,    0,  758,    0,  758,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  758,    0,  588,  589,  590,  591,  592,  593,  594,  595,
  758,  614,  612, 1151,  613,    0,  615,  758,    0,    0,
  758,    0,    0,    0,    0,    0,  752,    0,  752,  752,
  758,    0,  618,    0,  758,    0,    0,    0,  758,  754,
    0,  758,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  758,  758,  758,  758,  758,    0,  758,  752,    0,
    0,    0,  752,  616,  752,    0,    0,    0,    0,    0,
  754,    0,    0,  754,  758,  758,    0,    0,    0,    0,
    0,  752,    0,    0,    0,    0,    0,  754,  752,    0,
    0,    0,    0,  752,    0,    0,    0,    0,    0,  752,
  604,  605,  606,  607,  608,  609,  610,  611,  758,  758,
  758,    0,    0,    0,    0,    0,  758,    0,    0,    0,
    0,    0,  754,  758,  758,    0,    0,  758,  752,    0,
  752,    0,  758,    0,    0,    0,    0,    0,    0,    0,
  758,    0,  752,    0,  758,    0,    0,    0,  600,    0,
    0,    0,  752,  786,  784,  942,  785,    0,  787,  752,
    0,    0,  752,    0,    0,    0,    0,    0,  753,    0,
  753,  753,  752,    0,  603,    0,  752,    0,    0,    0,
  752,  755,    0,  752,  604,  605,  606,  607,  608,  609,
  610,  611,    0,  752,  752,  752,  752,  752,    0,  752,
  753,    0,    0,    0,  753,  788,  753,    0,    0,    0,
    0,    0,  755,    0,    0,  755,  752,  752,    0,    0,
    0,    0,    0,  753,    0,    0,    0,    0,    0,  755,
  753,    0,    0,    0,    0,  753,    0,    0,    0,    0,
    0,  753,  758,    0,  758,  758,    0,    0,    0,    0,
  752,  752,  752,    0,    0,    0,    0,    0,  752,    0,
    0,    0,    0,    0,  755,  752,  752,    0,    0,  752,
  753,    0,  753,    0,  752,    0,    0,    0,    0,    0,
    0,    0,  752,    0,  753,    0,  752,    0,    0,    0,
  600,    0,    0,    0,  753,  786,  784,  964,  785,    0,
  787,  753,    0,    0,  753,    0,    0,    0,    0,    0,
  754,    0,  754,  754,  753,    0,  603,    0,  753,    0,
    0,    0,  753,  756,    0,  753,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  753,  753,  753,  753,  753,
    0,  753,  754,    0,    0,    0,  754,  788,  754,    0,
    0,    0,    0,    0,  756,    0,    0,  756,  753,  753,
    0,    0,    0,    0,    0,  754,    0,    0,    0,    0,
    0,  756,  754,    0,    0,    0,    0,  754,    0,    0,
    0,    0,    0,  754,  752,    0,  752,  752,    0,    0,
    0,    0,  753,  753,  753,    0,    0,    0,    0,    0,
  753,    0,    0,    0,    0,    0,  756,  753,  753,    0,
    0,  753,  754,    0,  754,    0,  753,    0,    0,    0,
    0,    0,    0,    0,  753,    0,  754,    0,  753,    0,
    0,    0,    0,    0,    0,    0,  754,    0,    0,    0,
    0,    0,    0,  754,    0,    0,  754,    0,    0,    0,
    0,    0,  755,    0,  755,  755,  754,    0,    0,    0,
  754,    0,    0,    0,  754,  757,    0,  754,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  754,  754,  754,
  754,  754,    0,  754,  755,    0,    0,    0,  755,    0,
  755,    0,    0,    0,    0,    0,  757,    0,    0,  757,
  754,  754,    0,    0,    0,    0,    0,  755,    0,    0,
    0,    0,    0,  757,  755,    0,    0,    0,    0,  755,
    0,    0,    0,    0,    0,  755,  753,    0,  753,  753,
    0,    0,    0,    0,  754,  754,  754,    0,    0,    0,
    0,    0,  754,    0,    0,    0,    0,    0,  757,  754,
  754,    0,    0,  754,  755,    0,  755,    0,  754,    0,
    0,    0,    0,    0,    0,    0,  754,    0,  755,    0,
  754,    0,    0,    0,    0,    0,    0,    0,  755,    0,
    0,    0,    0,    0,    0,  755,    0,    0,  755,    0,
    0,    0,    0,    0,  756,    0,  756,  756,  755,    0,
    0,    0,  755,    0,    0,    0,  755,  759,    0,  755,
  604,  605,  606,  607,  608,  609,  610,  611,    0,  755,
  755,  755,  755,  755,    0,  755,  756,    0,    0,    0,
  756,    0,  756,    0,    0,    0,    0,    0,  759,    0,
    0,  759,  755,  755,    0,    0,    0,    0,    0,  756,
    0,    0,    0,    0,    0,  759,  756,    0,    0,    0,
    0,  756,    0,    0,    0,    0,    0,  756,  754,    0,
  754,  754,    0,    0,    0,    0,  755,  755,  755,    0,
    0,    0,    0,    0,  755,    0,    0,    0,    0,    0,
  759,  755,  755,    0,    0,  755,  756,    0,  756,    0,
  755,    0,    0,    0,    0,    0,    0,    0,  755,    0,
  756,    0,  755,    0,    0,    0,    0,    0,    0,    0,
  756,    0,    0,    0,    0,    0,    0,  756,    0,    0,
  756,    0,    0,    0,    0,    0,  757,    0,  757,  757,
  756,    0,    0,    0,  756,    0,    0,    0,  756,  751,
    0,  756,  588,  589,  590,  591,  592,  593,  594,  595,
    0,  756,  756,  756,  756,  756,    0,  756,  757,    0,
    0,    0,  757,    0,  757,    0,    0,    0,    0,    0,
  751,    0,    0,  751,  756,  756,    0,    0,    0,    0,
    0,  757,  442,    0,    0,    0,    0,  751,  757,    0,
    0,    0,    0,  757,    0,    0,    0,    0,    0,  757,
  755,    0,  755,  755,    0,    0,    0,    0,  756,  756,
  756,    0,    0,    0,    0,    0,  756,    0,    0,    0,
    0,    0,  751,  756,  756,    0,    0,  756,  757,    0,
  757,    0,  756,    0,    0,    0,    0,    0,    0,    0,
  756,    0,  757,    0,  756,    0,    0,    0,    0,    0,
    0,    0,  757,    0,    0,    0,    0,    0,    0,  757,
    0,    0,  757,    0,  443,    0,    0,    0,  759,    0,
  759,  759,  757,    0,    0,    0,  757,    0,    0,    0,
  757,    0,    0,  757,  588,  589,  590,  591,  592,  593,
  594,  595,    0,  757,  757,  757,  757,  757,    0,  757,
  759,    0,    0,    0,  759,    0,  759,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  757,  757,    0,    0,
    0,    0,    0,  759,    0,    0,    0,    0,    0,    0,
  759,    0,    0,    0,    0,  759,    0,    0,    0,    0,
    0,  759,  756,    0,  756,  756,    0,    0,    0,    0,
  757,  757,  757,    0,    0,    0,    0,    0,  757,    0,
    0,    0,    0,    0,    0,  757,  757,    0,    0,  757,
  759,    0,  759,    0,  757,    0,    0,    0,    0,    0,
    0,    0,  757,    0,  759,    0,  757,    0,    0,    0,
    0,  397,    0,    0,  759,    0,    0,    0,    0,    0,
    0,  759,    0,    0,  759,    0,    0,    0,    0,    0,
  751,    0,  751,  751,  759,    0,    0,    0,  759,    0,
    0,    0,  759,    0,    0,  759,    0,  396,    0,    0,
    0,    0,    0,    0,    0,  759,  759,  759,  759,  759,
    0,  759,  751,    0,    0,    0,  751,    0,  751,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  759,  759,
  391,    0,    0,    0,    0,  751,    0,    0,    0,    0,
    0,    0,  751,    0,    0,    0,    0,  751,    0,    0,
    0,    0,    0,  751,  757,    0,  757,  757,    0,  442,
    0,  442,  759,  759,  759,    0,    0,    0,    0,  392,
  759,    0,    0,    0,    0,    0,    0,  759,  759,    0,
    0,  759,  751,  600,  751,  442,  759, 1142,  598,  596,
  442,  597,    0,  599,  759,    0,  751,    0,  759,    0,
    0,    0,    0,    0,    0,    0,  751,    0,    0,  603,
    0,    0,    0,  751,    0,    0,  751,    0,    0,    0,
    0,    0,    0,    0,    0,  442,  751,  442,    0,    0,
  751,    0,    0,    0,  751,    0,    0,  751,    0,  442,
  601,  443,    0,  443,    0,    0,    0,  751,  751,  751,
  751,  751,    0,  751,    0,    0,  442,    0,  600,  442,
    0,    0,    0,  786,  784,  973,  785,  443,  787,  442,
  751,  751,  443,  442,    0,    0,    0,  393,    0,    0,
    0,    0,    0,    0,  603,    0,    0,    0,    0,    0,
  442,    0,    0,  442,  442,    0,  759,    0,  759,    0,
    0,    0,    0,    0,  751,  751,  751,  443,    0,  443,
    0,  394,  751,  442,  442,  788,    0,    0,    0,  751,
  751,  443,    0,  751,    0,    0,    0,    0,  751,    0,
    0,    0,  397,    0,  397,  397,  751,    0,  443,    0,
  751,  443,    0,    0,    0,    0,    0,  442,    0,  442,
    0,  443,    0,    0,    0,  443,    0,    0,    0,    0,
    0,    0,  442,  442,  397,    0,  442,    0,  396,    0,
  396,  396,  443,    0,    0,  443,  443,    0,    0,  442,
    0,    0,    0,  442,    0,  418,    0,  397,    0,    0,
    0,    0,    0,    0,    0,  443,  443,    0,    0,  397,
  396,  391,    0,  391,  391,  397,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  396,    0,    0,    0,    0,    0,  443,
    0,  443,    0,  391,    0,  396,    0,    0,  751,    0,
  392,  396,  392,  392,  443,  443,    0,    0,  443,    0,
    0,    0,    0,    0,    0,    0,  391,    0,  397,    0,
    0,  443,    0,    0,    0,  443,    0,    0,  391,    0,
    0,    0,  392,    0,  391,    0,    0,    0,  397,    0,
    0,  442,    0,    0,    0,    0,  397,    0,    0,  397,
    0,    0,    0,    0,  396,  392,    0,    0,    0,  397,
  397,  397,  397,  397,    0,  397,    0,  392,    0,    0,
    0,    0,    0,  392,  396,    0,    0,    0,    0,    0,
    0,    0,  396,    0,    0,  396,    0,  391,    0,    0,
    0,    0,    0,    0,    0,  396,  396,  396,  396,  396,
    0,  396,    0,    0,    0,    0,    0,  391,  393,    0,
  393,  393,    0,    0,    0,  391,    0,  397,  391,    0,
    0,    0,    0,  443,  397,    0,  392,    0,  391,  391,
  391,  391,  391,    0,  391,    0,    0,    0,    0,    0,
  393,    0,  394,    0,  394,  394,  392,    0,  397,    0,
    0,    0,    0,  396,  392,    0,    0,  392,    0,    0,
  396,    0,    0,  393,    0,    0,    0,  392,  392,  392,
  392,  392,    0,  392,  394,  393,    0,    0,    0,    0,
    0,  393,    0,    0,  396,    0,  391,    0,    0,    0,
    0,    0,    0,  391,  600,    0,    0,  394,    0,  786,
  784,  992,  785,    0,  787,    0,    0,    0,    0,  394,
    0,    0,    0,    0,    0,  394,  418,  391,  418,  418,
  603,    0,    0,    0,    0,  392,    0,    0,    0,    0,
    0,    0,  392,  600,  393,    0,    0, 1144,  598,  596,
    0,  597,    0,  599,    0,    0,    0,  600,  418,    0,
  397,  788,  786,  784,  393,  785,  392,  787,    0,  603,
  246,    0,  393,    0,    0,  393,    0,    0,  394,    0,
    0,  418,    0,  603,    0,  393,  393,  393,  393,  393,
    0,  393,    0,  418,    0,    0,  396,  170,  394,  418,
  601,    0,  160,    0,    0,    0,  394,    0,    0,  394,
    0,    0,    0, 1336,  788,    0,    0,    0,    0,  394,
  394,  394,  394,  394,    0,  394,    0,    0,    0,  391,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  393,    0,    0,    0,    0,    0,    0,
  393,    0,  418,    0,    0,    0,    0,  588,  589,  590,
  591,  592,  593,  594,  595,  600,    0,    0,  392, 1146,
  598,  596,  418,  597,  393,  599,    0,  394,    0,    0,
  418,    0,  247,  418,  394,    0,    0,    0,    0,    0,
    0,  603,    0,  418,  418,  418,  418,  418,    0,  418,
    0,    0,    0,    0,  248,  600,    0,    0,  394, 1148,
  598,  596,    0,  597,    0,  599,    0,  249,    0,    0,
    0,    0,  601,    0,    0,    0,    0,    0,    0,    0,
    0,  603,  588,  589,  590,  591,  592,  593,  594,  595,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  418,    0,    0,    0,  600,    0,    0,  418, 1152,
  598,  596,  601,  597,    0,  599,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  393,    0,    0,    0,
    0,  603,  418,    0,    0,    0,    0,    0,    0,  250,
  251,  252,  253,    0,  254,  255,  256,  257,  258,  259,
  260,  261,  262,  263,  264,  265,  266,  267,  268,  269,
  394,    0,  601,    1,    2,    3,    4,    5,    6,    7,
    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,
   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,
   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,
   38,   39,   40,   41,    0,   42,   43,   44,   45,   46,
   47,   48,   49,   50,   51,    0,    0,   52,   53,    0,
    0,    0,   54,   55,    0,    0,    0,    0,   56,    0,
    0,   57,   58,    0,  418,    0,   59,   60,   61,    0,
    0,   62,    0,    0,    0,   63,    0,   64,    0,    0,
    0,    0,   65,    0,   66,   67,    0,   68,   69,  614,
  612,   70,  613,   71,  615,   72,   73,    0,   74,    0,
    0,    0,    0,    0,   75, 1356,    0,    0,    0,   76,
  618,    0,   77,    0,    0,    0,    0,   78,   79,    0,
    0,    0,   80,   81,   82,   83,    0,   84,   85,    0,
    0,   86,    0,    0,    0,    0,    0,    0,    0,   87,
    0,  616,    0,   88,    0,    0,    0,    0,   89,   90,
   91,    0,   92,    0,    0,    0,    0,   93,    0,    0,
    0,   94,   95,    0,   96,   97,   98,   99,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  100,  101,  325,
    0,    0,    0,    0,  317,    0,    0,    0,    0,    0,
    0,    0,  102,  600,    0,    0,    0,    0,  598,  596,
 1150,  597,    0,  599,    0,  103,    0,    0,    0,    0,
  104,  105,    0,    0,    0,    0,  106,  107,  108,  603,
  109,  110,  111,  112,    0,    0,    0,    0,    0,    0,
  113,  114,  115,  116,  117,    0,  118,    0,    0,    0,
  119,  120,    0,    0,    0,  121,    0,    0,  122,  123,
  601,  600,    0,  124,    0, 1154,  598,  596,    0,  597,
  125,  599,  126,  127,  128,  129,    0,    0,    0,  130,
  131,    0,    0,    0,  132,    0,  133,  603,    0,  134,
  135,  136,  137,  138,  139,    0,  140,  141,  588,  589,
  590,  591,  592,  593,  594,  595,  600,    0,    0,    0,
 1156,  598,  596,    0,  597,    0,  599,    0,  601,    0,
    0,    0,  142,  143,  144,  145,  146,  147,  148,  149,
  150,    0,  603,    0,  151,  152,    0,  588,  589,  590,
  591,  592,  593,  594,  595,    0,    0,    0,    0,    0,
    0,  588,  589,  590,  591,  592,  593,  594,  595,    0,
    0,    0,    0,  601,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  153,    0,    0,
    0,    0,  154,  155,  156,  157,  158,  159,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  161,  162,  163,
  164,  165,  166,  167,  168,  169,  271,  272,  273,  274,
  275,  276,  277,  278,   10,   11,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,   22,   23,  289,  290,
  291,  292,  293,  294,  295,  296,  297,  298,  299,  300,
  301,  302,  303,  304,  305,  306,    0,   42,   43,   44,
   45,   46,   47,   48,   49,    0,    0,    0,    0,  588,
  589,  590,  591,  592,  593,  594,  595,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  418,    0,    0,
    0,    0,  419,    0,    0,    0,    0,  420,    0,  588,
  589,  590,  591,  592,  593,  594,  595,    0,    0,    0,
    0,    0,  600,    0,  325,    0, 1158,  598,  596,  317,
  597,    0,  599,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  421,    0,    0,    0,    0,    0,  603,  347,
    0,    0,    0,    0,    0,    0,  422,    0,    0,  588,
  589,  590,  591,  592,  593,  594,  595,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  423,    0,    0,  601,
  424,    0,    0,  600,  425,    0,  426, 1160,  598,  596,
  427,  597,    0,  599,    0,    0,  600,    0,    0,    0,
 1162,  598,  596,    0,  597,    0,  599,  240,  600,  603,
  241,    0,    0,  598,  596, 1164,  597,    0,  599,    0,
  600,    0,  603,    0, 1167,  598,  596,    0,  597,    0,
  599,    0,    0,    0,  603,    0,    0,    0,    0,    0,
  601,    0,    0,    0,  600,  314,  603,    0, 1169,  598,
  596,    0,  597,  601,  599,    0,    0,    0,    0,    0,
    0,  600,  315,    0,    0,  601,  598,  596, 1171,  597,
  603,  599,    0,  600,    0,    0,    0,  601,  598,  596,
 1182,  597,    0,  599,  428,    0,    0,  603,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  603,
  429,  601,    0,    0,    0,  138,  139,  430,  604,  605,
  606,  607,  608,  609,  610,  611,    0,    0,  601,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  601,    0,    0,    0,  142,  143,  431,  145,  146,  147,
  148,  271,  272,  273,  274,  275,  276,  277,  278,   10,
   11,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,   22,   23,  289,  290,  291,  292,  293,  294,  295,
  296,  297,  298,  299,  300,  301,  302,  303,  304,  305,
  306,    0,   42,   43,   44,   45,   46,   47,   48,   49,
    0,    0,    0,    0,    0,    0,    0,  316,  158,  159,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  318,
    0,  319,  320,  321,  322,  323,  324,  588,  589,  590,
  591,  592,  593,  594,  595,    0,    0,  503,    0,    0,
    0,    0,  504,    0,    0,    0,    0,  505,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  325,
    0,    0,    0,    0,  317,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  506,    0,    0,
    0,    0,    0,    0,  507,  588,  589,  590,  591,  592,
  593,  594,  595,    0,  600,    0,    0,    0, 1176,  598,
  596,    0,  597,    0,  599,    0,    0,    0,  508,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  600,    0,
  603,  509, 1178,  598,  596,  510,  597,    0,  599,    0,
  588,  589,  590,  591,  592,  593,  594,  595,  614,  612,
 1165,  613,  240,  615,  603,  241,    0,    0,  600,    0,
    0,  601, 1180,  598,  596,    0,  597,  600,  599,  618,
    0,    0,  598,  596, 1184,  597,    0,  599,    0,    0,
    0,    0,    0,    0,  603,  601,    0,    0,    0,    0,
  314,    0,    0,  603,    0,    0,  511,    0,    0,    0,
  616,    0,    0,  600,    0,    0,    0,  315,  598,  596,
 1186,  597,  600,  599,    0,  601,    0,  598,  596, 1188,
  597,    0,  599,    0,  601,  614,  612, 1172,  613,  603,
  615,    0,    0,    0,    0,    0,    0,    0,  603,    0,
    0,    0,    0,    0,    0,    0,  618,    0,    0,    0,
  138,  139,    0,    0,    0,    0,    0,    0,    0,    0,
  601,    0,    0,    0,    0,    0,    0,    0,    0,  601,
    0,    0,    0,    0,    0,    0,    0,  616,    0,  142,
  143,  144,  145,  146,  147,  148,  271,  272,  273,  274,
  275,  276,  277,  278,   10,   11,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,   22,   23,  289,  290,
  291,  292,  293,  294,  295,  296,  297,  298,  299,  300,
  301,  302,  303,  304,  305,  306,    0,   42,   43,   44,
   45,   46,   47,   48,   49,    0,    0,    0,    0,    0,
    0,    0,  316,  158,  159,    0,  588,  589,  590,  591,
  592,  593,  594,  595,  318,    0,  319,  320,  321,  322,
  323,  324,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  307,    0,    0,
    0,    0,  308,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  325,    0,    0,    0,    0,  317,
    0,    0,    0,    0,    0,    0,  309,  588,  589,  590,
  591,  592,  593,  594,  595,    0,    0,    0,    0,  310,
  588,  589,  590,  591,  592,  593,  594,  595,    0,    0,
    0,    0,  588,  589,  590,  591,  592,  593,  594,  595,
    0,    0,    0,    0,  588,  589,  590,  591,  592,  593,
  594,  595,    0,  600,  311,    0,  312, 1190,  598,  596,
  313,  597,    0,  599,    0,    0,    0,    0,  588,  589,
  590,  591,  592,  593,  594,  595,    0,  240,    0,  603,
  241,    0,    0,    0,    0,  588,  589,  590,  591,  592,
  593,  594,  595,    0,    0,    0,    0,  588,  589,  590,
  591,  592,  593,  594,  595,    0,    0,    0,  600,    0,
  601,    0, 1192,  598,  596,  314,  597,    0,  599,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  600,    0,  315,    0,  603,  598,  596, 1194,  597,    0,
  599,  600,    0,    0,    0, 1196,  598,  596,    0,  597,
    0,  599,    0,    0,    0,    0,  603,    0,    0,    0,
    0,    0,    0,    0,    0,  601,    0,  603,    0,    0,
    0,    0,    0,    0,    0,  138,  139,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  601,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  601,    0,
    0,    0,    0,    0,  142,  143,  144,  145,  146,  147,
  148,  271,  272,  273,  274,  275,  276,  277,  278,   10,
   11,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,   22,   23,  289,  290,  291,  292,  293,  294,  295,
  296,  297,  298,  299,  300,  301,  302,  303,  304,  305,
  306,    0,   42,   43,   44,   45,   46,   47,   48,   49,
    0,    0,    0,    0,    0,    0,    0,  316,  158,  159,
    0,    0,    0,    0,    0,    0,  434,    0,    0,  318,
    0,  319,  320,  321,  322,  323,  324,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  435,    0,    0,    0,    0,  436,  588,  589,
  590,  591,  592,  593,  594,  595,    0,    0,    0,  325,
    0,    0,    0,    0,  317,    0,    0,    0,    0,    0,
    0,    0,  588,  589,  590,  591,  592,  593,  594,  595,
    0,    0,    0,    0,  437,    0,    0,  604,  605,  606,
  607,  608,  609,  610,  611,    0,    0,    0,    0,    0,
    0,    0,  588,  589,  590,  591,  592,  593,  594,  595,
    0,  588,  589,  590,  591,  592,  593,  594,  595,  438,
    0,  439,    0,    0,    0,  440,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  240,    0,    0,  241,    0,  588,  589,  590,
  591,  592,  593,  594,  595,    0,  588,  589,  590,  591,
  592,  593,  594,  595,  604,  605,  606,  607,  608,  609,
  610,  611,    0,    0,    0,    0,    0,    0,    0,    0,
  314,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  315,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  138,  139,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  142,
  143,  144,  145,  146,  147,  148,  271,  272,  273,  274,
  275,  276,  277,  278,   10,   11,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,   22,   23,  289,  290,
  291,  292,  293,  294,  295,  296,  297,  298,  299,  300,
  301,  302,  303,  304,  305,  306,    0,   42,   43,   44,
   45,   46,   47,   48,   49,    0,    0,    0,    0,    0,
    0,    0,  316,  158,  159,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  318,    0,  319,  320,  321,  322,
  323,  324, 1149,  614,  612,    0,  613,    0,  615,    0,
    0,    0,    0,    0,    0,  600,    0,  570,    0, 1198,
  598,  596,  571,  597,  618,  599,    0,    0,    0,    0,
    0,    0,  600,    0,  325,    0, 1200,  598,  596,  317,
  597,  603,  599,    0,    0,    0,  572,  588,  589,  590,
  591,  592,  593,  594,  595,  616,  600,    0,  603,  573,
 1202,  598,  596,    0,  597,    0,  599,    0,    0,    0,
    0,    0,  601,    0,    0,  600,    0,    0,    0, 1006,
  786,  784,  603,  785,    0,  787,    0,    0,    0,  601,
    0,    0,    0,    0,  574,    0,  575,    0,    0,    0,
  576,  603,  588,  589,  590,  591,  592,  593,  594,  595,
    0,    0,    0,  601,    0,    0,    0,  240,    0,    0,
  241,    0,    0,    0,  588,  589,  590,  591,  592,  593,
  594,  595,  788,    0,    0,  588,  589,  590,  591,  592,
  593,  594,  595,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  314,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  315,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  325,    0,    0,    0,
    0,  317,    0,    0,    0,  138,  139,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  142,  143,  144,  145,  146,  147,
  148,  271,  272,  273,  274,  275,  276,  277,  278,   10,
   11,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,   22,   23,  289,  290,  291,  292,  293,  294,  295,
  296,  297,  298,  299,  300,  301,  302,  303,  304,  305,
  306,    0,   42,   43,   44,   45,   46,   47,   48,   49,
    0,    0,    0,    0,    0,    0,    0,  316,  158,  159,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  318,
    0,  319,  320,  321,  322,  323,  324,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1066, 1067,    0,    0,
    0,    0, 1068,  600,    0,    0,    0,    0,  786,  784,
 1301,  785,  600,  787,    0,    0,    0,  786,  784, 1306,
  785,    0,  787,    0,    0,    0,    0,    0,    0,  603,
    0, 1069,    0,    0,    0,    0,    0,    0,  603,    0,
    0,    0,    0,    0,  347,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  788,    0,    0,    0,    0,    0,    0,    0,    0,  788,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1070,
    0, 1071,    0,  271,  272,  273,  274,  275,  276,  277,
  278,   10,   11,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,   22,   23,  289,  290,  291,  292,  293,
  294,  295,  296,  297,  298,  299,  300,  301,  302,  303,
  304,  305,  306,    0,   42,   43,   44,   45,   46,   47,
   48,   49,    0,    0,    0,    0,    0,    0,    0,    0,
  314,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  315,    0,    0,
 1072, 1073,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1406,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  600,
    0,  325,    0, 1342,  598,  596,  317,  597,    0,  599,
  138,  139,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  603,  347,    0,    0, 1407,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  142,
  143,  144,  145,  146,  147,  148,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  601,    0,    0,    0,
    0, 1408,    0, 1409,    0,    0,    0,    0,    0,    0,
    0,    0,  604,  605,  606,  607,  608,  609,  610,  611,
    0,    0,    0,    0,  240,    0,    0,  241,    0,  588,
  589,  590,  591,  592,  593,  594,  595,    0,    0,    0,
    0,    0,  316,  158,  159,    0,  588,  589,  590,  591,
  592,  593,  594,  595,  318,    0,  319,  320,  321,  322,
  323,  324,  314,    0,    0,    0,    0,    0,    0,    0,
  588,  589,  590,  591,  592,  593,  594,  595,  600,  315,
    0,    0, 1410,  786,  784, 1307,  785,    0,  787,  588,
  589,  590,  591,  592,  593,  594,  595,    0,    0,    0,
    0,    0,    0,    0,  603,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  138,  139,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  788,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  142,  143,  144,  145,  146,  147,  148,  271,  272,
  273,  274,  275,  276,  277,  278,   10,   11,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,   22,   23,
  289,  290,  291,  292,  293,  294,  295,  296,  297,  298,
  299,  300,  301,  302,  303,  304,  305,  306,    0,   42,
   43,   44,   45,   46,   47,   48,   49,    0,    0,    0,
    0,    0,  600,    0,  316,  158,  159,  786,  784, 1311,
  785,    0,  787,    0,    0,    0,  318,    0,  319,  320,
  321,  322,  323,  324,    0,  600,    0,    0,  603,    0,
  786,  784, 1320,  785,    0,  787,    0,    0,    0, 1413,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  603,    0,    0,    0,    0,  325,    0,    0,  788,
    0,  317,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  347,  788,    0, 1414,    0,    0,    0,    0,  600,
    0,    0,    0,    0,  786,  784, 1334,  785,    0,  787,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  603, 1415,  600, 1416,    0,
    0, 1344,  598,  596,    0,  597,    0,  599,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  240,
  325,    0,  241,  603,    0,  317,  788,  588,  589,  590,
  591,  592,  593,  594,  595,    0,  588,  589,  590,  591,
  592,  593,  594,  595,    0,  600,    0,    0,    0, 1346,
  598,  596,    0,  597,  601,  599,  600,  314,    0,    0,
 1348,  598,  596,    0,  597,    0,  599,    0,    0,    0,
    0,  603,    0,  600,  315,  325,    0, 1417,  786,  784,
  317,  785,  603,  787,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1355,    0,    0,    0,    0,  603,
    0,    0,  601,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  601,    0,    0,    0,  138,  139,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  788,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  142,  143,  144,  145,
  146,  147,  148,  271,  272,  273,  274,  275,  276,  277,
  278,   10,   11,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,   22,   23,  289,  290,  291,  292,  293,
  294,  295,  296,  297,  298,  299,  300,  301,  302,  303,
  304,  305,  306,    0,   42,   43,   44,   45,   46,   47,
   48,   49,    0,    0,    0,    0,    0,    0,    0,  316,
  158,  159,    0,  588,  589,  590,  591,  592,  593,  594,
  595,  318,    0,  319,  320,  321,  322,  323,  324,    0,
    0,    0,    0,    0,    0,    0,    0,  271,  272,  273,
  274,  275,  276,  277,  278,   10,   11,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,   22,   23,  289,
  290,  291,  292,  293,  294,  295,  296,  297,  298,  299,
  300,  301,  302,  303,  304,  305,  306,    0,   42,   43,
   44,   45,   46,   47,   48,   49,  347,    0,    0,    0,
    0,    0,  271,  272,  273,  274,  275,  276,  277,  278,
   10,   11,  279,  280,  281,  282,  283,  284,  285,  286,
  287,  288,   22,   23,  289,  290,  291,  292,  293,  294,
  295,  296,  297,  298,  299,  300,  301,  302,  303,  304,
  305,  306,    0,   42,   43,   44,   45,   46,   47,   48,
   49,  600,    0,    0,    0, 1350,  598,  596,    0,  597,
    0,  599,  588,  589,  590,  591,  592,  593,  594,  595,
    0,    0,    0,    0,    0,    0,    0,  603,    0,    0,
  347,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  314,  600,    0,    0,    0, 1352,  598,  596,
    0,  597,    0,  599,    0,  600,    0,    0,  601,  315,
  786,  784,    0,  785,    0,  787,    0,    0,    0,  603,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  603,    0,    0,    0,  347,    0,    0,  600,    0,
    0,    0,    0,  786,  784, 1380,  785,    0,  787,    0,
  601,    0,  138,  139,    0,    0,    0,    0,  534,  535,
    0, 1357,  788,    0,  603,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  314,    0,    0,    0,
    0,  142,  143,  144,  145,  146,  147,  148,    0,  325,
    0,  536,  537,  315,  317,  788,  588,  589,  590,  591,
  592,  593,  594,  595,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  355,    0,  588,
  589,  590,  591,  592,  593,  594,  595,    0,    0,    0,
    0,  314,    0,    0,    0,    0,  138,  139,  356,    0,
    0,    0,  545,  546,  316,  158,  159,  600,  315,    0,
    0, 1487,  786,  784,    0,  785,  318,  787,  319,  320,
  321,  322,  323,  324,    0,  142,  143,  144,  145,  146,
  147,  148,  325,  603,    0,  547,  548,  317,    0,    0,
    0,    0, 1455,  588,  589,  590,  591,  592,  593,  594,
  595,  138,  139,  600,    0,    0,    0, 1144,  786,  784,
    0,  785,    0,  787,  788,    0,    0,    0,    0,    0,
    0,  588,  589,  590,  591,  592,  593,  594,  595,  603,
  142,  143,  144,  145,  146,  147,  148,  170,  316,  158,
  159,    0,  160,    0,    0,  357,    0,    0,    0,    0,
  318,    0,  319,  320,  321,  322,  323,  324,    0,    0,
  788,    0,    0,    0,    0,    0,    0,    0,    0,  588,
  589,  590,  591,  592,  593,  594,  595,    0,    0,    0,
  588,  589,  590,  591,  592,  593,  594,  595,    0,    0,
    0,    0,    0,  316,  158,  159,    0,  588,  589,  590,
  591,  592,  593,  594,  595,  318,    0,  319,  320,  321,
  322,  323,  324,    0,    0,    0,  271,  272,  273,  274,
  275,  276,  277,  278,   10,   11,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,   22,   23,  289,  290,
  291,  292,  293,  294,  295,  296,  297,  298,  299,  300,
  301,  302,  303,  304,  305,  306,    0,   42,   43,   44,
   45,   46,   47,   48,   49,    0,    0,    0,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,  369,
  370,  371,  372,  373,  374,  375,  376,  377,  378,  379,
  380,  381,  382,  383,    0,    0,    0,    0,    0,  271,
  272,  273,  274,  275,  276,  277,  278,   10,   11,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,   22,
   23,  289,  290,  291,  292,  293,  294,  295,  296,  297,
  298,  299,  300,  301,  302,  303,  304,  305,  306,    0,
   42,   43,   44,   45,   46,   47,   48,   49,    0,  347,
    0,    0,    0,    0,    2,    3,    4,    5,    6,    7,
    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,
  561,   19,   20,   21,   22,   23,   24,   25,   26,   27,
   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,
   38,   39,   40,   41,    0,   42,   43,   44,   45,   46,
   47,   48,   49,  600,    0,    0,    0, 1146,  786,  784,
    0,  785,    0,  787,    0,    0,  600,    0,    0,    0,
 1148,  786,  784,    0,  785,    0,  787,    0,  600,  603,
    0,    0,  347,  786,  784, 1150,  785,    0,  787,    0,
    0,    0,  603,    0,    0,  314,    0,    0,    0,    0,
    0,    0,    0,    0,  603,    0,    0,    0,    0,    0,
  788,    0,  315,    0,    0,  588,  589,  590,  591,  592,
  593,  594,  595,  788,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  788,    0,  562,    0,    0,
    0,    0,  600,    0,    0,    0, 1457,  786,  784, 1488,
  785,    0,  787,    0,    0,  138,  139,  588,  589,  590,
  591,  592,  593,  594,  595,    0,    0,    0,  603,  588,
  589,  590,  591,  592,  593,  594,  595,    0,  314,    0,
    0,    0,    0,    0,  142,  143,  144,  145,  146,  147,
  148,  170,    0,    0,    0,  315,  160,    0,    0,  788,
    0,    0,  588,  589,  590,  591,  592,  593,  594,  595,
    0,    0,    0,    0,    0,    0,    0,  600,    0,    0,
    0, 1152,  786,  784,    0,  785,  600,  787,    0,    0,
 1154,  786,  784,  314,  785,    0,  787,    0,  138,  139,
    0,    0,    0,  603,    0,    0,    0,  316,  158,  159,
  563,    0,  603,    0,    0,    0,    0,    0,    0,  318,
    0,  319,  320,  321,  322,  323,  324,  142,  143,  144,
  145,  146,  147,  148,  788,    0,  600,    0,    0,    0,
 1156,  786,  784,  788,  785,    0,  787,    0,    0,    0,
    0,    0,    0,  138,  139,  600,    0,    0,    0, 1158,
  786,  784,  603,  785,    0,  787,    0,    0,    0,    0,
    0,  588,  589,  590,  591,  592,  593,  594,  595,    0,
    0,  603,  142,  143,  144,  145,  146,  147,  148,    0,
  316,  158,  159,  788,    0,    0,    0,    0,    0,    0,
    0,    0,  318,    0,  319,  320,  321,  322,  323,  324,
    0,    0,  788,    0,    0,    0,    0,  588,  589,  590,
  591,  592,  593,  594,  595,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  564,  158,  159,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  161,    0,  163,
  164,  165,  166,  167,  168,    0,    0,    0,    2,    3,
    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,
   14,   15,   16,   17,  561,   19,   20,   21,   22,   23,
   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,
   34,   35,   36,   37,   38,   39,   40,   41,    0,   42,
   43,   44,   45,   46,   47,   48,   49,  600,    0,    0,
    0, 1160,  786,  784,    0,  785,  600,  787,    0,    0,
 1162,  786,  784,    0,  785,    0,  787,    0,    0,    0,
  600,    0,    0,  603, 1167,  786,  784,    0,  785,  600,
  787,    0,  603, 1169,  786,  784,    0,  785,    0,  787,
    0,    0,  600,    0,    0,    0,  603,  786,  784, 1489,
  785,    0,  787,    0,  788,  603,  600,    0,    0,    0,
 1176,  786,  784,  788,  785,  600,  787,    0,  603, 1178,
  786,  784,    0,  785,    0,  787,    0,  788,    0,  600,
    0,  562,  603, 1180,  786,  784,  788,  785,  600,  787,
    0,  603,    0,  786,  784, 1182,  785,    0,  787,  788,
    0,  600,    0,    0,    0,  603,  786,  784, 1184,  785,
    0,  787,    0,  788,  603,    0,    0,    0,  600,    0,
    0,    0,  788,  786,  784, 1186,  785,  603,  787,    0,
    0,    0,    0,  600,    0,    0,  788,    0,  786,  784,
 1188,  785,    0,  787,  603,  788,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  788,  603,
    0,  600,    0,    0,    0, 1190,  786,  784,    0,  785,
    0,  787,    0,    0,    0,  788,    0,  314,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  603,    0,    0,
  788,    0,    0,    0,  681,    0,    0,  588,  589,  590,
  591,  592,  593,  594,  595,    0,    0,    0,    0,    0,
  588,  589,  590,  591,  592,  593,  594,  595,  788,    0,
    0,    0,  588,  589,  590,  591,  592,  593,  594,  595,
    0,    0,    0,    0,    0,    0,    0,  138,  139,  600,
    0,    0,    0, 1192,  786,  784,    0,  785,  600,  787,
    0,    0,    0,  786,  784, 1491,  785,    0,  787,    0,
    0,    0,    0,    0,    0,  603,  142,  143,  144,  145,
  146,  147,  148,    0,  603,  600,    0,    0,    0, 1196,
  786,  784,    0,  785,    0,  787,  588,  589,  590,  591,
  592,  593,  594,  595,  600,    0,  788,    0, 1198,  786,
  784,  603,  785,    0,  787,  788,  614,  612,    0,  613,
    0,  615,    0,    0,    0,    0,    0,    0,    0,    0,
  603,    0,    0,    0,    0,    0,    0,  618,  600,  564,
  158,  159,  788,  786,  784, 1495,  785,    0,  787,    0,
    0,  161,    0,  163,  164,  165,  166,  167,  168,    0,
    0,  788,    0,    0,  603,    0,    0,    0,  616,    0,
    0,  588,  589,  590,  591,  592,  593,  594,  595,    0,
  588,  589,  590,  591,  592,  593,  594,  595,  600,    0,
    0,    0, 1200,  786,  784,  788,  785,    0,  787,    0,
  600,    0,    0,    0, 1202,  786,  784,    0,  785,    0,
  787,    0,  600,    0,  603,    0,    0,  786,  784,    0,
  785,    0,  787,    0,    0,    0,  603,    0,    0,    0,
  588,  589,  590,  591,  592,  593,  594,  595,  603,    0,
    0,    0,    0,    0,    0,  788,    0,    0,    0,  588,
  589,  590,  591,  592,  593,  594,  595,  788,    0,    0,
    0,    0,    0,    0,    0,    0,  600,    0, 1494,  788,
 1342,  786,  784,    0,  785,  600,  787,    0,    0, 1344,
  786,  784,    0,  785,    0,  787,    0,    0,    0,  600,
    0,    0,  603, 1346,  786,  784,    0,  785,  600,  787,
    0,  603, 1348,  786,  784,    0,  785,    0,  787,    0,
    0,    0,  600,    0,    0,  603, 1350,  786,  784,    0,
  785,  600,  787,  788,  603, 1352,  786,  784,    0,  785,
    0,  787,  788,    0,  600,    0,    0,    0,  603,  786,
  784,    0,  785,    0,  787,    0,  788,  603,    0,    0,
    0,  600,    0,    0,    0,  788,  786,  784, 1502,  785,
  603,  787,  600,    0,    0,    0, 1575,  786,  784,  788,
  785,    0,  787,    0,  600,    0,    0,  603,  788,  786,
  784, 1516,  785,    0,  787,    0,    0,    0,  603,    0,
 1496,  788,    0,    0,    0,    0,    0,    0,    0,    0,
  603,    0,    0,    0,    0,    0,    0,    0,  788,    0,
    0,  588,  589,  590,  591,  592,  593,  594,  595,  788,
  588,  589,  590,  591,  592,  593,  594,  595,    0,    0,
    0,  788,    0,    0,  588,  589,  590,  591,  592,  593,
  594,  595,    0,  588,  589,  590,  591,  592,  593,  594,
  595,    0,    0,    0,    0,    0,  588,  589,  590,  591,
  592,  593,  594,  595,    0,    0,    0,    0,    0,    0,
  588,  589,  590,  591,  592,  593,  594,  595,    0,  588,
  589,  590,  591,  592,  593,  594,  595,    0,    0,    0,
    0,    0,    0,  588,  589,  590,  591,  592,  593,  594,
  595,    0,  588,  589,  590,  591,  592,  593,  594,  595,
    0,    0,    0,    0,    0,  588,  589,  590,  591,  592,
  593,  594,  595,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  588,  589,  590,  591,  592,  593,  594,  595,
    0,    0,    0,    0,    0,    0,    0,  588,  589,  590,
  591,  592,  593,  594,  595,    0,    0,  600,    0,    0,
    0,    0,  786,  784, 1536,  785,    0,  787,    0,    0,
    0,    0,    0,    0,    0,  588,  589,  590,  591,  592,
  593,  594,  595,  603,  600,    0,    0,    0,    0,  786,
  784, 1539,  785,  600,  787,    0,    0,    0,  786,  784,
 1540,  785,    0,  787,    0,    0,    0,    0,    0,    0,
  603,    0,    0,    0,  788,    0,  600,    0,    0,  603,
    0,  786,  784, 1546,  785,  600,  787,    0,    0, 1577,
  598,  596,    0,  597,    0,  599,    0,    0,    0,    0,
    0,  788,  603,    0,    0,    0,    0,    0,    0,    0,
  788,  603,    0,  588,  589,  590,  591,  592,  593,  594,
  595,    0,  588,  589,  590,  591,  592,  593,  594,  595,
    0,  600,    0,  788,    0, 1579,  598,  596,    0,  597,
    0,  599,  601,    0,    0,    0,    0,    0,    0,  588,
  589,  590,  591,  592,  593,  594,  595,  603,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  588,  589,
  590,  591,  592,  593,  594,  595,  605,  606,  607,  608,
  609,  610,  611,    0,  600,    0,    0,    0,  601,  786,
  784, 1585,  785,    0,  787,    0,    0,    0,    0,    0,
    0,    0,  588,  589,  590,  591,  592,  593,  594,  595,
  603,    0,    0,    0,    0,    0,  600,    0,    0,    0,
    0,  786,  784, 1586,  785,    0,  787,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  788,  603,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  588,  589,  590,  591,  592,  593,  594,  595,
    0,    0,    0,    0,  588,  589,  590,  591,  592,  593,
  594,  595,    0,  788,    0,    0,  588,  589,  590,  591,
  592,  593,  594,  595,    0,    0,    0,    0,    0,    0,
  600,    0,    0,    0, 1587,  786,  784,    0,  785,    0,
  787,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  603,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  588,  589,  590,  591,  592,  593,  594,  595,    0,  588,
  589,  590,  591,  592,  593,  594,  595,  788,    0,    0,
    0,    0,    0,  588,  589,  590,  591,  592,  593,  594,
  595,    0,  588,  589,  590,  591,  592,  593,  594,  595,
    0,    0,    0,    0,    0,    0,  588,  589,  590,  591,
  592,  593,  594,  595,    0,  588,  589,  590,  591,  592,
  593,  594,  595,    0,    0,    0,    0,    0,  588,  589,
  590,  591,  592,  593,  594,  595,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  588,  589,  590,  591,  592,
  593,  594,  595,    0,    0,    0,  588,  589,  590,  591,
  592,  593,  594,  595,    0,    0,    0,    0,  588,  589,
  590,  591,  592,  593,  594,  595,  600,    0,    0,    0,
 1589,  786,  784,    0,  785,  600,  787,    0,    0, 1591,
  786,  784,    0,  785,    0,  787,    0,    0,    0,  600,
    0,    0,  603, 1593,  598,  596,    0,  597,  600,  599,
    0,  603, 1595,  598,  596,    0,  597,    0,  599,    0,
    0,  600,    0,    0,    0,  603,  786,  784, 1610,  785,
    0,  787,    0,  788,  603,    0,    0,    0,  600,    0,
    0,    0,  788,  786,  784, 1615,  785,  603,  787,    0,
    0,    0,    0,  600,    0,    0,  601,    0,  786,  784,
 1618,  785,  600,  787,  603,  601,    0,  786,  784, 1621,
  785,    0,  787,    0,    0,  600,    0,    0,  788,  603,
  786,  784,    0,  785,    0,  787,  600,    0,  603,    0,
    0,  786,  784, 1623,  785,  788,  787,    0,    0,    0,
    0,  603,    0,    0,    0,    0,    0,    0,  600,    0,
  788,    0,  603,  786,  784, 1628,  785,    0,  787,  788,
  600,    0,    0,    0,    0,  786,  784, 1629,  785,    0,
  787, 1622,  788,    0,  603,    0,    0,    0,    0,    0,
    0,    0,    0,  788,    0,    0,  603,    0,    0,    0,
    0,  588,  589,  590,  591,  592,  593,  594,  595,    0,
    0,    0,    0,    0,    0,  788,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  788,  588,  589,
  590,  591,  592,  593,  594,  595,    0,  588,  589,  590,
  591,  592,  593,  594,  595,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  588,  589,  590,  591,  592,  593,  594,  595,    0,  588,
  589,  590,  591,  592,  593,  594,  595,  600,    0,    0,
    0,    0,  786,  784, 1633,  785,  600,  787,    0,    0,
 1642,  786,  784,    0,  785,    0,  787,    0,    0,    0,
  600,    0,    0,  603, 1644,  786,  784,    0,  785,    0,
  787,    0,  603,    0,    0,  588,  589,  590,  591,  592,
  593,  594,  595,  600,    0,    0,  603,    0,  786,  784,
    0,  785,  600,  787,  788,    0,    0,  786,  784, 1647,
  785,    0,  787,  788, 1153,  614,  612,    0,  613,  603,
  615,    0,    0,    0,    0,  600,    0,  788,  603,    0,
  786,  784, 1659,  785,    0,  787,  618,    0,  588,  589,
  590,  591,  592,  593,  594,  595,    0,    0,    0, 1646,
  788,  603,    0,    0,    0,  600,    0,    0,    0,  788,
  786,  784, 1665,  785,    0,  787,    0,  616,    0,    0,
  588,  589,  590,  591,  592,  593,  594,  595,  600,    0,
    0,  603,  788,  786,  784, 1666,  785,    0,  787,    0,
    0,    0,    0,    0,    0,  600,    0,    0,    0,    0,
  786,  784, 1669,  785,  603,  787,    0,    0,    0,    0,
  600,    0,  788,    0, 1673,  786,  784,    0,  785,    0,
  787,  603,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  600,    0,  788,  603, 1674,  786,  784,
    0,  785,    0,  787,  588,  589,  590,  591,  592,  593,
  594,  595,  788,    0,    0,  600,    0,    0,    0,  603,
  786,  784,    0,  785,    0,  787,  600,  788,    0,    0,
    0,  786,  784, 1680,  785,    0,  787,  600,    0,    0,
    0,  603,  786,  784, 1684,  785,    0,  787,  600,    0,
  788,    0,  603,  786,  784, 1686,  785,    0,  787,  600,
    0,    0,    0,  603,  786,  784, 1689,  785,    0,  787,
  600, 1679,  788,    0,  603,  786,  784, 1691,  785,    0,
  787,  600,    0,  788,    0,  603,  786,  784,    0,  785,
    0,  787,  600,    0,  788,    0,  603,  786,  784,    0,
  785,    0,  787,    0,    0,  788,    0,  603,    0,    0,
    0,    0,    0,    0,    0,    0,  788,    0,  603,    0,
    0,    0,    0,    0,  600,    0,    0,  788,    0,  786,
  784, 1709,  785,    0,  787,    0,    0, 1693,  788,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  788,
  603,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  588,  589,  590,  591,  592,  593,  594,  595,    0,  588,
  589,  590,  591,  592,  593,  594,  595,    0,    0,    0,
    0,  788,    0,  588,  589,  590,  591,  592,  593,  594,
  595,    0,  588,  589,  590,  591,  592,  593,  594,  595,
    0,    0,    0,    0,    0,  588,  589,  590,  591,  592,
  593,  594,  595,    0, 1155,  614,  612,    0,  613,    0,
  615,    0,  588,  589,  590,  591,  592,  593,  594,  595,
    0,    0,    0,    0,    0,    0,  618,  588,  589,  590,
  591,  592,  593,  594,  595,    0,  588,  589,  590,  591,
  592,  593,  594,  595,    0,    0,    0,    0,    0,  588,
  589,  590,  591,  592,  593,  594,  595,  616,    0,    0,
  588,  589,  590,  591,  592,  593,  594,  595,    0, 1157,
  614,  612,    0,  613,    0,  615,    0,    0,    0,    0,
    0,    0,  588,  589,  590,  591,  592,  593,  594,  595,
    0,  618,    0,    0,  588,  589,  590,  591,  592,  593,
  594,  595,  600,    0,    0,    0,    0,  786,  784, 1713,
  785,  600,  787,    0,    0,    0,  786,  784, 1715,  785,
    0,  787,  616,    0,  600,    0,    0,    0,  603,  786,
  784,    0,  785,    0,  787,  600,    0,  603,    0,    0,
  598,  596,    0,  597,    0,  599,    0, 1159,  614,  612,
  603,  613,    0,  615,    0,    0, 1161,  614,  612,  788,
  613,  603,  615,    0,    0,    0,    0,    0,  788,  618,
    0,    0,    0,    0,    0,    0,    0,    0,  618,    0,
    0,  788,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  601,    0,    0,    0,    0,    0,    0,    0,
  616,  588,  589,  590,  591,  592,  593,  594,  595,  616,
  588,  589,  590,  591,  592,  593,  594,  595,    0,    0,
    0,    0,    0,    0,  588,  589,  590,  591,  592,  593,
  594,  595,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  588,  589,  590,
  591,  592,  593,  594,  595,    0,  588,  589,  590,  591,
  592,  593,  594,  595,  604,  605,  606,  607,  608,  609,
  610,  611, 1163,  614,  612,    0,  613,    0,  615,  588,
  589,  590,  591,  592,  593,  594,  595,    0,    0,    0,
    0,    0,    0,    0,  618, 1168,  614,  612,    0,  613,
    0,  615,    0,    0,    0,    0,    0,    0,    0,  588,
  589,  590,  591,  592,  593,  594,  595,  618,    0,    0,
 1170,  614,  612,    0,  613,  616,  615,    0,    0,    0,
    0,    0,  588,  589,  590,  591,  592,  593,  594,  595,
    0,    0,  618,    0,    0,    0,    0,    0,  616,  588,
  589,  590,  591,  592,  593,  594,  595,    0,    0,    0,
    0,    0,    0,    0,  588,  589,  590,  591,  592,  593,
  594,  595,    0,  616, 1703, 1177,  614,  612,    0,  613,
    0,  615,    0,    0,    0,    0,    0,  588,  589,  590,
  591,  592,  593,  594,  595,    0,    0,  618,  614,  612,
 1183,  613,    0,  615,    0,    0,    0,    0,    0,  588,
  589,  590,  591,  592,  593,  594,  595,    0,    0,  618,
  588,  589,  590,  591,  592,  593,  594,  595,  616,    0,
    0,  588,  589,  590,  591,  592,  593,  594,  595,    0,
    0,    0,  588,  589,  590,  591,  592,  593,  594,  595,
  616,    0,    0,  588,  589,  590,  591,  592,  593,  594,
  595,    0,    0,    0,  588,  589,  590,  591,  592,  593,
  594,  595,    0,    0,    0,  588,  589,  590,  591,  592,
  593,  594,  595,    0,    0,    0,  588,  589,  590,  591,
  592,  593,  594,  595, 1179,  614,  612,    0,  613,    0,
  615,    0,    0,    0, 1181,  614,  612,    0,  613,    0,
  615,    0,    0,    0,    0,    0,  618,    0,  588,  589,
  590,  591,  592,  593,  594,  595,  618, 1191,  614,  612,
    0,  613,    0,  615,    0,    0, 1193,  614,  612,    0,
  613,    0,  615,    0, 1197,  614,  612,  616,  613,  618,
  615,    0,    0,    0,    0,    0,    0,  616,  618, 1199,
  614,  612,    0,  613,    0,  615,  618,    0, 1201,  614,
  612,    0,  613,    0,  615,    0,    0,    0,    0,    0,
  616,  618,    0,    0,    0,    0,    0,    0,    0,  616,
  618,    0, 1203,  614,  612,    0,  613,  616,  615,    0,
    0,    0,    0,    0,  604,  605,  606,  607,  608,  609,
  610,  611,  616,    0,  618,    0,    0,    0,    0,    0,
    0,  616,    0,    0, 1343,  614,  612,    0,  613,    0,
  615,    0, 1345,  614,  612,    0,  613,    0,  615,    0,
    0,    0,    0,    0,    0,  616,  618,  614,  612, 1185,
  613,    0,  615,    0,  618,    0,    0,    0,    0,    0,
    0, 1347,  614,  612,    0,  613,    0,  615,  618,  604,
  605,  606,  607,  608,  609,  610,  611,  616,    0,    0,
    0,    0,    0,  618,    0,  616,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  616,
    0,    0,    0,    0,    0,    0,  588,  589,  590,  591,
  592,  593,  594,  595,  616,  588,  589,  590,  591,  592,
  593,  594,  595,    0,    0,    0,    0,    0,  588,  589,
  590,  591,  592,  593,  594,  595,    0,    0,    0,  588,
  589,  590,  591,  592,  593,  594,  595,  604,  605,  606,
  607,  608,  609,  610,  611,    0,  604,  605,  606,  607,
  608,  609,  610,  611, 1349,  614,  612,    0,  613,    0,
  615,    0, 1351,  614,  612,    0,  613,    0,  615,    0,
    0, 1353,  614,  612,    0,  613,  618,  615,    0, 1576,
  614,  612,    0,  613,  618,  615,    0,  355, 1578,  614,
  612,    0,  613,  618,  615,    0, 1580,  614,  612,    0,
  613,  618,  615,    0,    0,    0,    0,  616,  356,    0,
  618,    0,    0,    0,    0,  616,    0,    0,  618,    0,
    0, 1588,  614,  612,  616,  613,    0,  615,    0, 1590,
  614,  612,  616,  613,    0,  615,    0,    0,    0,    0,
    0,  616,    0,  618,    0,    0,    0,    0,    0,  616,
    0,  618,    0, 1592,  614,  612,    0,  613,    0,  615,
    0,    0,  604,  605,  606,  607,  608,  609,  610,  611,
    0,    0,    0,    0,  616,  618,    0, 1594,  614,  612,
    0,  613,  616,  615,    0,  604,  605,  606,  607,  608,
  609,  610,  611,    0,    0,    0, 1596,  614,  612,  618,
  613,    0,  615,    0,    0,  357,  616,    0,    0,    0,
  604,  605,  606,  607,  608,  609,  610,  611,  618,    0,
    0,  614,  612, 1187,  613,    0,  615,    0,    0,    0,
  616,  614,  612, 1189,  613,    0,  615,    0,    0,    0,
    0,    0,  618,  614,  612, 1195,  613,    0,  615,  616,
    0,    0,  618,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  618,  604,  605,  606,  607,  608,
  609,  610,  611,  616,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  616,    0,    0,    0,  604,  605,  606,
  607,  608,  609,  610,  611,  616,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,  369,
  370,  371,  372,  373,  374,  375,  376,  377,  378,  379,
  380,  381,  382,  383,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1434,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  604,  605,  606,  607,  608,  609,
  610,  611,    0,    0,  604,  605,  606,  607,  608,  609,
  610,  611,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  604,  605,  606,
  607,  608,  609,  610,  611,    0,  604,  605,  606,  607,
  608,  609,  610,  611,  604,  605,  606,  607,  608,  609,
  610,  611,    0,    0,    0,    0,    0,    0,    0,  604,
  605,  606,  607,  608,  609,  610,  611,    0,  604,  605,
  606,  607,  608,  609,  610,  611,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  604,  605,  606,  607,  608,  609,  610,  611,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  604,  605,  606,  607,  608,  609,
  610,  611,  604,  605,  606,  607,  608,  609,  610,  611,
    0,    0,    0,    0,    0,    0,  604,  605,  606,  607,
  608,  609,  610,  611,    0,    0,    0,    0,    0,    0,
    0,  604,  605,  606,  607,  608,  609,  610,  611,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  604,  605,  606,  607,  608,  609,
  610,  611,  604,  605,  606,  607,  608,  609,  610,  611,
    0,  604,  605,  606,  607,  608,  609,  610,  611,  604,
  605,  606,  607,  608,  609,  610,  611,    0,  604,  605,
  606,  607,  608,  609,  610,  611,  604,  605,  606,  607,
  608,  609,  610,  611,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  604,  605,  606,  607,  608,  609,  610,  611,  604,
  605,  606,  607,  608,  609,  610,  611, 1094,    0, 1095,
 1096,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  604,  605,  606,  607,  608,  609,  610,
  611,    0,    0,    0,    0,    0,    0,    0,    0, 1097,
    0,    0,    0,    0,    0,    0,    0,  604,  605,  606,
  607,  608,  609,  610,  611, 1117,    0, 1118,    0,    0,
    0,    0, 1098,    0,    0,    0,  604,  605,  606,  607,
  608,  609,  610,  611, 1099,    0,    0,  475,  476,  246,
 1100, 1119,    0,    0,    0,    0, 1120,    0,  477,    0,
  604,  605,  606,  607,  608,  609,  610,  611,    0,    0,
  604,  605,  606,  607,  608,  609,  610,  611,    0,    0,
    0,    0,  604,  605,  606,  607,  608,  609,  610,  611,
    0, 1121,    0, 1122,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1101,    0, 1123,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  478,    0, 1124, 1102,    0, 1125,    0,    0,    0,    0,
    0, 1103,    0,    0, 1104, 1126,    0,    0,    0, 1127,
    0,    0,    0,    0,  240, 1105, 1106,  241, 1107,    0,
 1108,    0,    0,    0,    0,    0,  240,    0,    0,  241,
 1128,  247,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1129,
 1130,    0,    0,  248,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  249,    0,    0,    0,
    0,    0, 1109,    0,    0,    0,    0,    0,    0, 1110,
    0,    0,    0, 1131,    0, 1132,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1133, 1134,
    0,    0, 1135, 1111,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1136,    0,    0,    0, 1137,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  625,  626,  250,  251,
  252,  253,    0,  254,  255,  256,  257,  258,  259,  260,
  261,  262,  263,  264,  265,  266,  267,  268,  269,  627,
    0,    0,    0,    0,    0,  628,    0,    0,    0,    0,
    0,  629,    0,  630,  471,  471,    0,    0,    0,    0,
    0,  470,  470,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  631,    0,    0,    0,    0,  471,    0,    0,
    0,    0,    0,  471,  470, 1112,    0,    0,    0,  471,
  470,  471,    0,  632,    0,  633,  470, 1138,  470,    0,
    0,    0,    0,    0,    0,    0,    0,  634,    0,    0,
  471,    0,    0,    0,    0,    0,  240,  470,    0,  241,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  471,    0,  471,    0,    0,    0,    0,  470,  635,
  470,    0,    0,    0,    0,  471,    0,    0,    0,    0,
    0,    0,  470,    0,  471,    0,    0,  471,    0,    0,
    0,  470,    0,    0,  470,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  636,  637,    0,  471,    0,    0,
    0,    0,    0,    0,  470,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  638,    0,    0,    0,
    0,    0,    0,    0,    0,  639,    0,    0,    0,    0,
    0,    0,  471,  471,    0,    0,    0,    0,    0,  470,
  470,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  471,    0,    0,    0,    0,  640,
    0,  470,    0,  471,    0,    0,    0,    0,    0,    0,
  470,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  471,    0,    0,
    0,    0,    0,    0,  470,
};
short yycheck[] = {                                      52,
    0,  476,  506,  374,  479,  309,  419,   60,   10,  109,
  512,  348,   46,  348,  544,   46,   10,  492,   10,  503,
  853,  374,  283,  284,   10,  427,   46,   61,   81,  639,
   46,  390,  132,  537,  390,  324,  323,  455,  440,   41,
  342,  324,   44,   37,  630,  324,  324,   41,   42,   43,
   44,   45,   42,   47,   10,   41,   58,   47,   44,  324,
   91,  324,    0,   63,   58,  549,  327,  390,  486,   63,
  357,   91,   58,   63,   74, 1107,  344,  490,  456,   10,
  348,   37,  283,  284,  462,   41,   42,   43,   44,   45,
  376,   47,  342,   93,   94,   40, 1128,   10,  582,  385,
   94,  101,   58,  542,   94,  544,   37,   63,  510,  639,
   41,   42,   43,   44,   45,  383,   47,  419,   41,   42,
   43,  338,   45,  460,   47,  460,  126,   58,   41,  129,
  532,   44,   63,   10,  134,  639,  136,  639,   94,  443,
   63,   10,  446,  338,  503,   58,   40,  503,   40,  451,
   40,  298,  299,  300,  301,  302,  303,  304,  305,  427,
  160,  161,  162,   94,   41,  536,   43,   44,   45,  419,
  170,   94,   41,  390,  576,   44,  589,  590,  591,  592,
  503,   58,  390,  536,  537,  336,  337,   40,  490,   58,
  190,  191,  192,  193,  194,  195,  196,  197,  198,  199,
  200,  201,  202,  203,  204,   40,  543,  424,  208,  209,
  210,  211,  212,  213,  214,  215,  216,  217,  218,  219,
  220,  221,  160,  161,  513,  308, 1059,  813,  140,  424,
  513,   41,  170,   40,  513,  513,   46,  149,  506,  448,
  490,   37,  451,  385,  399,   40,   42,   43,  513,   45,
  513,   47,  190,  191,  192,  193,  194,  195,  196,  197,
  198,  199,  200,  201,  202,  203,  204,   63,  419,  390,
  208,  209,  210,  211,  212,  213,  214,  215,  216,  217,
  218,  219,  220,  221,  344,   10,  503,  298,  299,  300,
  301,  302,  303,  304,  305,  503,  344,  360,   94,  332,
  360,   40,  639,   40,   63,   40,  448,   61,  525,  451,
   40,   40,  360,   40,    0,   10,   41,  317,  318,   44,
   10,  516,   40,  346,  407,  325,  409,   40,  362,  471,
  525,   10,  348,   58,  417,   94,  419,   91,   10,  490,
  390,  391,  395,   10,  331,  398,   41,   37,   40,   44,
  639,   41,   42,   43,   44,   45,  503,   47,  513,  382,
  348,  348,   41,   58,   40,   44,   10,  390,   58,   41,
   37,  454,   44,   63,   41,   42,   43,   44,   45,   58,
   47,  406,  503,  416,  535,  540,   58,  421,   40,   10,
  377,   58,   40,   37,  428,  537,   63,   41,   42,   43,
   44,   45,  465,   47,   94,  465,   61,  490,  424,  425,
   40,  427,  554,   37,   58,  448,   37,  465,  451,   63,
   41,   42,   43,   44,   45,  448,   47,   94,  451,  546,
  430,  431,  448,  467,  651,  451,   91,   58,  425,   63,
  427,  348,   63,  348,   46,   46,   42,   43,   40,   45,
   94,   47, 1285,  503,  504,  538,  651,  445,  575,   61,
   61,  448,  462,  360,  451,  639,   40,   63,   10,   40,
   94,   40,  460,   94,  160,  161,   40,   40,  503,  502,
  343,   40,  482,   40,  170,  348,  486,   40,   63,   91,
   40,   40,  503,  493,  348,  484,  529,  530,   94,   41,
  525,  501,   44,  344,  190,  191,  192,  193,  194,  195,
  196,  197,  198,  199,  200,  201,   58,  203,  204,   94,
  383,  537,  208,  209,  210,  211,  212,  213,  214,  215,
  216,  217,  218,  219,  220,  221, 1122,  639,  554,  639,
  445,  448,  639,  639,  451,  545,  546,  547,  548,  487,
  537,  448,  552,  460,  451,  460,  639,  495,   40,  559,
  560,  344,  425,  421,  427,  344,  356,  425,  465,  427,
  298,  299,  300,  301,  302,  303,  304,  305,   63,  579,
  580,  581,  582,  583,  584,   40,  554,   40,  588,  589,
  590,  591,  592,  593,  594,  595,  596,  597,  598,  599,
  600,  601,  425,  603,  427,   42,   43,  639,   45,   94,
   47,  639,  612,  613,  614,  615,  616,   46,  544,  638,
  344,  559,  622,  623,  427,  448,   63,  348,  451,   40,
  344,  639,   61,  491,  634,  503,  543,  525,  638,  641,
  640,  579,  580,  581,  582,  583,  584,  641,  642,  643,
  644,  645,  646,  647,  648,  641,  642,   94,  596,  597,
  598,  599,   91,  601,   40,  528,  604,  605,  606,  607,
  608,  609,  610,  611,  612,  613,  614,  615,  616,  537,
  618,   40,   40, 1269,  622,  641,  642,  643,  644,  645,
  646,  647,  648,   40,  631,  632,  633,  634,   40,   40,
   10,   40,   40,   10,  425,   10,  427,   10,   10,   10,
  641,  642,  643,  644,  645,  646,  647,  648,  641,  642,
  643,  644,  645,  646,  647,  648,   40,  448,  641,  642,
  451,  731,  732,  733,  734,  735,  736,  737,  738,  739,
  740,  741,  742,  743,  744,  745,   40,  747,  748,  749,
  750,  751,  752,  753,  754,  755,  756,  757,  758,  759,
  760,  362,   10,   10,  641,  642,  643,  644,  645,  646,
  647,  648,  641,  642,  774,  503,   63,  777,  778,  779,
  780,  781,  782,   10,  784,  785,  786,  787,  788,  789,
  790,   10,   79,   41,  639,   82,   44,   84,   10,  639,
  639, 1276,  802,   46,   44,  344,   93,   94,  639,  348,
   58,  639,   99,  506,   37,  639,  816,  639,  639,   42,
  421,  639,  344,   40,   47,  112,   40,  428,  639,   41,
   40,   43,   44,   45,  772,  773,   40,   40,   40,  126,
   63,   40,   40,   40,  383,   40,   58,  643,  644,  645,
  646,  647,  648,   40,   40,   40,   40,   40,   40,   40,
   40,   40,   40,  322,   40,   40,  467,  154,  155,  156,
  870,   94,   40,  559,   40,  162,   37,   37,  878,   46,
   91,   42,   42,   43,  884,   45,   47,   47,  427,  348,
   40,   40,  179,  579,  580,  581,  582,  583,  584,   40,
  187,  343,   63,   63,   40,  421,  348,   40,   40,   46,
  596,  597,  598,  599,   40,  601,  641,  642,  604,  605,
  606,  607,  608,  609,  610,  611,  612,  613,  614,  615,
  616,  639,  618,   94,   94,  639,  622,  937,   46,   40,
   40,  383,  942,  230,  343,  344,  641,  642,   40,  348,
  237,  641,  642,  643,  644,  645,  646,  647,  648,   40,
   40,  420,  641,  642,  964,   44,  425,  506,  427,  641,
  642,   91,  431,  973,  641,  642,  643,  644,  645,  646,
  647,  648,  982,   46,  383,  427,  534,  506,  639,  639,
  639,  506,  992,  503,  348,  504,  639,  641,  642,  643,
  644,  645,  646,  647,  648,   10,  448,  639,  639,  451,
  639,  506,  528, 1066,  506,  414,  504,  639,  417,  503,
  641,  642,  643,  644,  645,  646,  647,  648,  427,  639,
  546,  547,   37,  503,  499,  499,   41,   42,   43,   44,
   45,  500,   47,  506,  982,   10,  984,  643,  644,  645,
  646,  647,  648,   58,  639,  639,  639,  639,   63,  575,
  576,  577,  578,  579,  580,  581,  639,  466, 1068,  639,
   46,  639, 1072,  639,  639,  344,   41,   42,   43,   44,
   45,  421,   47,  639,  639,   10,  534,  639,  639,   94,
  534,  344,  639,   58,  639, 1095, 1096,  503,   63,  344,
  344,  388,  639, 1103, 1104, 1105, 1106,  639,  639,   10,
  397,  639,  399,  639,  506,  639,   41,   42,   43,   44,
   45,  408,   47,  537,  344,  639,  639,  639,  639,   94,
  376,  418,  639,   58, 1134, 1135,   37,  639,   63,   10,
   41,   42,   43,   44,   45,  639,   47,  503,  394,  639,
 1150,   40,  348,  639,  400,  401,  639,   58,  445,  639,
  639,  639,   63,  639, 1164, 1165,   37,   10,  639,   94,
   41,   42,   43,   44,   45,   63,   47,  639,  639,  639,
   46,  377, 1182, 1183, 1184,  376, 1186,   58, 1188,  639,
  436,  437,   63,   94, 1194, 1195,  639,  639,   41,   42,
   43,   44,   45,  394,   47,  492,  546,  547,  639,  400,
  401,  639,  639, 1151,  343,   58,  639,   46,   63,  348,
  639,  639,  639,   94,  503,  344, 1164, 1165,  503,  425,
  476,  427,  478,  520,  639,  575,  576,  577,  578,  579,
  580,  581,  529,  639,  639,  436,  437, 1185,  503, 1187,
   41, 1189,  448,  503,  383,  451, 1194, 1195,   44,   44,
  639,  639,  639,   44,  393,  639,  639,  639,  503,  503,
  639,  639,  639,  639,  639,  639,  639, 1277,  639,  639,
   44, 1281,  639,   37,   44,  476,   44,  478,   42,   43,
   44,   45,  344,   47,  639,  639,  425, 1297,  427,  390,
   44, 1301,  639,  639,  639,  639, 1306, 1307, 1308,   63,
  503, 1311,  344, 1313, 1314,  503, 1316,  546,  547,  448,
 1320,  344,  451,  344,   44,   61,   44,  344,   10,   46,
   61,  639,  506,  639, 1334, 1335,   44,  344,  344,  639,
   94, 1279,  639,  534,  639,   44,  575,  576,  577,  578,
  579,  580,  581,  639, 1354, 1355,  639,   44,  639,  639,
   42,   43,  639,   45,  651,   47,  653,  654,  639,   10,
   44,  639,  639,  639,  639,  639, 1314,   44,  639,  639,
 1380,   63,  639,  506,   44,  639,  344,  639,  639,  506,
  639,  344,   44,   41,   44,   46,   37,  639,  639,  534,
   41,   42,   43,   44,   45,   44,   47,  639,  639,  639,
   10,  639,   94,  639,  639,  639,  503,   58, 1356,  534,
  503,  639,   10,  639,  639,  385,  639, 1427,   61,  641,
  642,  643,  644,  645,  646,  647,  648,   37,  639,  639,
   46,   41,   42,   43,   44,   45,   61,   47,   44,   37,
  639,  344,   41,   41,   42,   43,   44,   45,   58,   47,
   41,   44,  639,   63,   44, 1151,  639,  639,  639,  639,
   58,  390,   41,   44,  639,  639,  639,  639, 1164, 1165,
  639,  639,  639,  639,  639,  639,  639,  639, 1488,  344,
   46, 1491,  639, 1493,   94, 1495,  639,   10,   44, 1185,
  639, 1187, 1502, 1189,  390,   93,   94,   41, 1194, 1195,
  344,  639,  639,   41,  639,  639, 1516,  639,  639,   41,
   41,  639,   46,  639,   37,   10,  639,  639,   41,   42,
   43,   44,   45,  639,   47,  639,   44,  639,   61, 1539,
 1540,  503,  639,   37, 1544,   58, 1546,   46,   42,   43,
 1550,   45,   37,   47, 1492,  344,   41,   42,   43,   44,
   45,   41,   47,   44,  639,  503,  853,   41,  503,   63,
  639,   10,   61,   58,  639,  639,   44,  639,   41,   41,
   41,   94,  639,  639,   44, 1585, 1586,   37,   41,    0,
   10,   10,   42,   43,   44,   45,   10,   47,   37,   91,
   94,   10,   41,   42,   43,   44,   45, 1545,   47,   94,
 1610,   10, 1612,   63, 1614, 1615,   10,   10, 1618,   58,
   10, 1621,   10, 1623,   10,   10,   10,   10, 1314, 1629,
   10,   10,   10, 1633,   10,   10,  641,  642,  643,  644,
  645,  646,  647,  648,   94, 1645,   10, 1647,   10,   10,
 1124,   10,   10,   10,   93,   94,   10,   10,   10, 1659,
   10,   10,   10, 1663,   10, 1665, 1666,   10,   10, 1669,
 1356,   10,   10,   10, 1612,   10,  641,  642,  643,  644,
  645,  646,  647,  648, 1684,   10, 1686,   10,   10,   10,
   10,   10,   10,  281, 1694,  283,  284,   10,   10,   10,
   37,   10,   10, 1703,   10,   42,   43,   10,   45, 1709,
   47,   10,   10, 1713,   10, 1715,  641,  642,  643,  644,
  645,  646,  647,  648,   10,  313,   63,   10,   10,  317,
   10,  319,   10,   10,   10,   10,   10,   10,  471,  572,
  641,  642,  643,  644,  645,  646,  647,  648,  336, 1613,
  408,   85,   85, 1115, 1140,  343,   -1,   94,   -1,   -1,
  348,   -1,   -1,   -1,   -1,   -1,  354,   -1, 1055,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  383,   -1,  385,  641,  642,
  643,  644,  645,  646,  647,  648,   -1, 1094,   -1,  397,
 1097,   -1,   -1,   -1,   -1,   -1, 1103, 1104,   -1,  407,
   -1,   -1,   -1,   -1,   -1,   -1,  414,   -1, 1115,  417,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   10,  427,
   -1,   -1,  281,  431,  283,  284,   -1,  435,   -1,   -1,
  438,   -1,   -1, 1140,   -1,   -1,   -1,   -1,   -1,   -1,
  448,  449,  450,  451,  452,   37,  454,   -1,   -1,   41,
   42,   43,   44,   45,  313,   47,   -1,   -1,  317,   -1,
  319,   -1,   -1,  471,  472,   -1,   58,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,  336,   -1,   -1,
   -1,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,  348,
   -1,   -1,   -1,   -1,   -1,  354,   -1,  505,  506,  507,
   -1,   93,   -1,  283,   -1,  513, 1612,   -1,   -1,   -1,
   -1,   -1,  520,  521,   -1,   -1,  524,   -1,   -1,   -1,
   -1,  529,   -1,   -1,  383,   -1,  385,   -1,   -1,  537,
   -1,   -1,   -1,  541,   -1,  315,  316,   -1,  397,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,  407,  329,
   -1,   -1,   -1,   -1,   -1,  414,   -1,   -1,  417,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   10,  427, 1276,
   -1,   -1,  431,   -1,   -1,   -1,  435,   -1,   -1,  438,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,  448,
  449,  450,  451,  452,   37,  454,   -1,   -1,   41,   42,
   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  471,  472,   -1,   58,   -1,   -1,   -1,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
   -1,  639,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,   -1,   -1,   -1,   -1,  505,  506,  507,   -1,
   93,   -1,   -1,   -1,  513,   -1,   -1,   -1,   -1,   -1,
   -1,  520,  521,   -1,   -1,  524,   -1,   -1,   -1,   -1,
  529,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  537,   -1,
   -1,   -1,  541,   -1,   -1,   -1,   -1,   -1,   -1,  281,
   46,  283,  284,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
 1407,   -1,   -1,   -1,   -1,   -1,   -1, 1414,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,
   -1,  313,   -1,  503,  504,  317,   -1,  319,  642,  643,
  644,  645,  646,  647,  648,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,  336,   -1,   -1,   -1,   -1,   -1,
   -1,  343,   -1,   -1,   -1,   -1,  348,   -1,   -1,   -1,
   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,   -1,  549,
  550,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
  639,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,  383,   -1,  385,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  582,  583,   -1,  397,   -1,  587,  588,   -1,
   -1,   -1,   -1,   -1,   -1,  407,   10,   -1,   -1,   -1,
   -1,   -1,  414,   -1,   -1,  417,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   10,  427,   -1,   -1,  281,  431,
  283,  284,   -1,  435,   -1,   -1,  438,   41,   42,   43,
   44,   45,   -1,   47,   -1,   -1,  448,  449,  450,  451,
  452,   37,  454,   -1,   58,   41,   42,   43,   44,   45,
  313,   47,   -1,   -1,  317,   -1,  319,   -1,   -1,  471,
  472,   -1,   58,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,  336,   -1,   -1,   -1,   -1,   -1,   -1,
  343,   -1,   -1,   -1,   -1,  348,   -1,   -1,   -1,   -1,
   -1,  354,   -1,  505,  506,  507,   -1,   93,   -1,   -1,
   10,  513,   -1,   -1,   -1,   -1,   -1,  283,  520,  521,
   -1,   -1,  524,   -1,   -1,   -1,   -1,  529,   -1,   -1,
  383,   -1,  385,   -1,   -1,  537,   -1,   37,   -1,  541,
   -1,   -1,   42,   43,  397,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,  407,   10,   -1,   -1,   -1,  325,
   -1,  414,   -1,   63,  417,   -1,  332,   -1,   -1,   -1,
   -1,   -1,   -1,   10,  427,   -1,   -1,   -1,  431,   -1,
   -1,   -1,  435,   -1,   -1,  438,   41,   42,   43,   44,
   45,   -1,   47,   -1,   94,  448,  449,  450,  451,  452,
   37,  454,   -1,   58,   41,   42,   43,   44,   45,   -1,
   47,   -1,   -1,  379,   -1,   -1,   -1,   -1,  471,  472,
   -1,   58,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  398,   -1,   -1,   -1,   -1,  639,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
  416,   -1,  505,  506,  507,   -1,   93,   -1,   -1,   10,
  513,   -1,   -1,   -1,   -1,   -1,   -1,  520,  521,   10,
   -1,  524,   -1,   -1,   -1,   -1,  529,   -1,   -1,   -1,
   -1,   -1,  448,   -1,  537,  451,   -1,   -1,  541,   -1,
   41,   42,   43,   44,   45,  281,   47,  283,  284,   -1,
   41,   42,   43,   44,   45,   -1,   47,   58,   -1,   -1,
   -1,   -1,   63,   -1,   -1,   -1,   -1,   58,  332,   -1,
   -1,   -1,   63,   -1,   -1,  339,   -1,  313,   -1,   -1,
   -1,  317,   10,  319,   -1,   -1,   -1,   -1,  504,   -1,
   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,
  336,  517,   -1,   94,   -1,   -1,   -1,  343,   -1,   -1,
   -1,   -1,  348,   41,   42,   43,   44,   45,  354,   47,
   -1,  537,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,  395,  396,   -1,   -1,   -1,  639,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,  383,   -1,  385,
   -1,   -1,   -1,   10,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  397,   -1,   -1,   -1,   -1,   94,   -1,  432,  433,
  434,  407,   -1,   -1,   -1,   10,   -1,   -1,  414,   -1,
   -1,  417,   -1,   -1,   41,   42,   43,   44,   45,   -1,
   47,  427,   -1,   -1,  281,  431,  283,  284,   -1,  435,
   -1,   58,  438,   -1,  468,   -1,   41,   -1,   43,   44,
   45,   -1,  448,  449,  450,  451,  452,   -1,  454,   -1,
   -1,   -1,   -1,   58,   -1,   -1,  313,   -1,   -1,   -1,
  317,   -1,  319,   -1,   -1,  471,  472,   94,   -1,   -1,
   -1,   10,   -1,   -1,   -1,   -1,  510,   -1,   -1,  336,
   -1,   -1,   -1,  517,  518,   -1,  343,   -1,   93,   -1,
   -1,  348,   -1,   -1,   -1,   -1,   -1,  354,   37,  505,
  506,  507,   41,   42,   43,   44,   45,  513,   47,   -1,
   10,   -1,   -1,   -1,  520,  521,   -1,   -1,  524,   58,
  554,   -1,   -1,  529,  558,   -1,  383,   -1,  385,   -1,
   -1,  537,   -1,   -1,   -1,  541,   -1,   37,   -1,   -1,
  397,   41,   42,   43,   44,   45,   -1,   47,   -1,   -1,
  407,   -1,   -1,   -1,   -1,   -1,   -1,  414,   58,   -1,
  417,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   10,   -1,
  427,   -1,   -1,   -1,  431,   -1,   10,   -1,  435,   -1,
   -1,  438,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  448,  449,  450,  451,  452,   -1,  454,   -1,   41,
   42,   43,   44,   45,   -1,   47,   -1,   -1,   42,   43,
   -1,   45,   -1,   47,  471,  472,   58,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,   63,
   -1,   -1,   -1,  639,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,   -1,   -1,   -1,   -1,  505,  506,
  507,   -1,   -1,   -1,   -1,   -1,  513,   10,   -1,   -1,
   94,   -1,   -1,  520,  521,   10,   -1,  524,   -1,   -1,
   -1,   -1,  529,   -1,   -1,   -1,  281,   -1,  283,  284,
  537,   -1,   -1,   -1,  541,   10,   -1,   -1,   41,   -1,
   43,   44,   45,   -1,   -1,   -1,   41,   42,   43,   44,
   45,   -1,   47,   -1,   -1,   58,   -1,   -1,  313,   -1,
   -1,   10,  317,   58,  319,   -1,   41,   -1,   43,   44,
   45,  641,  642,  643,  644,  645,  646,  647,  648,   42,
   43,  336,   45,   58,   47,   -1,   -1,   -1,  343,   -1,
   93,   -1,   41,  348,   43,   44,   45,   -1,   37,  354,
   63,   -1,   -1,   42,   43,   44,   45,   -1,   47,   58,
   -1,   -1,   10,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   63,   -1,   -1,   -1,  383,   -1,
  385,   94,  639,   10,  641,  642,  643,  644,  645,  646,
  647,  648,  397,   41,   42,   43,   44,   45,   -1,   47,
   -1,   -1,  407,   10,   -1,   94,   -1,   -1,   -1,  414,
   58,   -1,  417,   -1,   41,   42,   43,   44,   45,   -1,
   47,   10,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,
  435,   58,   -1,  438,   41,   42,   43,   44,   45,   -1,
   47,   -1,   -1,  448,  449,  450,  451,  452,   -1,  454,
   -1,   58,   41,   42,   43,   44,   45,   10,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  471,  472,   -1,   58,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   42,
   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
  505,  506,  507,   -1,   -1,   -1,   -1,   -1,  513,   -1,
   63,   -1,   -1,   -1,   -1,  520,  521,   -1,   -1,  524,
   -1,   -1,   -1,   -1,  529,   -1,   10,   -1,  281,   37,
  283,  284,  537,   41,   42,   43,  541,   45,   10,   47,
   -1,   94,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,   -1,   37,   10,   63,   -1,   -1,   42,   43,
  313,   45,   -1,   47,  317,   37,  319,   -1,   -1,   -1,
   42,   43,   10,   45,   -1,   47,   -1,   -1,   -1,   63,
   -1,   -1,   -1,  336,   -1,   41,   94,   43,   44,   45,
  343,   63,   -1,   -1,   -1,  348,   10,   -1,   -1,   37,
   -1,  354,   58,   -1,   42,   43,   -1,   45,   -1,   47,
   94,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   94,   37,   10,   63,   -1,   -1,   42,   43,
  383,   45,  385,   47,  639,   10,  641,  642,  643,  644,
  645,  646,  647,  648,  397,   -1,   -1,   -1,   -1,   63,
   -1,   -1,   -1,   -1,  407,   41,   94,   43,   44,   45,
   -1,  414,   -1,   -1,  417,   -1,   41,   -1,   43,   44,
   45,   -1,   58,   -1,  427,   -1,   -1,   -1,  431,   10,
   94,   -1,  435,   58,   -1,  438,   -1,   -1,   -1,   -1,
   10,   -1,   -1,   -1,   -1,  448,  449,  450,  451,  452,
   -1,  454,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   42,   43,   -1,   45,   -1,   47,   -1,  471,  472,
   -1,   41,   -1,   43,   44,   45,   -1,   -1,   -1,   41,
   42,   43,   63,   45,   -1,   47,   -1,   10,   58,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
   -1,   63,  505,  506,  507,   -1,   -1,   -1,   -1,   -1,
  513,   -1,   -1,   94,   -1,   -1,   -1,  520,  521,   42,
   43,  524,   45,   -1,   47,   -1,  529,   -1,   -1,   -1,
   -1,   -1,   94,   -1,  537,   -1,   -1,   -1,  541,   -1,
   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   37,   -1,   -1,
   -1,   94,   42,   43,   44,   45,   37,   47,   -1,   -1,
   -1,   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,   37,   -1,
   -1,   -1,   -1,   42,   43,   44,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   94,   63,   -1,  639,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   94,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   94,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,   41,   42,   43,   -1,   45,   -1,
   47,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,
   -1,   -1,   -1,   10,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,   94,   -1,   -1,
   -1,   -1,   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   93,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,   -1,   -1,   -1,   10,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   41,   -1,   -1,   44,
   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   58,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  281,   -1,  283,  284,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   10,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,  313,   -1,   -1,   -1,
  317,   -1,  319,   -1,   -1,   -1,   -1,   -1,   41,   -1,
   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  336,
   -1,   -1,   -1,   -1,   -1,   58,  343,   -1,   -1,   -1,
   -1,  348,   -1,   -1,   -1,   -1,   -1,  354,   -1,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   -1,
   93,   -1,   -1,   -1,   -1,   -1,  383,   -1,  385,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  397,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
  407,   42,   43,   44,   45,   -1,   47,  414,   -1,   -1,
  417,   -1,   -1,   -1,   -1,   -1,  281,   -1,  283,  284,
  427,   -1,   63,   -1,  431,   -1,   -1,   -1,  435,   10,
   -1,  438,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  448,  449,  450,  451,  452,   -1,  454,  313,   -1,
   -1,   -1,  317,   94,  319,   -1,   -1,   -1,   -1,   -1,
   41,   -1,   -1,   44,  471,  472,   -1,   -1,   -1,   -1,
   -1,  336,   -1,   -1,   -1,   -1,   -1,   58,  343,   -1,
   -1,   -1,   -1,  348,   -1,   -1,   -1,   -1,   -1,  354,
  641,  642,  643,  644,  645,  646,  647,  648,  505,  506,
  507,   -1,   -1,   -1,   -1,   -1,  513,   -1,   -1,   -1,
   -1,   -1,   93,  520,  521,   -1,   -1,  524,  383,   -1,
  385,   -1,  529,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  537,   -1,  397,   -1,  541,   -1,   -1,   -1,   37,   -1,
   -1,   -1,  407,   42,   43,   44,   45,   -1,   47,  414,
   -1,   -1,  417,   -1,   -1,   -1,   -1,   -1,  281,   -1,
  283,  284,  427,   -1,   63,   -1,  431,   -1,   -1,   -1,
  435,   10,   -1,  438,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,  448,  449,  450,  451,  452,   -1,  454,
  313,   -1,   -1,   -1,  317,   94,  319,   -1,   -1,   -1,
   -1,   -1,   41,   -1,   -1,   44,  471,  472,   -1,   -1,
   -1,   -1,   -1,  336,   -1,   -1,   -1,   -1,   -1,   58,
  343,   -1,   -1,   -1,   -1,  348,   -1,   -1,   -1,   -1,
   -1,  354,  639,   -1,  641,  642,   -1,   -1,   -1,   -1,
  505,  506,  507,   -1,   -1,   -1,   -1,   -1,  513,   -1,
   -1,   -1,   -1,   -1,   93,  520,  521,   -1,   -1,  524,
  383,   -1,  385,   -1,  529,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  537,   -1,  397,   -1,  541,   -1,   -1,   -1,
   37,   -1,   -1,   -1,  407,   42,   43,   44,   45,   -1,
   47,  414,   -1,   -1,  417,   -1,   -1,   -1,   -1,   -1,
  281,   -1,  283,  284,  427,   -1,   63,   -1,  431,   -1,
   -1,   -1,  435,   10,   -1,  438,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  448,  449,  450,  451,  452,
   -1,  454,  313,   -1,   -1,   -1,  317,   94,  319,   -1,
   -1,   -1,   -1,   -1,   41,   -1,   -1,   44,  471,  472,
   -1,   -1,   -1,   -1,   -1,  336,   -1,   -1,   -1,   -1,
   -1,   58,  343,   -1,   -1,   -1,   -1,  348,   -1,   -1,
   -1,   -1,   -1,  354,  639,   -1,  641,  642,   -1,   -1,
   -1,   -1,  505,  506,  507,   -1,   -1,   -1,   -1,   -1,
  513,   -1,   -1,   -1,   -1,   -1,   93,  520,  521,   -1,
   -1,  524,  383,   -1,  385,   -1,  529,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  537,   -1,  397,   -1,  541,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  407,   -1,   -1,   -1,
   -1,   -1,   -1,  414,   -1,   -1,  417,   -1,   -1,   -1,
   -1,   -1,  281,   -1,  283,  284,  427,   -1,   -1,   -1,
  431,   -1,   -1,   -1,  435,   10,   -1,  438,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  448,  449,  450,
  451,  452,   -1,  454,  313,   -1,   -1,   -1,  317,   -1,
  319,   -1,   -1,   -1,   -1,   -1,   41,   -1,   -1,   44,
  471,  472,   -1,   -1,   -1,   -1,   -1,  336,   -1,   -1,
   -1,   -1,   -1,   58,  343,   -1,   -1,   -1,   -1,  348,
   -1,   -1,   -1,   -1,   -1,  354,  639,   -1,  641,  642,
   -1,   -1,   -1,   -1,  505,  506,  507,   -1,   -1,   -1,
   -1,   -1,  513,   -1,   -1,   -1,   -1,   -1,   93,  520,
  521,   -1,   -1,  524,  383,   -1,  385,   -1,  529,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  537,   -1,  397,   -1,
  541,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  407,   -1,
   -1,   -1,   -1,   -1,   -1,  414,   -1,   -1,  417,   -1,
   -1,   -1,   -1,   -1,  281,   -1,  283,  284,  427,   -1,
   -1,   -1,  431,   -1,   -1,   -1,  435,   10,   -1,  438,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,  448,
  449,  450,  451,  452,   -1,  454,  313,   -1,   -1,   -1,
  317,   -1,  319,   -1,   -1,   -1,   -1,   -1,   41,   -1,
   -1,   44,  471,  472,   -1,   -1,   -1,   -1,   -1,  336,
   -1,   -1,   -1,   -1,   -1,   58,  343,   -1,   -1,   -1,
   -1,  348,   -1,   -1,   -1,   -1,   -1,  354,  639,   -1,
  641,  642,   -1,   -1,   -1,   -1,  505,  506,  507,   -1,
   -1,   -1,   -1,   -1,  513,   -1,   -1,   -1,   -1,   -1,
   93,  520,  521,   -1,   -1,  524,  383,   -1,  385,   -1,
  529,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  537,   -1,
  397,   -1,  541,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  407,   -1,   -1,   -1,   -1,   -1,   -1,  414,   -1,   -1,
  417,   -1,   -1,   -1,   -1,   -1,  281,   -1,  283,  284,
  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,  435,   10,
   -1,  438,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,  448,  449,  450,  451,  452,   -1,  454,  313,   -1,
   -1,   -1,  317,   -1,  319,   -1,   -1,   -1,   -1,   -1,
   41,   -1,   -1,   44,  471,  472,   -1,   -1,   -1,   -1,
   -1,  336,   10,   -1,   -1,   -1,   -1,   58,  343,   -1,
   -1,   -1,   -1,  348,   -1,   -1,   -1,   -1,   -1,  354,
  639,   -1,  641,  642,   -1,   -1,   -1,   -1,  505,  506,
  507,   -1,   -1,   -1,   -1,   -1,  513,   -1,   -1,   -1,
   -1,   -1,   93,  520,  521,   -1,   -1,  524,  383,   -1,
  385,   -1,  529,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  537,   -1,  397,   -1,  541,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  407,   -1,   -1,   -1,   -1,   -1,   -1,  414,
   -1,   -1,  417,   -1,   10,   -1,   -1,   -1,  281,   -1,
  283,  284,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,
  435,   -1,   -1,  438,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,  448,  449,  450,  451,  452,   -1,  454,
  313,   -1,   -1,   -1,  317,   -1,  319,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  471,  472,   -1,   -1,
   -1,   -1,   -1,  336,   -1,   -1,   -1,   -1,   -1,   -1,
  343,   -1,   -1,   -1,   -1,  348,   -1,   -1,   -1,   -1,
   -1,  354,  639,   -1,  641,  642,   -1,   -1,   -1,   -1,
  505,  506,  507,   -1,   -1,   -1,   -1,   -1,  513,   -1,
   -1,   -1,   -1,   -1,   -1,  520,  521,   -1,   -1,  524,
  383,   -1,  385,   -1,  529,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  537,   -1,  397,   -1,  541,   -1,   -1,   -1,
   -1,   10,   -1,   -1,  407,   -1,   -1,   -1,   -1,   -1,
   -1,  414,   -1,   -1,  417,   -1,   -1,   -1,   -1,   -1,
  281,   -1,  283,  284,  427,   -1,   -1,   -1,  431,   -1,
   -1,   -1,  435,   -1,   -1,  438,   -1,   10,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  448,  449,  450,  451,  452,
   -1,  454,  313,   -1,   -1,   -1,  317,   -1,  319,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  471,  472,
   10,   -1,   -1,   -1,   -1,  336,   -1,   -1,   -1,   -1,
   -1,   -1,  343,   -1,   -1,   -1,   -1,  348,   -1,   -1,
   -1,   -1,   -1,  354,  639,   -1,  641,  642,   -1,  317,
   -1,  319,  505,  506,  507,   -1,   -1,   -1,   -1,   10,
  513,   -1,   -1,   -1,   -1,   -1,   -1,  520,  521,   -1,
   -1,  524,  383,   37,  385,  343,  529,   41,   42,   43,
  348,   45,   -1,   47,  537,   -1,  397,   -1,  541,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  407,   -1,   -1,   63,
   -1,   -1,   -1,  414,   -1,   -1,  417,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  383,  427,  385,   -1,   -1,
  431,   -1,   -1,   -1,  435,   -1,   -1,  438,   -1,  397,
   94,  317,   -1,  319,   -1,   -1,   -1,  448,  449,  450,
  451,  452,   -1,  454,   -1,   -1,  414,   -1,   37,  417,
   -1,   -1,   -1,   42,   43,   44,   45,  343,   47,  427,
  471,  472,  348,  431,   -1,   -1,   -1,   10,   -1,   -1,
   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,
  448,   -1,   -1,  451,  452,   -1,  639,   -1,  641,   -1,
   -1,   -1,   -1,   -1,  505,  506,  507,  383,   -1,  385,
   -1,   10,  513,  471,  472,   94,   -1,   -1,   -1,  520,
  521,  397,   -1,  524,   -1,   -1,   -1,   -1,  529,   -1,
   -1,   -1,  281,   -1,  283,  284,  537,   -1,  414,   -1,
  541,  417,   -1,   -1,   -1,   -1,   -1,  505,   -1,  507,
   -1,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,
   -1,   -1,  520,  521,  313,   -1,  524,   -1,  281,   -1,
  283,  284,  448,   -1,   -1,  451,  452,   -1,   -1,  537,
   -1,   -1,   -1,  541,   -1,   10,   -1,  336,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  471,  472,   -1,   -1,  348,
  313,  281,   -1,  283,  284,  354,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  336,   -1,   -1,   -1,   -1,   -1,  505,
   -1,  507,   -1,  313,   -1,  348,   -1,   -1,  639,   -1,
  281,  354,  283,  284,  520,  521,   -1,   -1,  524,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  336,   -1,  407,   -1,
   -1,  537,   -1,   -1,   -1,  541,   -1,   -1,  348,   -1,
   -1,   -1,  313,   -1,  354,   -1,   -1,   -1,  427,   -1,
   -1,  639,   -1,   -1,   -1,   -1,  435,   -1,   -1,  438,
   -1,   -1,   -1,   -1,  407,  336,   -1,   -1,   -1,  448,
  449,  450,  451,  452,   -1,  454,   -1,  348,   -1,   -1,
   -1,   -1,   -1,  354,  427,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  435,   -1,   -1,  438,   -1,  407,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  448,  449,  450,  451,  452,
   -1,  454,   -1,   -1,   -1,   -1,   -1,  427,  281,   -1,
  283,  284,   -1,   -1,   -1,  435,   -1,  506,  438,   -1,
   -1,   -1,   -1,  639,  513,   -1,  407,   -1,  448,  449,
  450,  451,  452,   -1,  454,   -1,   -1,   -1,   -1,   -1,
  313,   -1,  281,   -1,  283,  284,  427,   -1,  537,   -1,
   -1,   -1,   -1,  506,  435,   -1,   -1,  438,   -1,   -1,
  513,   -1,   -1,  336,   -1,   -1,   -1,  448,  449,  450,
  451,  452,   -1,  454,  313,  348,   -1,   -1,   -1,   -1,
   -1,  354,   -1,   -1,  537,   -1,  506,   -1,   -1,   -1,
   -1,   -1,   -1,  513,   37,   -1,   -1,  336,   -1,   42,
   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,  348,
   -1,   -1,   -1,   -1,   -1,  354,  281,  537,  283,  284,
   63,   -1,   -1,   -1,   -1,  506,   -1,   -1,   -1,   -1,
   -1,   -1,  513,   37,  407,   -1,   -1,   41,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,   -1,   37,  313,   -1,
  639,   94,   42,   43,  427,   45,  537,   47,   -1,   63,
  335,   -1,  435,   -1,   -1,  438,   -1,   -1,  407,   -1,
   -1,  336,   -1,   63,   -1,  448,  449,  450,  451,  452,
   -1,  454,   -1,  348,   -1,   -1,  639,   40,  427,  354,
   94,   -1,   45,   -1,   -1,   -1,  435,   -1,   -1,  438,
   -1,   -1,   -1,   93,   94,   -1,   -1,   -1,   -1,  448,
  449,  450,  451,  452,   -1,  454,   -1,   -1,   -1,  639,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  506,   -1,   -1,   -1,   -1,   -1,   -1,
  513,   -1,  407,   -1,   -1,   -1,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   37,   -1,   -1,  639,   41,
   42,   43,  427,   45,  537,   47,   -1,  506,   -1,   -1,
  435,   -1,  447,  438,  513,   -1,   -1,   -1,   -1,   -1,
   -1,   63,   -1,  448,  449,  450,  451,  452,   -1,  454,
   -1,   -1,   -1,   -1,  469,   37,   -1,   -1,  537,   41,
   42,   43,   -1,   45,   -1,   47,   -1,  482,   -1,   -1,
   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   63,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  506,   -1,   -1,   -1,   37,   -1,   -1,  513,   41,
   42,   43,   94,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  639,   -1,   -1,   -1,
   -1,   63,  537,   -1,   -1,   -1,   -1,   -1,   -1,  554,
  555,  556,  557,   -1,  559,  560,  561,  562,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  639,   -1,   94,  256,  257,  258,  259,  260,  261,  262,
  263,  264,  265,  266,  267,  268,  269,  270,  271,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
  293,  294,  295,  296,   -1,  298,  299,  300,  301,  302,
  303,  304,  305,  306,  307,   -1,   -1,  310,  311,   -1,
   -1,   -1,  315,  316,   -1,   -1,   -1,   -1,  321,   -1,
   -1,  324,  325,   -1,  639,   -1,  329,  330,  331,   -1,
   -1,  334,   -1,   -1,   -1,  338,   -1,  340,   -1,   -1,
   -1,   -1,  345,   -1,  347,  348,   -1,  350,  351,   42,
   43,  354,   45,  356,   47,  358,  359,   -1,  361,   -1,
   -1,   -1,   -1,   -1,  367,   58,   -1,   -1,   -1,  372,
   63,   -1,  375,   -1,   -1,   -1,   -1,  380,  381,   -1,
   -1,   -1,  385,  386,  387,  388,   -1,  390,  391,   -1,
   -1,  394,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  402,
   -1,   94,   -1,  406,   -1,   -1,   -1,   -1,  411,  412,
  413,   -1,  415,   -1,   -1,   -1,   -1,  420,   -1,   -1,
   -1,  424,  425,   -1,  427,  428,  429,  430,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,   40,
   -1,   -1,   -1,   -1,   45,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  455,   37,   -1,   -1,   -1,   -1,   42,   43,
   44,   45,   -1,   47,   -1,  468,   -1,   -1,   -1,   -1,
  473,  474,   -1,   -1,   -1,   -1,  479,  480,  481,   63,
  483,  484,  485,  486,   -1,   -1,   -1,   -1,   -1,   -1,
  493,  494,  495,  496,  497,   -1,  499,   -1,   -1,   -1,
  503,  504,   -1,   -1,   -1,  508,   -1,   -1,  511,  512,
   94,   37,   -1,  516,   -1,   41,   42,   43,   -1,   45,
  523,   47,  525,  526,  527,  528,   -1,   -1,   -1,  532,
  533,   -1,   -1,   -1,  537,   -1,  539,   63,   -1,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,  641,  642,
  643,  644,  645,  646,  647,  648,   37,   -1,   -1,   -1,
   41,   42,   43,   -1,   45,   -1,   47,   -1,   94,   -1,
   -1,   -1,  575,  576,  577,  578,  579,  580,  581,  582,
  583,   -1,   63,   -1,  587,  588,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  630,   -1,   -1,
   -1,   -1,  635,  636,  637,  638,  639,  640,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  650,  651,  652,
  653,  654,  655,  656,  657,  658,  257,  258,  259,  260,
  261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
  291,  292,  293,  294,  295,  296,   -1,  298,  299,  300,
  301,  302,  303,  304,  305,   -1,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  338,   -1,   -1,
   -1,   -1,  343,   -1,   -1,   -1,   -1,  348,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   -1,   -1,   37,   -1,   40,   -1,   41,   42,   43,   45,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  383,   -1,   -1,   -1,   -1,   -1,   63,  390,
   -1,   -1,   -1,   -1,   -1,   -1,  397,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  417,   -1,   -1,   94,
  421,   -1,   -1,   37,  425,   -1,  427,   41,   42,   43,
  431,   45,   -1,   47,   -1,   -1,   37,   -1,   -1,   -1,
   41,   42,   43,   -1,   45,   -1,   47,  448,   37,   63,
  451,   -1,   -1,   42,   43,   44,   45,   -1,   47,   -1,
   37,   -1,   63,   -1,   41,   42,   43,   -1,   45,   -1,
   47,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,
   94,   -1,   -1,   -1,   37,  486,   63,   -1,   41,   42,
   43,   -1,   45,   94,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   37,  503,   -1,   -1,   94,   42,   43,   44,   45,
   63,   47,   -1,   37,   -1,   -1,   -1,   94,   42,   43,
   44,   45,   -1,   47,  525,   -1,   -1,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   63,
  541,   94,   -1,   -1,   -1,  546,  547,  548,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,   -1,   94,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   94,   -1,   -1,   -1,  575,  576,  577,  578,  579,  580,
  581,  257,  258,  259,  260,  261,  262,  263,  264,  265,
  266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,  291,  292,  293,  294,  295,
  296,   -1,  298,  299,  300,  301,  302,  303,  304,  305,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  638,  639,  640,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  650,
   -1,  652,  653,  654,  655,  656,  657,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,  343,   -1,   -1,
   -1,   -1,  348,   -1,   -1,   -1,   -1,  353,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,
   -1,   -1,   -1,   -1,   45,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  383,   -1,   -1,
   -1,   -1,   -1,   -1,  390,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,   37,   -1,   -1,   -1,   41,   42,
   43,   -1,   45,   -1,   47,   -1,   -1,   -1,  414,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   37,   -1,
   63,  427,   41,   42,   43,  431,   45,   -1,   47,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   42,   43,
   44,   45,  448,   47,   63,  451,   -1,   -1,   37,   -1,
   -1,   94,   41,   42,   43,   -1,   45,   37,   47,   63,
   -1,   -1,   42,   43,   44,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   63,   94,   -1,   -1,   -1,   -1,
  486,   -1,   -1,   63,   -1,   -1,  492,   -1,   -1,   -1,
   94,   -1,   -1,   37,   -1,   -1,   -1,  503,   42,   43,
   44,   45,   37,   47,   -1,   94,   -1,   42,   43,   44,
   45,   -1,   47,   -1,   94,   42,   43,   44,   45,   63,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   63,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,
  546,  547,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,  575,
  576,  577,  578,  579,  580,  581,  257,  258,  259,  260,
  261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
  291,  292,  293,  294,  295,  296,   -1,  298,  299,  300,
  301,  302,  303,  304,  305,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  638,  639,  640,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,  650,   -1,  652,  653,  654,  655,
  656,  657,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,   -1,   -1,
   -1,   -1,  353,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   40,   -1,   -1,   -1,   -1,   45,
   -1,   -1,   -1,   -1,   -1,   -1,  377,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,  390,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   37,  425,   -1,  427,   41,   42,   43,
  431,   45,   -1,   47,   -1,   -1,   -1,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,  448,   -1,   63,
  451,   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,   -1,   -1,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,   37,   -1,
   94,   -1,   41,   42,   43,  486,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   37,   -1,  503,   -1,   63,   42,   43,   44,   45,   -1,
   47,   37,   -1,   -1,   -1,   41,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   94,   -1,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  546,  547,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,
   -1,   -1,   -1,   -1,  575,  576,  577,  578,  579,  580,
  581,  257,  258,  259,  260,  261,  262,  263,  264,  265,
  266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,  291,  292,  293,  294,  295,
  296,   -1,  298,  299,  300,  301,  302,  303,  304,  305,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  638,  639,  640,
   -1,   -1,   -1,   -1,   -1,   -1,  322,   -1,   -1,  650,
   -1,  652,  653,  654,  655,  656,  657,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  348,   -1,   -1,   -1,   -1,  353,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,   40,
   -1,   -1,   -1,   -1,   45,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,  390,   -1,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,  425,
   -1,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  448,   -1,   -1,  451,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  486,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  503,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  546,  547,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  575,
  576,  577,  578,  579,  580,  581,  257,  258,  259,  260,
  261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
  291,  292,  293,  294,  295,  296,   -1,  298,  299,  300,
  301,  302,  303,  304,  305,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  638,  639,  640,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  650,   -1,  652,  653,  654,  655,
  656,  657,   41,   42,   43,   -1,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   37,   -1,  348,   -1,   41,
   42,   43,  353,   45,   63,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   37,   -1,   40,   -1,   41,   42,   43,   45,
   45,   63,   47,   -1,   -1,   -1,  377,  641,  642,  643,
  644,  645,  646,  647,  648,   94,   37,   -1,   63,  390,
   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   94,   -1,   -1,   37,   -1,   -1,   -1,   41,
   42,   43,   63,   45,   -1,   47,   -1,   -1,   -1,   94,
   -1,   -1,   -1,   -1,  425,   -1,  427,   -1,   -1,   -1,
  431,   63,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   94,   -1,   -1,   -1,  448,   -1,   -1,
  451,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   94,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  486,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  503,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,   -1,
   -1,   45,   -1,   -1,   -1,  546,  547,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  575,  576,  577,  578,  579,  580,
  581,  257,  258,  259,  260,  261,  262,  263,  264,  265,
  266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,  291,  292,  293,  294,  295,
  296,   -1,  298,  299,  300,  301,  302,  303,  304,  305,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  638,  639,  640,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  650,
   -1,  652,  653,  654,  655,  656,  657,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  342,  343,   -1,   -1,
   -1,   -1,  348,   37,   -1,   -1,   -1,   -1,   42,   43,
   44,   45,   37,   47,   -1,   -1,   -1,   42,   43,   44,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   63,
   -1,  377,   -1,   -1,   -1,   -1,   -1,   -1,   63,   -1,
   -1,   -1,   -1,   -1,  390,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  425,
   -1,  427,   -1,  257,  258,  259,  260,  261,  262,  263,
  264,  265,  266,  267,  268,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
  294,  295,  296,   -1,  298,  299,  300,  301,  302,  303,
  304,  305,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  486,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  503,   -1,   -1,
  506,  507,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  348,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   37,
   -1,   40,   -1,   41,   42,   43,   45,   45,   -1,   47,
  546,  547,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   63,  390,   -1,   -1,  393,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  575,
  576,  577,  578,  579,  580,  581,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,
   -1,  425,   -1,  427,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,  448,   -1,   -1,  451,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   -1,   -1,  638,  639,  640,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,  650,   -1,  652,  653,  654,  655,
  656,  657,  486,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   37,  503,
   -1,   -1,  506,   42,   43,   44,   45,   -1,   47,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  546,  547,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  575,  576,  577,  578,  579,  580,  581,  257,  258,
  259,  260,  261,  262,  263,  264,  265,  266,  267,  268,
  269,  270,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,  293,  294,  295,  296,   -1,  298,
  299,  300,  301,  302,  303,  304,  305,   -1,   -1,   -1,
   -1,   -1,   37,   -1,  638,  639,  640,   42,   43,   44,
   45,   -1,   47,   -1,   -1,   -1,  650,   -1,  652,  653,
  654,  655,  656,  657,   -1,   37,   -1,   -1,   63,   -1,
   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,  348,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   63,   -1,   -1,   -1,   -1,   40,   -1,   -1,   94,
   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  390,   94,   -1,  393,   -1,   -1,   -1,   -1,   37,
   -1,   -1,   -1,   -1,   42,   43,   44,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   63,  425,   37,  427,   -1,
   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  448,
   40,   -1,  451,   63,   -1,   45,   94,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   37,   -1,   -1,   -1,   41,
   42,   43,   -1,   45,   94,   47,   37,  486,   -1,   -1,
   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
   -1,   63,   -1,   37,  503,   40,   -1,  506,   42,   43,
   45,   45,   63,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   -1,   -1,   -1,   -1,   63,
   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   94,   -1,   -1,   -1,  546,  547,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  575,  576,  577,  578,
  579,  580,  581,  257,  258,  259,  260,  261,  262,  263,
  264,  265,  266,  267,  268,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
  294,  295,  296,   -1,  298,  299,  300,  301,  302,  303,
  304,  305,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  638,
  639,  640,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,  650,   -1,  652,  653,  654,  655,  656,  657,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,
  260,  261,  262,  263,  264,  265,  266,  267,  268,  269,
  270,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,  296,   -1,  298,  299,
  300,  301,  302,  303,  304,  305,  390,   -1,   -1,   -1,
   -1,   -1,  257,  258,  259,  260,  261,  262,  263,  264,
  265,  266,  267,  268,  269,  270,  271,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,  296,   -1,  298,  299,  300,  301,  302,  303,  304,
  305,   37,   -1,   -1,   -1,   41,   42,   43,   -1,   45,
   -1,   47,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   63,   -1,   -1,
  390,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  486,   37,   -1,   -1,   -1,   41,   42,   43,
   -1,   45,   -1,   47,   -1,   37,   -1,   -1,   94,  503,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   63,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   63,   -1,   -1,   -1,  390,   -1,   -1,   37,   -1,
   -1,   -1,   -1,   42,   43,   44,   45,   -1,   47,   -1,
   94,   -1,  546,  547,   -1,   -1,   -1,   -1,  552,  553,
   -1,   93,   94,   -1,   63,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  486,   -1,   -1,   -1,
   -1,  575,  576,  577,  578,  579,  580,  581,   -1,   40,
   -1,  585,  586,  503,   45,   94,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  352,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   -1,  486,   -1,   -1,   -1,   -1,  546,  547,  373,   -1,
   -1,   -1,  552,  553,  638,  639,  640,   37,  503,   -1,
   -1,   41,   42,   43,   -1,   45,  650,   47,  652,  653,
  654,  655,  656,  657,   -1,  575,  576,  577,  578,  579,
  580,  581,   40,   63,   -1,  585,  586,   45,   -1,   -1,
   -1,   -1,  537,  641,  642,  643,  644,  645,  646,  647,
  648,  546,  547,   37,   -1,   -1,   -1,   41,   42,   43,
   -1,   45,   -1,   47,   94,   -1,   -1,   -1,   -1,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   63,
  575,  576,  577,  578,  579,  580,  581,   40,  638,  639,
  640,   -1,   45,   -1,   -1,  470,   -1,   -1,   -1,   -1,
  650,   -1,  652,  653,  654,  655,  656,  657,   -1,   -1,
   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   -1,
   -1,   -1,   -1,  638,  639,  640,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,  650,   -1,  652,  653,  654,
  655,  656,  657,   -1,   -1,   -1,  257,  258,  259,  260,
  261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
  291,  292,  293,  294,  295,  296,   -1,  298,  299,  300,
  301,  302,  303,  304,  305,   -1,   -1,   -1,  593,  594,
  595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
  605,  606,  607,  608,  609,  610,  611,  612,  613,  614,
  615,  616,  617,  618,   -1,   -1,   -1,   -1,   -1,  257,
  258,  259,  260,  261,  262,  263,  264,  265,  266,  267,
  268,  269,  270,  271,  272,  273,  274,  275,  276,  277,
  278,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,  296,   -1,
  298,  299,  300,  301,  302,  303,  304,  305,   -1,  390,
   -1,   -1,   -1,   -1,  257,  258,  259,  260,  261,  262,
  263,  264,  265,  266,  267,  268,  269,  270,  271,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
  293,  294,  295,  296,   -1,  298,  299,  300,  301,  302,
  303,  304,  305,   37,   -1,   -1,   -1,   41,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,   37,   -1,   -1,   -1,
   41,   42,   43,   -1,   45,   -1,   47,   -1,   37,   63,
   -1,   -1,  390,   42,   43,   44,   45,   -1,   47,   -1,
   -1,   -1,   63,   -1,   -1,  486,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,
   94,   -1,  503,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   94,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   94,   -1,  390,   -1,   -1,
   -1,   -1,   37,   -1,   -1,   -1,  537,   42,   43,   44,
   45,   -1,   47,   -1,   -1,  546,  547,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,   63,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,  486,   -1,
   -1,   -1,   -1,   -1,  575,  576,  577,  578,  579,  580,
  581,   40,   -1,   -1,   -1,  503,   45,   -1,   -1,   94,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   37,   -1,   -1,
   -1,   41,   42,   43,   -1,   45,   37,   47,   -1,   -1,
   41,   42,   43,  486,   45,   -1,   47,   -1,  546,  547,
   -1,   -1,   -1,   63,   -1,   -1,   -1,  638,  639,  640,
  503,   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,  650,
   -1,  652,  653,  654,  655,  656,  657,  575,  576,  577,
  578,  579,  580,  581,   94,   -1,   37,   -1,   -1,   -1,
   41,   42,   43,   94,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,  546,  547,   37,   -1,   -1,   -1,   41,
   42,   43,   63,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
   -1,   63,  575,  576,  577,  578,  579,  580,  581,   -1,
  638,  639,  640,   94,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  650,   -1,  652,  653,  654,  655,  656,  657,
   -1,   -1,   94,   -1,   -1,   -1,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  638,  639,  640,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  650,   -1,  652,
  653,  654,  655,  656,  657,   -1,   -1,   -1,  257,  258,
  259,  260,  261,  262,  263,  264,  265,  266,  267,  268,
  269,  270,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,  293,  294,  295,  296,   -1,  298,
  299,  300,  301,  302,  303,  304,  305,   37,   -1,   -1,
   -1,   41,   42,   43,   -1,   45,   37,   47,   -1,   -1,
   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
   37,   -1,   -1,   63,   41,   42,   43,   -1,   45,   37,
   47,   -1,   63,   41,   42,   43,   -1,   45,   -1,   47,
   -1,   -1,   37,   -1,   -1,   -1,   63,   42,   43,   44,
   45,   -1,   47,   -1,   94,   63,   37,   -1,   -1,   -1,
   41,   42,   43,   94,   45,   37,   47,   -1,   63,   41,
   42,   43,   -1,   45,   -1,   47,   -1,   94,   -1,   37,
   -1,  390,   63,   41,   42,   43,   94,   45,   37,   47,
   -1,   63,   -1,   42,   43,   44,   45,   -1,   47,   94,
   -1,   37,   -1,   -1,   -1,   63,   42,   43,   44,   45,
   -1,   47,   -1,   94,   63,   -1,   -1,   -1,   37,   -1,
   -1,   -1,   94,   42,   43,   44,   45,   63,   47,   -1,
   -1,   -1,   -1,   37,   -1,   -1,   94,   -1,   42,   43,
   44,   45,   -1,   47,   63,   94,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,   63,
   -1,   37,   -1,   -1,   -1,   41,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   -1,   94,   -1,  486,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   63,   -1,   -1,
   94,   -1,   -1,   -1,  503,   -1,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   94,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  546,  547,   37,
   -1,   -1,   -1,   41,   42,   43,   -1,   45,   37,   47,
   -1,   -1,   -1,   42,   43,   44,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   63,  575,  576,  577,  578,
  579,  580,  581,   -1,   63,   37,   -1,   -1,   -1,   41,
   42,   43,   -1,   45,   -1,   47,  641,  642,  643,  644,
  645,  646,  647,  648,   37,   -1,   94,   -1,   41,   42,
   43,   63,   45,   -1,   47,   94,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   63,   -1,   -1,   -1,   -1,   -1,   -1,   63,   37,  638,
  639,  640,   94,   42,   43,   44,   45,   -1,   47,   -1,
   -1,  650,   -1,  652,  653,  654,  655,  656,  657,   -1,
   -1,   94,   -1,   -1,   63,   -1,   -1,   -1,   94,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   37,   -1,
   -1,   -1,   41,   42,   43,   94,   45,   -1,   47,   -1,
   37,   -1,   -1,   -1,   41,   42,   43,   -1,   45,   -1,
   47,   -1,   37,   -1,   63,   -1,   -1,   42,   43,   -1,
   45,   -1,   47,   -1,   -1,   -1,   63,   -1,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   63,   -1,
   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   94,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   37,   -1,   93,   94,
   41,   42,   43,   -1,   45,   37,   47,   -1,   -1,   41,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   37,
   -1,   -1,   63,   41,   42,   43,   -1,   45,   37,   47,
   -1,   63,   41,   42,   43,   -1,   45,   -1,   47,   -1,
   -1,   -1,   37,   -1,   -1,   63,   41,   42,   43,   -1,
   45,   37,   47,   94,   63,   41,   42,   43,   -1,   45,
   -1,   47,   94,   -1,   37,   -1,   -1,   -1,   63,   42,
   43,   -1,   45,   -1,   47,   -1,   94,   63,   -1,   -1,
   -1,   37,   -1,   -1,   -1,   94,   42,   43,   44,   45,
   63,   47,   37,   -1,   -1,   -1,   41,   42,   43,   94,
   45,   -1,   47,   -1,   37,   -1,   -1,   63,   94,   42,
   43,   44,   45,   -1,   47,   -1,   -1,   -1,   63,   -1,
   93,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   94,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   -1,
   -1,   94,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   37,   -1,   -1,
   -1,   -1,   42,   43,   44,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   63,   37,   -1,   -1,   -1,   -1,   42,
   43,   44,   45,   37,   47,   -1,   -1,   -1,   42,   43,
   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   63,   -1,   -1,   -1,   94,   -1,   37,   -1,   -1,   63,
   -1,   42,   43,   44,   45,   37,   47,   -1,   -1,   41,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   94,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   94,   63,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   37,   -1,   94,   -1,   41,   42,   43,   -1,   45,
   -1,   47,   94,   -1,   -1,   -1,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,  642,  643,  644,  645,
  646,  647,  648,   -1,   37,   -1,   -1,   -1,   94,   42,
   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   63,   -1,   -1,   -1,   -1,   -1,   37,   -1,   -1,   -1,
   -1,   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   94,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   94,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,
   37,   -1,   -1,   -1,   41,   42,   43,   -1,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   94,   -1,   -1,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,   -1,   -1,   -1,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   37,   -1,   -1,   -1,
   41,   42,   43,   -1,   45,   37,   47,   -1,   -1,   41,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   37,
   -1,   -1,   63,   41,   42,   43,   -1,   45,   37,   47,
   -1,   63,   41,   42,   43,   -1,   45,   -1,   47,   -1,
   -1,   37,   -1,   -1,   -1,   63,   42,   43,   44,   45,
   -1,   47,   -1,   94,   63,   -1,   -1,   -1,   37,   -1,
   -1,   -1,   94,   42,   43,   44,   45,   63,   47,   -1,
   -1,   -1,   -1,   37,   -1,   -1,   94,   -1,   42,   43,
   44,   45,   37,   47,   63,   94,   -1,   42,   43,   44,
   45,   -1,   47,   -1,   -1,   37,   -1,   -1,   94,   63,
   42,   43,   -1,   45,   -1,   47,   37,   -1,   63,   -1,
   -1,   42,   43,   44,   45,   94,   47,   -1,   -1,   -1,
   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   37,   -1,
   94,   -1,   63,   42,   43,   44,   45,   -1,   47,   94,
   37,   -1,   -1,   -1,   -1,   42,   43,   44,   45,   -1,
   47,   93,   94,   -1,   63,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   94,   -1,   -1,   63,   -1,   -1,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   37,   -1,   -1,
   -1,   -1,   42,   43,   44,   45,   37,   47,   -1,   -1,
   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
   37,   -1,   -1,   63,   41,   42,   43,   -1,   45,   -1,
   47,   -1,   63,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   37,   -1,   -1,   63,   -1,   42,   43,
   -1,   45,   37,   47,   94,   -1,   -1,   42,   43,   44,
   45,   -1,   47,   94,   41,   42,   43,   -1,   45,   63,
   47,   -1,   -1,   -1,   -1,   37,   -1,   94,   63,   -1,
   42,   43,   44,   45,   -1,   47,   63,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,   93,
   94,   63,   -1,   -1,   -1,   37,   -1,   -1,   -1,   94,
   42,   43,   44,   45,   -1,   47,   -1,   94,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   37,   -1,
   -1,   63,   94,   42,   43,   44,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   37,   -1,   -1,   -1,   -1,
   42,   43,   44,   45,   63,   47,   -1,   -1,   -1,   -1,
   37,   -1,   94,   -1,   41,   42,   43,   -1,   45,   -1,
   47,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   37,   -1,   94,   63,   41,   42,   43,
   -1,   45,   -1,   47,  641,  642,  643,  644,  645,  646,
  647,  648,   94,   -1,   -1,   37,   -1,   -1,   -1,   63,
   42,   43,   -1,   45,   -1,   47,   37,   94,   -1,   -1,
   -1,   42,   43,   44,   45,   -1,   47,   37,   -1,   -1,
   -1,   63,   42,   43,   44,   45,   -1,   47,   37,   -1,
   94,   -1,   63,   42,   43,   44,   45,   -1,   47,   37,
   -1,   -1,   -1,   63,   42,   43,   44,   45,   -1,   47,
   37,   93,   94,   -1,   63,   42,   43,   44,   45,   -1,
   47,   37,   -1,   94,   -1,   63,   42,   43,   -1,   45,
   -1,   47,   37,   -1,   94,   -1,   63,   42,   43,   -1,
   45,   -1,   47,   -1,   -1,   94,   -1,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,   63,   -1,
   -1,   -1,   -1,   -1,   37,   -1,   -1,   94,   -1,   42,
   43,   44,   45,   -1,   47,   -1,   -1,   93,   94,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,
   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   -1,   94,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,   41,   42,   43,   -1,   45,   -1,
   47,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,   -1,   -1,   63,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   94,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   41,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   63,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   37,   -1,   -1,   -1,   -1,   42,   43,   44,
   45,   37,   47,   -1,   -1,   -1,   42,   43,   44,   45,
   -1,   47,   94,   -1,   37,   -1,   -1,   -1,   63,   42,
   43,   -1,   45,   -1,   47,   37,   -1,   63,   -1,   -1,
   42,   43,   -1,   45,   -1,   47,   -1,   41,   42,   43,
   63,   45,   -1,   47,   -1,   -1,   41,   42,   43,   94,
   45,   63,   47,   -1,   -1,   -1,   -1,   -1,   94,   63,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   63,   -1,
   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   94,  641,  642,  643,  644,  645,  646,  647,  648,   94,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   -1,
   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,  641,  642,  643,  644,  645,  646,
  647,  648,   41,   42,   43,   -1,   45,   -1,   47,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   63,   41,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   63,   -1,   -1,
   41,   42,   43,   -1,   45,   94,   47,   -1,   -1,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,   94,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   94,  529,   41,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   63,   42,   43,
   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   63,
  641,  642,  643,  644,  645,  646,  647,  648,   94,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   94,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   41,   42,   43,   -1,   45,   -1,
   47,   -1,   -1,   -1,   41,   42,   43,   -1,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,   63,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   63,   41,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,   41,   42,   43,   -1,
   45,   -1,   47,   -1,   41,   42,   43,   94,   45,   63,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   94,   63,   41,
   42,   43,   -1,   45,   -1,   47,   63,   -1,   41,   42,
   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   94,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,
   63,   -1,   41,   42,   43,   -1,   45,   94,   47,   -1,
   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   94,   -1,   63,   -1,   -1,   -1,   -1,   -1,
   -1,   94,   -1,   -1,   41,   42,   43,   -1,   45,   -1,
   47,   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   94,   63,   42,   43,   44,
   45,   -1,   47,   -1,   63,   -1,   -1,   -1,   -1,   -1,
   -1,   41,   42,   43,   -1,   45,   -1,   47,   63,  641,
  642,  643,  644,  645,  646,  647,  648,   94,   -1,   -1,
   -1,   -1,   -1,   63,   -1,   94,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,
   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   94,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,   -1,   -1,   -1,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   41,   42,   43,   -1,   45,   -1,
   47,   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,
   -1,   41,   42,   43,   -1,   45,   63,   47,   -1,   41,
   42,   43,   -1,   45,   63,   47,   -1,  352,   41,   42,
   43,   -1,   45,   63,   47,   -1,   41,   42,   43,   -1,
   45,   63,   47,   -1,   -1,   -1,   -1,   94,  373,   -1,
   63,   -1,   -1,   -1,   -1,   94,   -1,   -1,   63,   -1,
   -1,   41,   42,   43,   94,   45,   -1,   47,   -1,   41,
   42,   43,   94,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   94,   -1,   63,   -1,   -1,   -1,   -1,   -1,   94,
   -1,   63,   -1,   41,   42,   43,   -1,   45,   -1,   47,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,   94,   63,   -1,   41,   42,   43,
   -1,   45,   94,   47,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,   -1,   -1,   41,   42,   43,   63,
   45,   -1,   47,   -1,   -1,  470,   94,   -1,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   63,   -1,
   -1,   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,
   94,   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   63,   42,   43,   44,   45,   -1,   47,   94,
   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   63,  641,  642,  643,  644,  645,
  646,  647,  648,   94,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   94,   -1,   -1,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   94,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  593,  594,
  595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
  605,  606,  607,  608,  609,  610,  611,  612,  613,  614,
  615,  616,  617,  618,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  639,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,  641,
  642,  643,  644,  645,  646,  647,  648,  281,   -1,  283,
  284,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  313,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,  317,   -1,  319,   -1,   -1,
   -1,   -1,  336,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,  348,   -1,   -1,  333,  334,  335,
  354,  343,   -1,   -1,   -1,   -1,  348,   -1,  344,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,  383,   -1,  385,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  407,   -1,  397,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  406,   -1,  414,  427,   -1,  417,   -1,   -1,   -1,   -1,
   -1,  435,   -1,   -1,  438,  427,   -1,   -1,   -1,  431,
   -1,   -1,   -1,   -1,  448,  449,  450,  451,  452,   -1,
  454,   -1,   -1,   -1,   -1,   -1,  448,   -1,   -1,  451,
  452,  447,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  471,
  472,   -1,   -1,  469,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  482,   -1,   -1,   -1,
   -1,   -1,  506,   -1,   -1,   -1,   -1,   -1,   -1,  513,
   -1,   -1,   -1,  505,   -1,  507,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  520,  521,
   -1,   -1,  524,  537,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  537,   -1,   -1,   -1,  541,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  348,  349,  554,  555,
  556,  557,   -1,  559,  560,  561,  562,  563,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  371,
   -1,   -1,   -1,   -1,   -1,  377,   -1,   -1,   -1,   -1,
   -1,  383,   -1,  385,  348,  349,   -1,   -1,   -1,   -1,
   -1,  348,  349,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  404,   -1,   -1,   -1,   -1,  371,   -1,   -1,
   -1,   -1,   -1,  377,  371,  639,   -1,   -1,   -1,  383,
  377,  385,   -1,  425,   -1,  427,  383,  639,  385,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  439,   -1,   -1,
  404,   -1,   -1,   -1,   -1,   -1,  448,  404,   -1,  451,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  425,   -1,  427,   -1,   -1,   -1,   -1,  425,  471,
  427,   -1,   -1,   -1,   -1,  439,   -1,   -1,   -1,   -1,
   -1,   -1,  439,   -1,  448,   -1,   -1,  451,   -1,   -1,
   -1,  448,   -1,   -1,  451,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  506,  507,   -1,  471,   -1,   -1,
   -1,   -1,   -1,   -1,  471,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  528,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  537,   -1,   -1,   -1,   -1,
   -1,   -1,  506,  507,   -1,   -1,   -1,   -1,   -1,  506,
  507,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  528,   -1,   -1,   -1,   -1,  571,
   -1,  528,   -1,  537,   -1,   -1,   -1,   -1,   -1,   -1,
  537,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  571,   -1,   -1,
   -1,   -1,   -1,   -1,  571,
};
#define YYFINAL 171
#ifndef YYDEBUG
#define YYDEBUG 1
#endif
#define YYMAXTOKEN 658
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,"'\\n'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'%'",0,0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,0,0,0,0,
0,0,0,0,0,"':'",0,0,"'='",0,"'?'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,"'['",0,"']'","'^'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"ABS","ACOS","ASIN","ATAN","ATAN2","CEIL","COS",
"DEG","DX","DY","ERF","ERFC","EXP","FLOOR","HYPOT","INDEX","INT","INVN","INVT",
"IRAND","JDAY","JDAY0","LGAMMA","LN","LOG","LOGISTIC","MAXP","MINP","MOD",
"NORM","NORMP","PI","RAD","RAND","RNORM","SETNO","SIN","SQR","SQRT","TAN",
"INUM","VX1","VX2","VY1","VY2","WX1","WX2","WY1","WY2","DELAYP","DOUBLEBUFFER",
"DOWN","ABSOLUTE","ABORT","ACTIVATE","ACTIVE","ALT","ALTERNATE","ALTXAXIS",
"ALTYAXIS","ANGLE","ANNOTATE","APPEND","AREA","ARRANGE","ARROW","ASCENDING",
"AUTO","AUTOSCALE","AUTOTICKS","AVG","AXIS","AXES","BACKBUFFER","BACKGROUND",
"BAR","BATCH","BLOCK","BIN","BOTH","BOTTOM","BOX","BOXPLOT","CD","CELLS",
"CENTER","CHAR","CHRSTR","CLEAR","CLICK","CMAP","COLOR","COMMENT","COPY",
"CYCLE","DECIMAL","DEF","DEFAULT","DELETE","DEVICE","DESCENDING","DFT",
"DIFFERENCE","DISK","DRAW2","DROP","DXDX","DXP","DYDY","DYP","ECHO","EDIT",
"ELSE","END","ERRORBAR","EXIT","EXPONENTIAL","FALSEP","FFT","FILEP","FILL",
"FIND","FIXEDPOINT","FLUSH","FOCUS","FOLLOWS","FONTP","FOREGROUND","FORMAT",
"FRONTBUFFER","FRAMEP","GETP","GRAPH","GRAPHNO","GRAPHS","GRAPHTYPE","GRID",
"HARDCOPY","HBAR","HBOXPLOT","HGAP","HIDDEN","HORIZONTAL","HPGLL","HPGLP",
"HISTO","IF","IGNORE","IHL","IMAGE","IN","INIT","INOUT","INTEGRATE","INTERP",
"INVDFT","INVFFT","JUST","KILL","LABEL","LAYOUT","LEAVE","LEFT","LEGEND",
"LENGTH","LEVEL","LEVELS","LINE","LINESTYLE","LINETO","LINEWIDTH","LINK","LOAD",
"LOCATOR","LOCTYPE","LOGX","LOGY","LOGXY","MAJOR","MIFL","MIFP","MINOR",
"MISSINGP","MOVE","MOVE2","MOVETO","NEGATE","NO","NONE","NORMAL","NXY","OFF",
"OFFSETX","OFFSETY","ON","OP","ORIENT","OUT","PAGE","PARA","PARALLEL",
"PARAMETERS","PARAMS","PATTERN","PERIMETER","PERP","PERPENDICULAR","PIE","PIPE",
"PLACE","POINT","POLAR","POLY","POWER","PREC","PREPEND","PRINT","PS","PSCOLORP",
"PSMONOP","PSCOLORL","PSMONOL","PUSH","POP","PUTP","RAWSPICE","READ","REDRAW",
"REGRESS","REGNUM","REGIONS","RENDER","REVERSE","RIGHT","RISER","ROT","RUNAVG",
"RUNMED","RUNSTD","RUNMIN","RUNMAX","SAMPLE","SAVEALL","SCALE","SCIENTIFIC",
"SET","SETNUM","SETS","SIGN","SIZE","SKIP","SLEEP","SLICE","SMITH","SORT",
"SOURCE","SPEC","SPECIFIED","SPECTRUM","STACK","STACKEDBAR","STACKEDHBAR",
"STACKEDLINE","STAGGER","START","STARTTYPE","STATUS","STOP","STRING","SUBTITLE",
"SWAPBUFFER","SYMBOL","TICKP","TICKLABEL","TICKMARKS","TIME","TITLE","TO","TOP",
"TRUEP","TYPE","UP","VELOCITY","VERTICAL","VGAP","VIEW","WITH","WORLD","WRITE",
"X","X0","X1","XAXES","XAXIS","XCOR","XMAX","XMIN","XY","XYARC","XYBOX",
"XYBOXPLOT","XYFIXED","XYHILO","XYRT","XYSEG","XYSTRING","XYDX","XYDY","XYDXDX",
"XYDYDY","XYDXDY","XYX2Y2","XYXX","XYYY","XYZ","XYZW","XYUV","TSV","Y","Y0",
"Y1","Y2","Y3","Y4","Y5","YAXES","YAXIS","YES","YMAX","YMIN","ZEROXAXIS",
"ZEROYAXIS","ABOVE","BELOW","POLYI","POLYO","GENERAL","DDMMYY","YYMMDD",
"MMDDYY","MMYY","MMDD","MONTHDAY","DAYMONTH","MONTHS","MONTHSY","MONTHL",
"DAYOFWEEKS","DAYOFWEEKL","DAYOFYEAR","HMS","MMDDHMS","MMDDYYHMS","YYMMDDHMS",
"DEGREESLON","DEGREESMMLON","DEGREESMMSSLON","MMSSLON","DEGREESLAT",
"DEGREESMMLAT","DEGREESMMSSLAT","MMSSLAT","DOT","STAR","PLUS","CROSS","CIRCLE",
"SQUARE","DIAMOND","TRIANGLE1","TRIANGLE2","TRIANGLE3","TRIANGLE4","SPLINE",
"LANDSCAPE","PORTRAIT","FREE","FIXED","STATUSBAR","LOCATORBAR","TOOLBAR","VAR",
"NUMBER","FITPARM","OR","AND","GT","LT","LE","GE","EQ","NE","UMINUS","NOT",
"ELLIPSE","ACOSH","ASINH","ATANH","COSH","SINH","TANH","ASPLINE",
};
char *yyrule[] = {
"$accept : list",
"list :",
"list : asgn '\\n'",
"list : vasgn '\\n'",
"list : rasgn '\\n'",
"list : expr '\\n'",
"list : vexpr '\\n'",
"list : parmset '\\n'",
"list : regionset '\\n'",
"list : setaxis '\\n'",
"list : setvelocity '\\n'",
"list : set_setprop '\\n'",
"list : setprint '\\n'",
"list : error '\\n'",
"setprint : PRINT printer CHRSTR",
"setprint : PRINT TO printer CHRSTR",
"setprint : PRINT TO printer",
"setprint : DEVICE NUMBER",
"setprint : HARDCOPY DEVICE NUMBER",
"setprint : HARDCOPY",
"setprint : PS LINEWIDTH NUMBER",
"printer : PSMONOP",
"printer : PSMONOL",
"printer : MIFP",
"printer : MIFL",
"printer : HPGLP",
"printer : HPGLL",
"printer : HARDCOPY",
"printer : FILEP",
"regionset : REGNUM onoff",
"regionset : REGNUM TYPE regiontype",
"regionset : REGNUM COLOR NUMBER",
"regionset : REGNUM LINESTYLE NUMBER",
"regionset : REGNUM LINEWIDTH NUMBER",
"regionset : REGNUM LINE expr ',' expr ',' expr ',' expr",
"regionset : REGNUM XY expr ',' expr",
"regionset : LINK REGNUM TO GRAPHNO",
"parmset : REDRAW",
"parmset : AUTO REDRAW onoff",
"parmset : CD CHRSTR",
"parmset : ECHO CHRSTR",
"parmset : STATUS",
"parmset : BACKGROUND COLOR NUMBER",
"parmset : CMAP NUMBER ',' NUMBER ',' NUMBER ',' NUMBER",
"parmset : EXIT",
"parmset : PAGE LAYOUT pagelayout",
"parmset : STATUSBAR onoff",
"parmset : TOOLBAR onoff",
"parmset : LOCATORBAR onoff",
"parmset : DRAW2 expr ',' expr",
"parmset : MOVE2 expr ',' expr",
"parmset : SYMBOL expr ',' expr ',' NUMBER",
"parmset : COLOR NUMBER",
"parmset : LINEWIDTH NUMBER",
"parmset : LINESTYLE NUMBER",
"parmset : WRITE STRING expr ',' expr ',' CHRSTR",
"parmset : PAGE direction",
"parmset : PAGE NUMBER",
"parmset : PAGE INOUT NUMBER",
"parmset : LINK PAGE onoff",
"parmset : DOUBLEBUFFER torf",
"parmset : FRONTBUFFER torf",
"parmset : BACKBUFFER torf",
"parmset : SWAPBUFFER",
"parmset : SLEEP NUMBER",
"parmset : DELAYP NUMBER",
"parmset : ABORT torf",
"parmset : GETP CHRSTR",
"parmset : PUTP CHRSTR",
"parmset : WITH GRAPHNO",
"parmset : WITH SETNUM",
"parmset : SETNUM LINK sourcetype CHRSTR",
"parmset : GRAPHNO '.' SETNUM LINK sourcetype CHRSTR",
"parmset : SETNUM LINK onoff",
"parmset : GRAPHNO '.' SETNUM LINK onoff",
"parmset : ACTIVATE SETNUM NUMBER",
"parmset : ACTIVATE GRAPHNO '.' SETNUM NUMBER",
"parmset : SETNUM LENGTH NUMBER",
"parmset : GRAPHNO '.' SETNUM LENGTH NUMBER",
"parmset : SETNUM POINT expr ',' expr",
"parmset : GRAPHNO '.' SETNUM POINT expr ',' expr",
"parmset : SETNUM DROP NUMBER ',' NUMBER",
"parmset : GRAPHNO '.' SETNUM DROP NUMBER ',' NUMBER",
"parmset : SORT SETNUM sorton sortdir",
"parmset : COPY SETNUM TO SETNUM",
"parmset : COPY GRAPHNO '.' SETNUM TO GRAPHNO '.' SETNUM",
"parmset : MOVE SETNUM TO SETNUM",
"parmset : MOVE GRAPHNO '.' SETNUM TO GRAPHNO '.' SETNUM",
"parmset : KILL SETNUM",
"parmset : KILL SETS",
"parmset : KILL SETNUM SAVEALL",
"parmset : KILL SETS SAVEALL",
"parmset : KILL GRAPHNO",
"parmset : KILL GRAPHS",
"parmset : FLUSH",
"parmset : ARRANGE NUMBER ',' NUMBER",
"parmset : LOAD VAR NUMBER ',' expr ',' expr",
"parmset : REGRESS '(' SETNUM ',' NUMBER ')'",
"parmset : runtype '(' SETNUM ',' NUMBER ')'",
"parmset : ffttype '(' SETNUM ',' NUMBER ')'",
"parmset : SPLINE '(' SETNUM ',' expr ',' expr ',' NUMBER ')'",
"parmset : ASPLINE '(' SETNUM ',' expr ',' expr ',' NUMBER ')'",
"parmset : INTERP '(' SETNUM ',' SETNUM ',' NUMBER ')'",
"parmset : HISTO '(' SETNUM ',' expr ',' expr ',' NUMBER ')'",
"parmset : DIFFERENCE '(' SETNUM ',' NUMBER ')'",
"parmset : INT '(' SETNUM ')'",
"parmset : AUTOSCALE",
"parmset : AUTOSCALE XAXES",
"parmset : AUTOSCALE YAXES",
"parmset : AUTOSCALE SETNUM",
"parmset : LOCATOR onoff",
"parmset : FOCUS GRAPHNO",
"parmset : FOCUS onoff",
"parmset : FOCUS SET",
"parmset : FOCUS FOLLOWS",
"parmset : FOCUS CLICK",
"parmset : SOURCE sourcetype",
"parmset : TYPE xytype",
"parmset : FORMAT formatchoice",
"parmset : READ CHRSTR",
"parmset : READ BATCH CHRSTR",
"parmset : READ BLOCK CHRSTR",
"parmset : READ BLOCK sourcetype CHRSTR",
"parmset : BLOCK xytype CHRSTR",
"parmset : READ xytype CHRSTR",
"parmset : READ xytype sourcetype CHRSTR",
"parmset : READ IMAGE CHRSTR",
"parmset : WRITE IMAGE CHRSTR",
"parmset : IMAGE XY NUMBER ',' NUMBER",
"parmset : WRITE SETNUM",
"parmset : WRITE SETNUM FORMAT CHRSTR",
"parmset : WRITE SETNUM FILEP CHRSTR",
"parmset : WRITE SETNUM FILEP CHRSTR FORMAT CHRSTR",
"parmset : SAVEALL CHRSTR",
"parmset : PUSH",
"parmset : POP",
"parmset : CYCLE",
"parmset : STACK NUMBER",
"parmset : STACK WORLD expr ',' expr ',' expr ',' expr TICKP expr ',' expr ',' expr ',' expr",
"parmset : CLEAR STACK",
"parmset : CLEAR BOX",
"parmset : WITH BOX",
"parmset : WITH BOX NUMBER",
"parmset : BOX onoff",
"parmset : BOX GRAPHNO",
"parmset : BOX expr ',' expr ',' expr ',' expr",
"parmset : BOX LOCTYPE worldview",
"parmset : BOX LINESTYLE NUMBER",
"parmset : BOX LINEWIDTH NUMBER",
"parmset : BOX COLOR NUMBER",
"parmset : BOX FILL filltype",
"parmset : BOX FILL COLOR NUMBER",
"parmset : BOX FILL PATTERN NUMBER",
"parmset : BOX DEF",
"parmset : CLEAR ELLIPSE",
"parmset : WITH ELLIPSE",
"parmset : WITH ELLIPSE NUMBER",
"parmset : ELLIPSE onoff",
"parmset : ELLIPSE GRAPHNO",
"parmset : ELLIPSE expr ',' expr ',' expr ',' expr",
"parmset : ELLIPSE LOCTYPE worldview",
"parmset : ELLIPSE LINESTYLE NUMBER",
"parmset : ELLIPSE LINEWIDTH NUMBER",
"parmset : ELLIPSE COLOR NUMBER",
"parmset : ELLIPSE FILL filltype",
"parmset : ELLIPSE FILL COLOR NUMBER",
"parmset : ELLIPSE FILL PATTERN NUMBER",
"parmset : ELLIPSE DEF",
"parmset : WITH LINE",
"parmset : WITH LINE NUMBER",
"parmset : CLEAR LINE",
"parmset : LINE onoff",
"parmset : LINE GRAPHNO",
"parmset : LINE expr ',' expr ',' expr ',' expr",
"parmset : LINE LOCTYPE worldview",
"parmset : LINE LINEWIDTH NUMBER",
"parmset : LINE LINESTYLE NUMBER",
"parmset : LINE COLOR NUMBER",
"parmset : LINE ARROW NUMBER",
"parmset : LINE ARROW SIZE NUMBER",
"parmset : LINE ARROW TYPE NUMBER",
"parmset : LINE DEF",
"parmset : CLEAR STRING",
"parmset : WITH STRING",
"parmset : WITH STRING NUMBER",
"parmset : STRING onoff",
"parmset : STRING GRAPHNO",
"parmset : STRING expr ',' expr",
"parmset : STRING LOCTYPE worldview",
"parmset : STRING LINEWIDTH NUMBER",
"parmset : STRING COLOR NUMBER",
"parmset : STRING ROT NUMBER",
"parmset : STRING FONTP NUMBER",
"parmset : STRING JUST NUMBER",
"parmset : STRING CHAR SIZE NUMBER",
"parmset : STRING DEF CHRSTR",
"parmset : TIME STRING onoff",
"parmset : TIME STRING FONTP NUMBER",
"parmset : TIME STRING CHAR SIZE NUMBER",
"parmset : TIME STRING COLOR NUMBER",
"parmset : TIME STRING LINEWIDTH NUMBER",
"parmset : TIME STRING NUMBER ',' NUMBER",
"parmset : DEFAULT LINESTYLE NUMBER",
"parmset : DEFAULT LINEWIDTH NUMBER",
"parmset : DEFAULT COLOR NUMBER",
"parmset : DEFAULT CHAR SIZE NUMBER",
"parmset : DEFAULT FONTP NUMBER",
"parmset : DEFAULT FONTP SOURCE NUMBER",
"parmset : DEFAULT SYMBOL SIZE NUMBER",
"parmset : WORLD expr ',' expr ',' expr ',' expr",
"parmset : WORLD XMIN expr",
"parmset : WORLD XMAX expr",
"parmset : WORLD YMIN expr",
"parmset : WORLD YMAX expr",
"parmset : POLAR WORLD expr ',' expr",
"parmset : VIEW expr ',' expr ',' expr ',' expr",
"parmset : VIEW XMIN NUMBER",
"parmset : VIEW XMAX NUMBER",
"parmset : VIEW YMIN NUMBER",
"parmset : VIEW YMAX NUMBER",
"parmset : TITLE CHRSTR",
"parmset : TITLE FONTP NUMBER",
"parmset : TITLE SIZE NUMBER",
"parmset : TITLE COLOR NUMBER",
"parmset : TITLE LINEWIDTH NUMBER",
"parmset : SUBTITLE CHRSTR",
"parmset : SUBTITLE FONTP NUMBER",
"parmset : SUBTITLE SIZE NUMBER",
"parmset : SUBTITLE COLOR NUMBER",
"parmset : SUBTITLE LINEWIDTH NUMBER",
"parmset : GRAPHS MAXP SETS NUMBER",
"parmset : LEGEND onoff",
"parmset : LEGEND LOCTYPE worldview",
"parmset : LEGEND LAYOUT NUMBER",
"parmset : LEGEND VGAP NUMBER",
"parmset : LEGEND HGAP NUMBER",
"parmset : LEGEND LENGTH NUMBER",
"parmset : LEGEND BOX onoff",
"parmset : LEGEND BOX FILL onoff",
"parmset : LEGEND BOX FILL WITH colpat",
"parmset : LEGEND BOX FILL colpat NUMBER",
"parmset : LEGEND BOX COLOR NUMBER",
"parmset : LEGEND BOX LINESTYLE NUMBER",
"parmset : LEGEND BOX LINEWIDTH NUMBER",
"parmset : LEGEND expr ',' expr",
"parmset : LEGEND X1 expr",
"parmset : LEGEND Y1 expr",
"parmset : LEGEND CHAR SIZE NUMBER",
"parmset : LEGEND FONTP NUMBER",
"parmset : LEGEND LINESTYLE NUMBER",
"parmset : LEGEND LINEWIDTH NUMBER",
"parmset : LEGEND COLOR NUMBER",
"parmset : LEGEND STRING NUMBER CHRSTR",
"parmset : FRAMEP onoff",
"parmset : FRAMEP TYPE NUMBER",
"parmset : FRAMEP LINESTYLE NUMBER",
"parmset : FRAMEP LINEWIDTH NUMBER",
"parmset : FRAMEP COLOR NUMBER",
"parmset : FRAMEP FILL onoff",
"parmset : FRAMEP BACKGROUND COLOR NUMBER",
"parmset : GRAPHNO onoff",
"parmset : GRAPHNO LABEL onoff",
"parmset : GRAPHNO AUTOSCALE TYPE AUTO",
"parmset : GRAPHNO AUTOSCALE TYPE SPEC",
"parmset : GRAPHNO AUTOSCALE torf",
"parmset : GRAPHNO HIDDEN torf",
"parmset : GRAPHNO TYPE graphtype",
"parmset : GRAPHNO BAR SIZE NUMBER",
"parmset : GRAPHNO STACKEDBAR SIZE NUMBER",
"parmset : GRAPHNO FIXEDPOINT onoff",
"parmset : GRAPHNO FIXEDPOINT FORMAT formatchoice formatchoice",
"parmset : GRAPHNO FIXEDPOINT PREC NUMBER ',' NUMBER",
"parmset : GRAPHNO FIXEDPOINT XY expr ',' expr",
"parmset : GRAPHNO FIXEDPOINT TYPE NUMBER",
"parmset : GRAPHNO MAXP SETS NUMBER",
"setvelocity : VELOCITY SCALE NUMBER",
"setvelocity : VELOCITY LEGEND onoff",
"setvelocity : VELOCITY LINEWIDTH NUMBER",
"setvelocity : VELOCITY LINESTYLE NUMBER",
"setvelocity : VELOCITY COLOR NUMBER",
"setvelocity : VELOCITY LOCTYPE worldview",
"setvelocity : VELOCITY ARROW TYPE NUMBER",
"xytype : XY",
"xytype : XYARC",
"xytype : XYBOX",
"xytype : XYBOXPLOT",
"xytype : XYHILO",
"xytype : XYRT",
"xytype : XYSEG",
"xytype : XYSTRING",
"xytype : XYDX",
"xytype : XYDY",
"xytype : XYDXDX",
"xytype : XYDYDY",
"xytype : XYDXDY",
"xytype : XYX2Y2",
"xytype : XYXX",
"xytype : XYYY",
"xytype : XYZ",
"xytype : XYZW",
"xytype : XYUV",
"xytype : TSV",
"xytype : NXY",
"xytype : BIN",
"xytype : POLY",
"xytype : RAWSPICE",
"graphtype : XY",
"graphtype : LOGX",
"graphtype : LOGY",
"graphtype : LOGXY",
"graphtype : BAR",
"graphtype : HBAR",
"graphtype : STACKEDBAR",
"graphtype : STACKEDHBAR",
"graphtype : POLAR",
"graphtype : XYFIXED",
"graphtype : BOXPLOT",
"graphtype : HBOXPLOT",
"graphtype : SMITH",
"pagelayout : FREE",
"pagelayout : LANDSCAPE",
"pagelayout : PORTRAIT",
"pagelayout : FIXED",
"regiontype : ABOVE",
"regiontype : BELOW",
"regiontype : LEFT",
"regiontype : RIGHT",
"regiontype : POLYI",
"regiontype : POLYO",
"set_setprop : selectsets setprop",
"setprop : onoff",
"setprop : IGNORE",
"setprop : TYPE xytype",
"setprop : MISSINGP expr",
"setprop : PREC NUMBER",
"setprop : FORMAT formatchoice",
"setprop : SYMBOL expr",
"setprop : SYMBOL FILL NUMBER",
"setprop : SYMBOL CENTER torf",
"setprop : SYMBOL SIZE expr",
"setprop : SYMBOL CHAR NUMBER",
"setprop : SYMBOL SKIP NUMBER",
"setprop : SYMBOL COLOR expr",
"setprop : SYMBOL LINEWIDTH NUMBER",
"setprop : SYMBOL LINESTYLE NUMBER",
"setprop : prop NUMBER",
"setprop : FILL NUMBER",
"setprop : FILL WITH colpat",
"setprop : FILL colpat NUMBER",
"setprop : SKIP NUMBER",
"setprop : ERRORBAR LENGTH NUMBER",
"setprop : ERRORBAR TYPE opchoice",
"setprop : ERRORBAR LINEWIDTH NUMBER",
"setprop : ERRORBAR LINESTYLE NUMBER",
"setprop : ERRORBAR RISER onoff",
"setprop : ERRORBAR RISER LINEWIDTH NUMBER",
"setprop : ERRORBAR RISER LINESTYLE NUMBER",
"setprop : XYZ expr ',' expr",
"setprop : COMMENT CHRSTR",
"setaxis : axis",
"setaxis : axis axisfeature",
"setaxis : allaxes",
"setaxis : GRAPHS axis",
"setaxis : GRAPHS axis axisfeature",
"setaxis : GRAPHS allaxes",
"axis : XAXIS",
"axis : YAXIS",
"axis : ALTXAXIS",
"axis : ALTYAXIS",
"axis : ZEROXAXIS",
"axis : ZEROYAXIS",
"allaxes : AXES axesprops",
"allaxes : XAXES axesprops",
"allaxes : YAXES axesprops",
"axesprops : onoff",
"axesprops : COLOR NUMBER",
"axesprops : LINEWIDTH NUMBER",
"axesprops : LINESTYLE NUMBER",
"axesprops : FONTP NUMBER",
"axesprops : CHAR SIZE NUMBER",
"axesprops : GRID onoff",
"axisfeature : TICKP tickdesc",
"axisfeature : TICKLABEL ticklabeldesc",
"axisfeature : LABEL axislabeldesc",
"axisfeature : BAR axisbardesc",
"axisfeature : onoff",
"tickdesc : tickattr",
"tickdesc : tickdesc tickattr",
"tickattr : onoff",
"tickattr : MAJOR onoff",
"tickattr : MINOR onoff",
"tickattr : MAJOR expr",
"tickattr : MINOR expr",
"tickattr : OFFSETX expr",
"tickattr : OFFSETY expr",
"tickattr : ALT onoff",
"tickattr : MINP expr",
"tickattr : MAXP expr",
"tickattr : DEFAULT NUMBER",
"tickattr : inoutchoice",
"tickattr : LOG onoff",
"tickattr : SIZE NUMBER",
"tickattr : MAJOR SIZE NUMBER",
"tickattr : MINOR SIZE NUMBER",
"tickattr : COLOR NUMBER",
"tickattr : LINEWIDTH NUMBER",
"tickattr : MAJOR COLOR NUMBER",
"tickattr : MINOR COLOR NUMBER",
"tickattr : MAJOR LINEWIDTH NUMBER",
"tickattr : MINOR LINEWIDTH NUMBER",
"tickattr : MAJOR LINESTYLE NUMBER",
"tickattr : MINOR LINESTYLE NUMBER",
"tickattr : MAJOR GRID onoff",
"tickattr : MINOR GRID onoff",
"tickattr : OP opchoice",
"tickattr : TYPE AUTO",
"tickattr : TYPE SPEC",
"tickattr : SPEC NUMBER",
"tickattr : NUMBER ',' expr",
"ticklabeldesc : ticklabelattr",
"ticklabeldesc : ticklabeldesc ticklabelattr",
"ticklabelattr : onoff",
"ticklabelattr : TYPE AUTO",
"ticklabelattr : TYPE SPEC",
"ticklabelattr : PREC NUMBER",
"ticklabelattr : FORMAT formatchoice",
"ticklabelattr : FORMAT NUMBER",
"ticklabelattr : APPEND CHRSTR",
"ticklabelattr : PREPEND CHRSTR",
"ticklabelattr : LAYOUT HORIZONTAL",
"ticklabelattr : LAYOUT VERTICAL",
"ticklabelattr : LAYOUT SPEC",
"ticklabelattr : LOCTYPE ON",
"ticklabelattr : LOCTYPE CENTER",
"ticklabelattr : LOCTYPE LEFT",
"ticklabelattr : LOCTYPE RIGHT",
"ticklabelattr : ANGLE NUMBER",
"ticklabelattr : JUST justchoice",
"ticklabelattr : SKIP NUMBER",
"ticklabelattr : STAGGER NUMBER",
"ticklabelattr : OP opchoice",
"ticklabelattr : SIGN signchoice",
"ticklabelattr : START expr",
"ticklabelattr : STOP expr",
"ticklabelattr : START TYPE SPEC",
"ticklabelattr : START TYPE AUTO",
"ticklabelattr : STOP TYPE SPEC",
"ticklabelattr : STOP TYPE AUTO",
"ticklabelattr : VGAP NUMBER",
"ticklabelattr : HGAP NUMBER",
"ticklabelattr : CHAR SIZE NUMBER",
"ticklabelattr : FONTP NUMBER",
"ticklabelattr : COLOR NUMBER",
"ticklabelattr : LINEWIDTH NUMBER",
"ticklabelattr : NUMBER ',' CHRSTR",
"axislabeldesc : CHRSTR",
"axislabeldesc : LAYOUT PERP",
"axislabeldesc : LAYOUT PARA",
"axislabeldesc : PLACE AUTO",
"axislabeldesc : PLACE SPEC",
"axislabeldesc : PLACE NUMBER ',' NUMBER",
"axislabeldesc : JUST justchoice",
"axislabeldesc : CHAR SIZE NUMBER",
"axislabeldesc : FONTP NUMBER",
"axislabeldesc : COLOR NUMBER",
"axislabeldesc : LINEWIDTH NUMBER",
"axisbardesc : onoff",
"axisbardesc : COLOR NUMBER",
"axisbardesc : LINESTYLE NUMBER",
"axisbardesc : LINEWIDTH NUMBER",
"selectsets : GRAPHNO '.' SETNUM",
"selectsets : SETNUM",
"selectsets : SETS",
"selectsets : GRAPHNO SETS",
"selectsets : GRAPHS SETS",
"selectsets : GRAPHS SETNUM",
"prop : LINESTYLE",
"prop : LINEWIDTH",
"prop : FONTP",
"prop : COLOR",
"prop : SIZE",
"onoff : ON",
"onoff : OFF",
"colpat : COLOR",
"colpat : PATTERN",
"runtype : RUNAVG",
"runtype : RUNSTD",
"runtype : RUNMED",
"runtype : RUNMAX",
"runtype : RUNMIN",
"ffttype : DFT",
"ffttype : FFT",
"ffttype : INVDFT",
"ffttype : INVFFT",
"sourcetype : DISK",
"sourcetype : PIPE",
"filltype : PATTERN",
"filltype : COLOR",
"filltype : NONE",
"opchoice : TOP",
"opchoice : BOTTOM",
"opchoice : LEFT",
"opchoice : RIGHT",
"opchoice : BOTH",
"justchoice : RIGHT",
"justchoice : LEFT",
"justchoice : CENTER",
"extremetype : MINP",
"extremetype : MAXP",
"torf : TRUEP",
"torf : FALSEP",
"inoutchoice : IN",
"inoutchoice : OUT",
"inoutchoice : BOTH",
"formatchoice : DECIMAL",
"formatchoice : EXPONENTIAL",
"formatchoice : POWER",
"formatchoice : GENERAL",
"formatchoice : DDMMYY",
"formatchoice : MMDDYY",
"formatchoice : YYMMDD",
"formatchoice : MMYY",
"formatchoice : MMDD",
"formatchoice : MONTHDAY",
"formatchoice : DAYMONTH",
"formatchoice : MONTHS",
"formatchoice : MONTHSY",
"formatchoice : MONTHL",
"formatchoice : DAYOFWEEKS",
"formatchoice : DAYOFWEEKL",
"formatchoice : DAYOFYEAR",
"formatchoice : HMS",
"formatchoice : MMDDHMS",
"formatchoice : MMDDYYHMS",
"formatchoice : YYMMDDHMS",
"formatchoice : DEGREESLON",
"formatchoice : DEGREESMMLON",
"formatchoice : DEGREESMMSSLON",
"formatchoice : MMSSLON",
"formatchoice : DEGREESLAT",
"formatchoice : DEGREESMMLAT",
"formatchoice : DEGREESMMSSLAT",
"formatchoice : MMSSLAT",
"signchoice : NORMAL",
"signchoice : ABSOLUTE",
"signchoice : NEGATE",
"direction : UP",
"direction : DOWN",
"direction : RIGHT",
"direction : LEFT",
"direction : IN",
"direction : OUT",
"worldview : WORLD",
"worldview : VIEW",
"sortdir : ASCENDING",
"sortdir : DESCENDING",
"sorton : X",
"sorton : Y",
"vector : X",
"vector : Y",
"vector : X0",
"vector : Y0",
"vector : Y1",
"vector : Y2",
"vector : Y3",
"vector : Y4",
"vector : Y5",
"asgn : VAR '[' expr ']' '=' expr",
"asgn : vector '[' expr ']' '=' expr",
"asgn : SETNUM '.' vector '[' expr ']' '=' expr",
"asgn : SETNUM '.' SYMBOL '=' expr",
"asgn : GRAPHNO '.' SETNUM '.' vector '[' expr ']' '=' expr",
"rasgn : REGNUM '.' vector '=' expr",
"vasgn : VAR '=' vexpr",
"vasgn : vector '=' vexpr",
"vasgn : SETNUM '=' SETNUM",
"vasgn : GRAPHNO '.' SETNUM '=' SETNUM",
"vasgn : SETNUM '=' GRAPHNO '.' SETNUM",
"vasgn : GRAPHNO '.' SETNUM '=' GRAPHNO '.' SETNUM",
"vasgn : SETNUM '.' vector '=' vexpr",
"vasgn : GRAPHNO '.' SETNUM '.' vector '=' vexpr",
"vasgn : VAR '=' expr",
"vasgn : vector '=' expr",
"vasgn : SETNUM '.' vector '=' expr",
"vasgn : GRAPHNO '.' SETNUM '.' vector '=' expr",
"vexpr : VAR",
"vexpr : vector",
"vexpr : SETNUM '.' vector",
"vexpr : GRAPHNO '.' SETNUM '.' vector",
"vexpr : expr",
"vexpr : expr '+' expr",
"vexpr : vexpr '+' vexpr",
"vexpr : expr '+' vexpr",
"vexpr : vexpr '+' expr",
"vexpr : expr '-' expr",
"vexpr : vexpr '-' vexpr",
"vexpr : expr '-' vexpr",
"vexpr : vexpr '-' expr",
"vexpr : expr '*' expr",
"vexpr : vexpr '*' vexpr",
"vexpr : expr '*' vexpr",
"vexpr : vexpr '*' expr",
"vexpr : expr '/' expr",
"vexpr : vexpr '/' vexpr",
"vexpr : expr '/' vexpr",
"vexpr : vexpr '/' expr",
"vexpr : expr '^' expr",
"vexpr : expr '^' vexpr",
"vexpr : vexpr '^' expr",
"vexpr : vexpr '^' vexpr",
"vexpr : ABS '(' expr ')'",
"vexpr : ABS '(' vexpr ')'",
"vexpr : ACOS '(' vexpr ')'",
"vexpr : ACOSH '(' vexpr ')'",
"vexpr : ASIN '(' vexpr ')'",
"vexpr : ASINH '(' vexpr ')'",
"vexpr : ATAN '(' vexpr ')'",
"vexpr : ATANH '(' vexpr ')'",
"vexpr : ATAN2 '(' vexpr ',' vexpr ')'",
"vexpr : CEIL '(' vexpr ')'",
"vexpr : COS '(' vexpr ')'",
"vexpr : COSH '(' vexpr ')'",
"vexpr : DEG",
"vexpr : ERF '(' vexpr ')'",
"vexpr : ERFC '(' vexpr ')'",
"vexpr : EXP '(' vexpr ')'",
"vexpr : FLOOR '(' vexpr ')'",
"vexpr : HYPOT '(' vexpr ',' vexpr ')'",
"vexpr : HYPOT '(' expr ',' vexpr ')'",
"vexpr : HYPOT '(' vexpr ',' expr ')'",
"vexpr : HYPOT '(' expr ',' expr ')'",
"vexpr : INDEX",
"vexpr : SETNO",
"vexpr : INT '(' vexpr ')'",
"vexpr : INVN '(' vexpr ')'",
"vexpr : INVT '(' expr ',' NUMBER ')'",
"vexpr : INVT '(' vexpr ',' NUMBER ')'",
"vexpr : IRAND '(' NUMBER ')'",
"vexpr : LGAMMA '(' vexpr ')'",
"vexpr : LN '(' vexpr ')'",
"vexpr : LOG '(' vexpr ')'",
"vexpr : LOGISTIC '(' vexpr ',' expr ',' expr ')'",
"vexpr : MAXP '(' vexpr ',' vexpr ')'",
"vexpr : MINP '(' vexpr ',' vexpr ')'",
"vexpr : MOD '(' vexpr ',' vexpr ')'",
"vexpr : NORM '(' vexpr ')'",
"vexpr : NORMP '(' vexpr ')'",
"vexpr : PI",
"vexpr : RAD",
"vexpr : RAND",
"vexpr : RNORM '(' vexpr ',' vexpr ')'",
"vexpr : RNORM '(' expr ',' vexpr ')'",
"vexpr : RNORM '(' vexpr ',' expr ')'",
"vexpr : RNORM '(' expr ',' expr ')'",
"vexpr : SIN '(' vexpr ')'",
"vexpr : SINH '(' vexpr ')'",
"vexpr : SQR '(' vexpr ')'",
"vexpr : SQRT '(' vexpr ')'",
"vexpr : TAN '(' vexpr ')'",
"vexpr : TANH '(' vexpr ')'",
"vexpr : vexpr '?' vexpr ':' vexpr",
"vexpr : vexpr GT vexpr",
"vexpr : vexpr LT vexpr",
"vexpr : vexpr LE vexpr",
"vexpr : vexpr GE vexpr",
"vexpr : vexpr EQ vexpr",
"vexpr : vexpr NE vexpr",
"vexpr : vexpr AND vexpr",
"vexpr : vexpr OR vexpr",
"vexpr : NOT vexpr",
"vexpr : '(' vexpr ')'",
"vexpr : '-' vexpr",
"expr : NUMBER",
"expr : FITPARM",
"expr : VAR '[' expr ']'",
"expr : REGNUM '.' vector",
"expr : vector '[' expr ']'",
"expr : SETNUM '.' vector '[' expr ']'",
"expr : GRAPHNO '.' SETNUM '.' vector '[' expr ']'",
"expr : SETNUM '.' vector '.' extremetype",
"expr : GRAPHNO '.' SETNUM '.' vector '.' extremetype",
"expr : SETNUM '.' LENGTH",
"expr : SETNUM '.' vector '.' AVG",
"expr : expr '+' expr",
"expr : expr '-' expr",
"expr : expr '*' expr",
"expr : expr '/' expr",
"expr : expr '%' expr",
"expr : expr '^' expr",
"expr : ABS '(' expr ')'",
"expr : ACOS '(' expr ')'",
"expr : ACOSH '(' expr ')'",
"expr : ASIN '(' expr ')'",
"expr : ASINH '(' expr ')'",
"expr : ATAN '(' expr ')'",
"expr : ATANH '(' expr ')'",
"expr : ATAN2 '(' expr ',' expr ')'",
"expr : CEIL '(' expr ')'",
"expr : COS '(' expr ')'",
"expr : COSH '(' expr ')'",
"expr : DEG",
"expr : ERF '(' expr ')'",
"expr : ERFC '(' expr ')'",
"expr : EXP '(' expr ')'",
"expr : FLOOR '(' expr ')'",
"expr : HYPOT '(' expr ',' expr ')'",
"expr : GRAPHNO '.' VX1",
"expr : GRAPHNO '.' VX2",
"expr : GRAPHNO '.' VY1",
"expr : GRAPHNO '.' VY2",
"expr : GRAPHNO '.' WX1",
"expr : GRAPHNO '.' WX2",
"expr : GRAPHNO '.' WY1",
"expr : GRAPHNO '.' WY2",
"expr : VX1",
"expr : VX2",
"expr : VY1",
"expr : VY2",
"expr : WX1",
"expr : WX2",
"expr : WY1",
"expr : WY2",
"expr : DX",
"expr : DY",
"expr : INDEX",
"expr : SETNO",
"expr : INT '(' expr ')'",
"expr : INVN '(' expr ')'",
"expr : INVT '(' expr ',' NUMBER ')'",
"expr : IRAND '(' NUMBER ')'",
"expr : JDAY '(' NUMBER ',' NUMBER ',' NUMBER ')'",
"expr : JDAY0 '(' NUMBER ',' NUMBER ',' NUMBER ',' NUMBER ',' NUMBER ',' NUMBER ')'",
"expr : LGAMMA '(' expr ')'",
"expr : LN '(' expr ')'",
"expr : LOG '(' expr ')'",
"expr : LOGISTIC '(' expr ',' expr ',' expr ')'",
"expr : MAXP '(' expr ',' expr ')'",
"expr : MINP '(' expr ',' expr ')'",
"expr : MOD '(' expr ',' expr ')'",
"expr : NORM '(' expr ')'",
"expr : NORMP '(' expr ')'",
"expr : PI",
"expr : RAD",
"expr : RAND",
"expr : RNORM '(' expr ',' expr ')'",
"expr : SIN '(' expr ')'",
"expr : SINH '(' expr ')'",
"expr : SQR '(' expr ')'",
"expr : SQRT '(' expr ')'",
"expr : TAN '(' expr ')'",
"expr : TANH '(' expr ')'",
"expr : expr '?' expr ':' expr",
"expr : expr GT expr",
"expr : expr LT expr",
"expr : expr LE expr",
"expr : expr GE expr",
"expr : expr EQ expr",
"expr : expr NE expr",
"expr : expr AND expr",
"expr : expr OR expr",
"expr : NOT expr",
"expr : '(' expr ')'",
"expr : '-' expr",
};
#endif
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#ifdef YYSTACKSIZE
#ifndef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#endif
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 3790 "pars.yacc"

void fixupstr(char *val)
{
    int vl = strlen(val);
    lowtoupper(val);
    val[vl + 1] = 0;
    val[vl] = '\n';
}

void scanner(char *s, double *x, double *y, int len, double *a, double *b, double *c, double *d, int lenscr, int i, int setno, int *errpos)
{
    interr = 0;
    whichgraph = cg;
    whichset = setno;
    if (s[0] == '#') {
	return;
    }
    pos = 0;
    aa = a;
    bb = b;
    cc = c;
    dd = d;
    xx = x;
    yy = y;
    lxy = len;
    ls = lenscr;
    setindex = i + 1;
    curset = setsetno = setno;
    strcpy(f_string, s);
    fcnt = 0;
    log_results(s);
    yyparse();
    *errpos = interr;
    for (i = 0; i < fcnt; i++) {
	cfree(freelist[i]);
	freelist[i] = NULL;
    }
}

void runbatch(char *bfile)
{
    double x, y;
    int errpos;
    char stext[256];
    FILE *fp;
    if (strcmp("stdin", bfile)) {
	fp = fopen(bfile, "r");
    }
    else {
	fp = stdin;
    }
    if (fp == NULL) {
        fprintf(stderr, "Error opening batch file \"%s\"\n", bfile);
        exit(1);
    }
    while(fgets(stext, 255, fp) != NULL) {
        if (stext[0] == '#') {
            continue;
        }
	if (strlen(stext) == 0) {
	    continue;
	}
        lowtoupper(stext);
/* TODO check on 0, 0 here for index and setno */
        scanner(stext, &x, &y, 1, ax, bx, cx, dx, 1, 0, 0, &errpos);
        stext[0] = 0;
        if (gotparams && paramfile[0]) {
            if (!getparms(cg, paramfile)) {
            }
            gotparams = 0;
        } else if (gotread && readfile[0]) {
            if (getdata(cg, readfile, readsrc, readtype)) {
#ifndef GRBATCH
                drawgraph();
#endif
            }
            gotread = 0;
        }
    }
    if (fp != stdin) {
	fclose(fp);
    }
}

symtab_entry key[] = {
	"A", VAR,
	"A0", FITPARM,
	"A1", FITPARM,
	"A2", FITPARM,
	"A3", FITPARM,
	"A4", FITPARM,
	"A5", FITPARM,
	"A6", FITPARM,
	"A7", FITPARM,
	"A8", FITPARM,
	"A9", FITPARM,
	"ABORT", ABORT,
	"ABOVE", ABOVE,
	"ABS", ABS,
	"ABSOLUTE", ABSOLUTE,
	"ACOS", ACOS,
	"ACOSH", ACOSH,
	"ACTIVATE", ACTIVATE,
	"ACTIVE", ACTIVE,
	"ALT", ALT,
	"ALTERNATE", ALTERNATE,
	"ALTXAXIS", ALTXAXIS,
	"ALTYAXIS", ALTYAXIS,
	"AND", AND,
	"ANGLE", ANGLE,
	"ANNOTATE", ANNOTATE,
	"APPEND", APPEND,
	"AREA", AREA,
	"ARRANGE", ARRANGE,
	"ARROW", ARROW,
	"ASCENDING", ASCENDING,
	"ASIN", ASIN,
	"ASINH", ASINH,
	"ASPLINE", ASPLINE,
	"ATAN", ATAN,
	"ATANH", ATANH,
	"ATAN2", ATAN2,
	"AUTO", AUTO,
	"AUTOSCALE", AUTOSCALE,
	"AUTOTICKS", AUTOTICKS,
	"AVG", AVG,
	"AXES", AXES,
	"AXIS", AXIS,
	"B", VAR,
	"BACKBUFFER", BACKBUFFER,
	"BACKGROUND", BACKGROUND,
	"BAR", BAR,
	"BATCH", BATCH,
	"BELOW", BELOW,
	"BIN", BIN,
	"BLOCK", BLOCK,
	"BOTH", BOTH,
	"BOTTOM", BOTTOM,
	"BOX", BOX,
	"BOXPLOT", BOXPLOT,
	"C", VAR,
	"CD", CD,
	"CEIL", CEIL,
	"CELLS", CELLS,
	"CENTER", CENTER,
	"CHAR", CHAR,
	"CHRSTR", CHRSTR,
	"CLEAR", CLEAR,
	"CLICK", CLICK,
	"CMAP", CMAP,
	"CO", COLOR,
	"COLOR", COLOR,
	"COMMENT", COMMENT,
	"COPY", COPY,
	"COS", COS,
	"COSH", COSH,
	"CYCLE", CYCLE,
	"D", VAR,
	"DAYMONTH", DAYMONTH,
	"DAYOFWEEKL", DAYOFWEEKL,
	"DAYOFWEEKS", DAYOFWEEKS,
	"DAYOFYEAR", DAYOFYEAR,
	"DDMMYY", DDMMYY,
	"DECIMAL", DECIMAL,
	"DEF", DEF,
	"DEFAULT", DEFAULT,
	"DEG", DEG,
	"DEGREESLAT", DEGREESLAT,
	"DEGREESLON", DEGREESLON,
	"DEGREESMMLAT", DEGREESMMLAT,
	"DEGREESMMLON", DEGREESMMLON,
	"DEGREESMMSSLAT", DEGREESMMSSLAT,
	"DEGREESMMSSLON", DEGREESMMSSLON,
	"DELAY", DELAYP,
	"DELETE", DELETE,
	"DESCENDING", DESCENDING,
	"DEVICE", DEVICE,
	"DFT", DFT,
	"DIFF", DIFFERENCE,
	"DIFFERENCE", DIFFERENCE,
	"DISK", DISK,
	"DOUBLEBUFFER", DOUBLEBUFFER,
	"DOWN", DOWN,
	"DRAW2", DRAW2,
	"DROP", DROP,
	"DX", DX,
	"DXDX", DXDX,
	"DY", DY,
	"DYDY", DYDY,
	"ECHO", ECHO,
	"EDIT", EDIT,
	"ELLIPSE", ELLIPSE,
	"ELSE", ELSE,
	"END", END,
	"EQ", EQ,
	"ER", ERRORBAR,
	"ERF", ERF,
	"ERFC", ERFC,
	"ERRORBAR", ERRORBAR,
	"EXIT", EXIT,
	"EXP", EXP,
	"EXPONENTIAL", EXPONENTIAL,
	"FALSE", FALSEP,
	"FFT", FFT,
	"FILE", FILEP,
	"FILL", FILL,
	"FIND", FIND,
	"FIXED", FIXED,
	"FIXEDPOINT", FIXEDPOINT,
	"FLOOR", FLOOR,
	"FLUSH", FLUSH,
	"FOCUS", FOCUS,
	"FOLLOWS", FOLLOWS,
	"FONT", FONTP,
	"FOREGROUND", FOREGROUND,
	"FORMAT", FORMAT,
	"FRAME", FRAMEP,
	"FREE", FREE,
	"FRONTBUFFER", FRONTBUFFER,
	"GE", GE,
	"GENERAL", GENERAL,
	"GETP", GETP,
	"GRAPH", GRAPH,
	"GRAPHS", GRAPHS,
	"GRAPHTYPE", GRAPHTYPE,
	"GRID", GRID,
	"GT", GT,
	"HARDCOPY", HARDCOPY,
	"HBAR", HBAR,
	"HBOXPLOT", HBOXPLOT,
	"HGAP", HGAP,
	"HIDDEN", HIDDEN,
	"HISTO", HISTO,
	"HMS", HMS,
	"HORIZONTAL", HORIZONTAL,
	"HPGLL", HPGLL,
	"HPGLP", HPGLP,
	"HYPOT", HYPOT,
	"IF", IF,
	"IGNORE", IGNORE,
	"IHL", IHL,
	"IMAGE", IMAGE,
	"IN", IN,
	"INDEX", INDEX,
	"INIT", INIT,
	"INOUT", INOUT,
	"INT", INT,
	"INTEGRATE", INT,
	"INTERP", INTERP,
	"INUM", INUM,
	"INVDFT", INVDFT,
	"INVFFT", INVFFT,
	"INVN", INVN,
	"INVT", INVT,
	"IRAND", IRAND,
	"JDAY", JDAY,
	"JDAY0", JDAY0,
	"JUST", JUST,
	"KILL", KILL,
	"LABEL", LABEL,
	"LANDSCAPE", LANDSCAPE,
	"LAYOUT", LAYOUT,
	"LE", LE,
	"LEAVE", LEAVE,
	"LEFT", LEFT,
	"LEGEND", LEGEND,
	"LENGTH", LENGTH,
	"LEVEL", LEVEL,
	"LEVELS", LEVELS,
	"LGAMMA", LGAMMA,
	"LINE", LINE,
	"LINESTYLE", LINESTYLE,
	"LINETO", LINETO,
	"LINEWIDTH", LINEWIDTH,
	"LINK", LINK,
	"LN", LN,
	"LOAD", LOAD,
	"LOCATOR", LOCATOR,
	"LOCATORBAR", LOCATORBAR,
	"LOCTYPE", LOCTYPE,
	"LOG", LOG,
	"LOGISTIC", LOGISTIC,
	"LOGX", LOGX,
	"LOGXY", LOGXY,
	"LOGY", LOGY,
	"LS", LINESTYLE,
	"LT", LT,
	"LW", LINEWIDTH,
	"MAJOR", MAJOR,
	"MAX", MAXP,
	"MIFL", MIFL,
	"MIFP", MIFP,
	"MIN", MINP,
	"MINOR", MINOR,
	"MISSING", MISSINGP,
	"MMDD", MMDD,
	"MMDDHMS", MMDDHMS,
	"MMDDYY", MMDDYY,
	"MMDDYYHMS", MMDDYYHMS,
	"MMSSLAT", MMSSLAT,
	"MMSSLON", MMSSLON,
	"MMYY", MMYY,
	"MOD", MOD,
	"MONTHDAY", MONTHDAY,
	"MONTHL", MONTHL,
	"MONTHS", MONTHS,
	"MONTHSY", MONTHSY,
	"MOVE", MOVE,
	"MOVE2", MOVE2,
	"MOVETO", MOVETO,
	"NE", NE,
	"NEGATE", NEGATE,
	"NO", NO,
	"NONE", NONE,
	"NORM", NORM,
	"NORMAL", NORMAL,
	"NORMP", NORMP,
	"NOT", NOT,
	"NUMBER", NUMBER,
	"NXY", NXY,
	"OFF", OFF,
	"OFFSETX", OFFSETX,
	"OFFSETY", OFFSETY,
	"ON", ON,
	"OP", OP,
	"OR", OR,
	"ORIENT", ORIENT,
	"OUT", OUT,
	"PAGE", PAGE,
	"PARA", PARA,
	"PARALLEL", PARALLEL,
	"PARAMETERS", PARAMETERS,
	"PARAMS", PARAMS,
	"PATTERN", PATTERN,
	"PERIMETER", PERIMETER,
	"PERP", PERP,
	"PERPENDICULAR", PERPENDICULAR,
	"PI", PI,
	"PIE", PIE,
	"PIPE", PIPE,
	"PLACE", PLACE,
	"POINT", POINT,
	"POLAR", POLAR,
	"POLY", POLY,
	"POLYI", POLYI,
	"POLYO", POLYO,
	"POP", POP,
	"PORTRAIT", PORTRAIT,
	"POWER", POWER,
	"PREC", PREC,
	"PREPEND", PREPEND,
	"PRINT", PRINT,
	"PS", PS,
	"PSCOLORL", PSCOLORL,
	"PSCOLORP", PSCOLORP,
	"PSMONOL", PSMONOL,
	"PSMONOP", PSMONOP,
	"PUSH", PUSH,
	"PUTP", PUTP,
	"RAD", RAD,
	"RAND", RAND,
	"RAWSPICE", RAWSPICE,
	"READ", READ,
	"REDRAW", REDRAW,
	"REGRESS", REGRESS,
	"RENDER", RENDER,
	"REVERSE", REVERSE,
	"RIGHT", RIGHT,
	"RISER", RISER,
	"RNORM", RNORM,
	"ROT", ROT,
	"RUNAVG", RUNAVG,
	"RUNMAX", RUNMAX,
	"RUNMED", RUNMED,
	"RUNMIN", RUNMIN,
	"RUNSTD", RUNSTD,
	"SAMPLE", SAMPLE,
	"SAVEALL", SAVEALL,
	"SCALE", SCALE,
	"SCIENTIFIC", SCIENTIFIC,
	"SET", SET,
	"SETNO", SETNO,
	"SETS", SETS,
	"SIGN", SIGN,
	"SIN", SIN,
	"SINH", SINH,
	"SIZE", SIZE,
	"SKIP", SKIP,
	"SLEEP", SLEEP,
	"SLICE", SLICE,
	"SORT", SORT,
	"SOURCE", SOURCE,
	"SPEC", SPEC,
	"SPECIFIED", SPECIFIED,
	"SPECTRUM", SPECTRUM,
	"SPLINE", SPLINE,
	"SQR", SQR,
	"SQRT", SQRT,
	"STACK", STACK,
	"STACKEDBAR", STACKEDBAR,
	"STACKEDHBAR", STACKEDHBAR,
	"STACKEDLINE", STACKEDLINE,
	"STAGGER", STAGGER,
	"START", START,
	"STARTTYPE", STARTTYPE,
	"STATUS", STATUS,
	"STATUSBAR", STATUSBAR,
	"STOP", STOP,
	"STRING", STRING,
	"SUBTITLE", SUBTITLE,
	"SWAPBUFFER", SWAPBUFFER,
	"SYMBOL", SYMBOL,
	"TAN", TAN,
	"TANH", TANH,
	"TICK", TICKP,
	"TICKLABEL", TICKLABEL,
	"TICKMARKS", TICKMARKS,
	"TIME", TIME,
	"TITLE", TITLE,
	"TO", TO,
	"TOOLBAR", TOOLBAR,
	"TOP", TOP,
	"TRUE", TRUEP,
	"TSV", TSV,
	"TYPE", TYPE,
	"UP", UP,
	"VAR", VAR,
	"VELOCITY", VELOCITY,
	"VERTICAL", VERTICAL,
	"VGAP", VGAP,
	"VIEW", VIEW,
	"VX1", VX1,
	"VX2", VX2,
	"VY1", VY1,
	"VY2", VY2,
	"WITH", WITH,
	"WORLD", WORLD,
	"WRITE", WRITE,
	"WX1", WX1,
	"WX2", WX2,
	"WY1", WY1,
	"WY2", WY2,
	"X", X,
	"X0", X0,
	"X1", X1,
	"XAXES", XAXES,
	"XAXIS", XAXIS,
	"XCOR", XCOR,
	"XMAX", XMAX,
	"XMIN", XMIN,
	"XY", XY,
	"XYARC", XYARC,
	"XYBOX", XYBOX,
	"XYBOXPLOT", XYBOXPLOT,
	"XYDX", XYDX,
	"XYDXDX", XYDXDX,
	"XYDXDY", XYDXDY,
	"XYDY", XYDY,
	"XYDYDY", XYDYDY,
	"XYFIXED", XYFIXED,
	"XYHILO", XYHILO,
	"XYRT", XYRT,
	"XYSEG", XYSEG,
	"XYSTRING", XYSTRING,
	"XYUV", XYUV,
	"XYX2Y2", XYX2Y2,
	"XYXX", XYXX,
	"XYYY", XYYY,
	"XYZ", XYZ,
	"XYZW", XYZW,
	"Y", Y,
	"Y0", Y0,
	"Y1", Y1,
	"Y2", Y2,
	"Y3", Y3,
	"Y4", Y4,
	"Y5", Y5,
	"YAXES", YAXES,
	"YAXIS", YAXIS,
	"YES", YES,
	"YMAX", YMAX,
	"YMIN", YMIN,
	"YYMMDD", YYMMDD,
	"YYMMDDHMS", YYMMDDHMS,
	"ZEROXAXIS", ZEROXAXIS,
	"ZEROYAXIS", ZEROYAXIS,
};

int maxparms = sizeof(key) / sizeof(symtab_entry);
int maxfunc = sizeof(key) / sizeof(symtab_entry);

int findf(symtab_entry *key, char *s, int tlen)
{

    int low, high, mid;

    low = 0;
    high = tlen - 1;
    while (low <= high) {
	mid = (low + high) / 2;
	if (strcmp(s, key[mid].s) < 0) {
	    high = mid - 1;
	} else {
	    if (strcmp(s, key[mid].s) > 0) {
		low = mid + 1;
	    } else {
		return (mid);
	    }
	}
    }
    return (-1);
}

int getcharstr(void)
{
    if (pos >= strlen(f_string))
	 return EOF;
    return (f_string[pos++]);
}

void ungetchstr(void)
{
    if (pos > 0)
	pos--;
}

int yylex(void)
{
    int c, i;
    int found;
    static char s[256];
    char sbuf[256];
    char *str;

    while ((c = getcharstr()) == ' ' || c == '\t');
    if (c == EOF) {
	return (0);
    }
    if (c == '"') {
	i = 0;
	while ((c = getcharstr()) != '"' && c != EOF) {
	    if (c == '\\') {
		int ctmp;
		ctmp = getcharstr();
		if (ctmp != '"') {
		    ungetchstr();
		}
		else {
		    c = ctmp;
		}
	    }
	    s[i] = c;
	    i++;
	}
	if (c == EOF) {
	    yyerror("Nonterminating string");
	    return 0;
	}
	s[i] = '\0';
	str = (char *) malloc(strlen(s) + 1);
	strcpy(str, s);
	yylval.str = str;
	return CHRSTR;
    }
    if (c == '.' || isdigit(c)) {
	char stmp[80];
	double d;
	int i, gotdot = 0;

	i = 0;
	while (c == '.' || isdigit(c)) {
	    if (c == '.') {
		if (gotdot) {
		    yyerror("Reading number, too many dots");
	    	    return 0;
		} else {
		    gotdot = 1;
		}
	    }
	    stmp[i++] = c;
	    c = getcharstr();
	}
	if (c == 'E' || c == 'e') {
	    stmp[i++] = c;
	    c = getcharstr();
	    if (c == '+' || c == '-') {
		stmp[i++] = c;
		c = getcharstr();
	    }
	    while (isdigit(c)) {
		stmp[i++] = c;
		c = getcharstr();
	    }
	}
	if (gotdot && i == 1) {
	    ungetchstr();
	    return '.';
	}
	stmp[i] = '\0';
	ungetchstr();
	sscanf(stmp, "%lf", &d);
	yylval.val = d;
	return NUMBER;
    }
/* graphs, sets, regions resp. */
    if (c == 'G' || c == 'S' || c == 'R') {
	char stmp[80];
	int i = 0, ctmp = c, gn, sn, rn;
	c = getcharstr();
	while (isdigit(c)) {
	    stmp[i++] = c;
	    c = getcharstr();
	}
	if (i == 0) {
	    c = ctmp;
	    ungetchstr();
	} else {
	    ungetchstr();
	    if (ctmp == 'G') {
	        stmp[i] = '\0';
		gn = atoi(stmp);
		if (gn >= 0 && gn < maxgraph) {
		    yylval.ival = gn;
		    whichgraph = gn;
		    return GRAPHNO;
		}
	    } else if (ctmp == 'S') {
	        stmp[i] = '\0';
		sn = atoi(stmp);
		if (sn >= 0 && sn < g[cg].maxplot) {
		    lxy = getsetlength(cg, sn);
		    yylval.ival = sn;
		    whichset = sn;
		    return SETNUM;
		}
	    } else if (ctmp == 'R') {
	        stmp[i] = '\0';
		rn = atoi(stmp);
		if (rn >= 0 && rn < MAXREGION) {
		    yylval.ival = rn;
		    return REGNUM;
		}
	    }
	}
    }
    if (isalpha(c)) {
	char *p = sbuf;

	do {
	    *p++ = c;
	} while ((c = getcharstr()) != EOF && isalnum(c));
	ungetchstr();
	*p = '\0';
        if (debuglevel == 2) {
	    printf("->%s<-\n", sbuf);
	}
	if ((found = findf(key, sbuf, maxfunc)) >= 0) {
	    if (key[found].type == VAR) {
		switch (sbuf[0]) {
		case 'A':
		    yylval.ptr = aa;
		    return VAR;
		case 'B':
		    yylval.ptr = bb;
		    return VAR;
		case 'C':
		    yylval.ptr = cc;
		    return VAR;
		case 'D':
		    yylval.ptr = dd;
		    return VAR;
		}
	    }
	    else if (key[found].type == FITPARM) {
		int index = sbuf[1] - '0';
		yylval.val = nonl_parms[index];
		return FITPARM;
	    }
	    else { /* set up special cases */
		switch (key[found].type) {
		case XAXIS:
		    naxis = 0;
		    break;
		case YAXIS:
		    naxis = 1;
		    break;
		case ZEROXAXIS:
		    naxis = 2;
		    break;
		case ZEROYAXIS:
		    naxis = 3;
		    break;
		case ALTXAXIS:
		    naxis = 4;
		    break;
		case ALTYAXIS:
		    naxis = 5;
		    break;
		case AXES:
		    naxis = 6;
		    break;
		case XAXES:
		    naxis = 7;
		    break;
		case YAXES:
		    naxis = 8;
		    break;
		case GRAPHS:
		    yylval.ival = -1;
		    whichgraph = -1;
		    return GRAPHS;
		    break;
		case SETS:
		    yylval.ival = -1;
		    whichset = -1;
		    return SETS;
		    break;
		default:
		    break;
		}
	    }
	    yylval.func = key[found].type;
	    return key[found].type;
	} else {
	    strcat(sbuf, ": No such function or variable");
	    yyerror(sbuf);
	    return 0;
	}
    }
    switch (c) {
    case '>':
	return follow('=', GE, GT);
    case '<':
	return follow('=', LE, LT);
    case '=':
	return follow('=', EQ, '=');
    case '!':
	return follow('=', NE, NOT);
    case '|':
	return follow('|', OR, '|');
    case '&':
	return follow('&', AND, '&');
    case '\n':
	return '\n';
    default:
	return c;
    }
}

int follow(int expect, int ifyes, int ifno)
{
    int c = getcharstr();

    if (c == expect) {
	return ifyes;
    }
    ungetchstr();
    return ifno;
}

void yyerror(char *s)
{
    int i;
    char buf[256];
    sprintf(buf, "%s: %s", s, f_string);
    i = strlen(buf);
    buf[i - 1] = 0;
    errmsg(buf);
    interr = 1;
}

#define C1 0.1978977093962766
#define C2 0.1352915131768107

double rnorm(double mean, double sdev)
{
    double u = drand48();

    return mean + sdev * (pow(u, C2) - pow(1.0 - u, C2)) / C1;
}

double fx(double x)
{
    return 1.0 / sqrt(2.0 * M_PI) * exp(-x * x * 0.5);
}

double normp(double b, double *s)
{
    double sum, dx, a = -8.0, fx(double x);
    int i, n = 48;

    sum = fx(a) + fx(b);
    dx = (b - a) / n;
    for (i = 1; i <= ((n - 1) / 2); i++)
	sum = sum + 4.0 * fx(a + (2.0 * i - 1.0) * dx) + 2.0 * fx(a + 2.0 * i * dx);
    sum = sum + 4.0 * fx(b - dx);
    *s = fx(b);
    return sum * dx / 3.0;
}

double invnorm(double p)
{
    double s, x, z, normp(double b, double *s);

    if (p > 0.5)
	x = 1.0 - p;
    else
	x = p;
    s = sqrt(-2.0 * log(x));
    x = ((-7.49101 * s - 448.047) * s - 1266.846);
    x = x / (((s + 109.8371) * s + 748.189) * s + 498.003) + s;
    if (p < 0.5)
	x = -x;
    z = p - normp(x, &s);
    z = z / s;
    s = x * x;
    return (((((((((720.0 * s + 2556.0) * s + 1740.0) * s + 127.0) * z / 7.0 +
		 ((120.0 * s + 326.0) * s + 127.0) * x) * z / 6.0 + (24 * s + 46.0) * s + 7.0) * z / 40.0 +
	       (0.75 * s + 0.875) * x) * z + s + 0.5) * z / 3.0 + x * 0.5) * z + 1.0) * z + x + 0.832e-24 * x;
}

double invt(double p, int n)
{
    double sign, temp, a, b, c, d, x, y;

    sign = 1.0;
    if (p < 0.5) {
	p = 1.0 - p;
	sign = -1.0;
    }
    p = (1 - p) * 2;
    if (n == 2) {
	temp = sqrt(2.0 / (p * (2.0 - p)) - 2.0);
	temp = sign * temp;
	return temp;
    } else if (n == 1) {
	p = p * M_PI / 2.0;
	return sign * cos(p) / sin(p);
    } else {
	a = 1.0 / (n - 0.5);
	b = 48.0 / (a * a);
	c = ((20700 * a / b - 98.0) * a - 16.0) * a + 96.36;
	d = ((94.5 / (b + c) - 3.0) / b + 1.0) * sqrt(a * M_PI / 2.0) * n;
	x = d * p;
	y = exp((2.0 / n) * log(x));
	if (y > (0.05 + a)) {
	    x = invnorm(p * 0.5);
	    y = x * x;
	    if (n < 5)
		c = c + 0.3 * (n - 4.5) * (x + 0.6);
	    c = (((0.05 * d * x - 5.0) * x - 7.0) * x - 2.0) * x + b + c;
	    y = (((((0.4 * y + 6.3) * y + 36.0) * y + 94.5) / c - y - 3.0) / b + 1.0) * x;
	    y = a * y * y;
	    if (y > 0.002)
		y = exp(y) - 1.0;
	    else
		y = 0.5 * y * y + y;
	} else
	    y = ((1.0 / (((n + 0.6) / (n * y) - 0.089 * d - 0.822) * (n + 2.0) * 3.0) + 0.5 / (n + 4.0)) * y - 1.0) * (n + 1.0) / (n + 2.0) + 1.0 / y;
	return sign * sqrt(n * y);
    }
}

/*
 * return a pointer to the array given by v
 */
double *getvptr(int gno, int setno, int v)
{
    switch (v) {
    case X:
    case X0:
	return g[gno].p[setno].ex[0];
	break;
    case Y:
    case Y0:
	return g[gno].p[setno].ex[1];
	break;
    case Y1:
	return g[gno].p[setno].ex[2];
	break;
    case Y2:
	return g[gno].p[setno].ex[3];
	break;
    case Y3:
	return g[gno].p[setno].ex[4];
	break;
    case Y4:
	return g[gno].p[setno].ex[5];
	break;
    case Y5:
	return g[gno].p[setno].ex[6];
	break;
    }
    return NULL;
}
#line 5702 "y.tab.c"
#define YYABORT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, reading %d (%s)\n", yystate,
                    yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: state %d, shifting to state %d\n",
                    yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: state %d, error recovery shifting\
 to state %d\n", *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: error recovery discarding state %d\n",
                            *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, error recovery discards token %d (%s)\n",
                    yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("yydebug: state %d, reducing by rule %d (%s)\n",
                yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 5:
#line 531 "pars.yacc"
{
	    result = yyvsp[-1].val;
	}
break;
case 6:
#line 534 "pars.yacc"
{
	    result = *yyvsp[-1].ptr;
	}
break;
case 13:
#line 543 "pars.yacc"
{
	    return 1;
	}
break;
case 14:
#line 549 "pars.yacc"
{
	    if (yyvsp[-1].pset == FILEP) {
		set_printer(FILEP, (char *) yyvsp[0].pset);
	    }
	    else {
		set_printer(yyvsp[-1].pset, (char *) yyvsp[0].pset);
	    }
	    free((char *) yyvsp[0].pset);
	}
break;
case 15:
#line 558 "pars.yacc"
{
	    if (yyvsp[-1].pset == FILEP) {
		set_printer(FILEP, (char *) yyvsp[0].pset);
	    }
	    else {
		set_printer(yyvsp[-1].pset, (char *) yyvsp[0].pset);
	    }
	    free((char *) yyvsp[0].pset);
	}
break;
case 16:
#line 567 "pars.yacc"
{
	    if (yyvsp[0].pset == FILEP) {
		set_printer(FILEP, NULL);
	    }
	    else {
		set_printer(yyvsp[0].pset, NULL);
	    }
	}
break;
case 17:
#line 575 "pars.yacc"
{
	    tdevice = (int) yyvsp[0].val;
	}
break;
case 18:
#line 578 "pars.yacc"
{
	    hdevice = (int) yyvsp[0].val;
	}
break;
case 19:
#line 581 "pars.yacc"
{
	    do_hardcopy();
	}
break;
case 20:
#line 585 "pars.yacc"
{ 
	    extern int pslwfactor; /* fudge factor for linewidths in the PS driver */
	    pslwfactor = yyvsp[0].val; 
	}
break;
case 21:
#line 592 "pars.yacc"
{ yyval.pset = GR_PS_P; }
break;
case 22:
#line 593 "pars.yacc"
{ yyval.pset = GR_PS_L; }
break;
case 23:
#line 594 "pars.yacc"
{ yyval.pset = GR_MIF_P; }
break;
case 24:
#line 595 "pars.yacc"
{ yyval.pset = GR_MIF_L; }
break;
case 25:
#line 596 "pars.yacc"
{ yyval.pset = GR_HPGL_P; }
break;
case 26:
#line 597 "pars.yacc"
{ yyval.pset = GR_HPGL_L; }
break;
case 27:
#line 598 "pars.yacc"
{ yyval.pset = hdevice; }
break;
case 28:
#line 599 "pars.yacc"
{ yyval.pset = FILEP; }
break;
case 29:
#line 603 "pars.yacc"
{
	    rg[yyvsp[-1].pset].active = yyvsp[0].pset;
	}
break;
case 30:
#line 606 "pars.yacc"
{
	    rg[yyvsp[-2].pset].type = yyvsp[0].pset;
	}
break;
case 31:
#line 609 "pars.yacc"
{
	    rg[yyvsp[-2].pset].color = checkon(COLOR, rg[yyvsp[-2].pset].color, (int) yyvsp[0].val);
	}
break;
case 32:
#line 612 "pars.yacc"
{
	    rg[yyvsp[-2].pset].lines = checkon(LINESTYLE, rg[yyvsp[-2].pset].lines, (int) yyvsp[0].val);
	}
break;
case 33:
#line 615 "pars.yacc"
{
	    rg[yyvsp[-2].pset].linew = checkon(LINEWIDTH, rg[yyvsp[-2].pset].linew, (int) yyvsp[0].val);
	}
break;
case 34:
#line 619 "pars.yacc"
{
	    rg[yyvsp[-8].pset].x1 = yyvsp[-6].val;
	    rg[yyvsp[-8].pset].y1 = yyvsp[-4].val;
	    rg[yyvsp[-8].pset].x2 = yyvsp[-2].val;
	    rg[yyvsp[-8].pset].y2 = yyvsp[0].val;
	}
break;
case 35:
#line 626 "pars.yacc"
{
	    if (rg[yyvsp[-4].pset].x == NULL || rg[yyvsp[-4].pset].n == 0) {
		rg[yyvsp[-4].pset].n = 0;
		rg[yyvsp[-4].pset].x = (double *) calloc(1, sizeof(double));
		rg[yyvsp[-4].pset].y = (double *) calloc(1, sizeof(double));
	    } else {
		rg[yyvsp[-4].pset].x = (double *) realloc(rg[yyvsp[-4].pset].x, (rg[yyvsp[-4].pset].n + 1) * sizeof(double));
		rg[yyvsp[-4].pset].y = (double *) realloc(rg[yyvsp[-4].pset].y, (rg[yyvsp[-4].pset].n + 1) * sizeof(double));
	    }
	    rg[yyvsp[-4].pset].x[rg[yyvsp[-4].pset].n] = yyvsp[-2].val;
	    rg[yyvsp[-4].pset].y[rg[yyvsp[-4].pset].n] = yyvsp[0].val;
	    rg[yyvsp[-4].pset].n++;
	}
break;
case 36:
#line 639 "pars.yacc"
{
	    rg[yyvsp[-2].pset].linkto[yyvsp[0].pset] = TRUE;
	}
break;
case 37:
#line 645 "pars.yacc"
{
#ifndef GRBATCH
	    drawgraph();
#endif
	}
break;
case 38:
#line 650 "pars.yacc"
{
	    auto_redraw = (yyvsp[0].pset == ON);
	}
break;
case 39:
#line 653 "pars.yacc"
{
	    char buf[MAXPATHLEN];
	    strcpy(buf, (char *) yyvsp[0].pset);
	    expand_tilde(buf); 
	    if (chdir(buf) >= 0) {
		strcpy(workingdir, buf);
	    	if (inwin) {
#ifndef GRBATCH
		    set_title(workingdir);
#endif
	        }
	    }
	    free((char *) yyvsp[0].pset);
	}
break;
case 40:
#line 667 "pars.yacc"
{
	    if (inwin) {
#ifndef GRBATCH
		set_left_footer((char *) yyvsp[0].pset);
#endif
	    }
	    else {
		printf("%s\n", (char *) yyvsp[0].pset);
	    }
	    free((char *) yyvsp[0].pset);
	}
break;
case 41:
#line 678 "pars.yacc"
{
#ifndef GRBATCH
	    update_stuff_status();
#endif
	}
break;
case 42:
#line 683 "pars.yacc"
{
	    setbgcolor((int) yyvsp[0].val);
	}
break;
case 43:
#line 686 "pars.yacc"
{
#ifndef GRBATCH
	    xlibsetcmap((int) yyvsp[-6].val, (int) yyvsp[-4].val, (int) yyvsp[-2].val, (int) yyvsp[0].val);
#endif
	}
break;
case 44:
#line 691 "pars.yacc"
{
	    exit(0);
	}
break;
case 45:
#line 695 "pars.yacc"
{
#ifndef GRBATCH
            set_pagelayout(yyvsp[0].pset);
#endif
        }
break;
case 46:
#line 701 "pars.yacc"
{
#ifndef GRBATCH
            set_toolbars(yyvsp[-1].pset, yyvsp[0].pset == ON);
#endif
        }
break;
case 47:
#line 707 "pars.yacc"
{
#ifndef GRBATCH
            set_toolbars(yyvsp[-1].pset, yyvsp[0].pset == ON);
#endif
        }
break;
case 48:
#line 713 "pars.yacc"
{
#ifndef GRBATCH
            set_toolbars(yyvsp[-1].pset, yyvsp[0].pset == ON);
#endif
        }
break;
case 49:
#line 719 "pars.yacc"
{
	    if (inwin) {
		my_draw2((double) yyvsp[-2].val, (double) yyvsp[0].val);
#ifndef GRBATCH
		flush_pending();
#endif
	    }
	}
break;
case 50:
#line 727 "pars.yacc"
{
	    if (inwin) {
		my_move2((double) yyvsp[-2].val, (double) yyvsp[0].val);
	    }
	}
break;
case 51:
#line 732 "pars.yacc"
{
	    if (inwin) {
		double x = (double) yyvsp[-4].val;
		double y = (double) yyvsp[-2].val;
		drawpolysym(&x, &y, 1, (int) yyvsp[0].val, 0, 0, 1.0);
#ifndef GRBATCH
		flush_pending();
#endif
	    }
	}
break;
case 52:
#line 742 "pars.yacc"
{
	    if (inwin) {
		setcolor((int) yyvsp[0].val);
	    }
	}
break;
case 53:
#line 747 "pars.yacc"
{
	    if (inwin) {
		setlinewidth((int) yyvsp[0].val);
	    }
	}
break;
case 54:
#line 752 "pars.yacc"
{
	    if (inwin) {
		setlinestyle((int) yyvsp[0].val);
	    }
	}
break;
case 55:
#line 757 "pars.yacc"
{
	}
break;
case 56:
#line 761 "pars.yacc"
{
	    switch (yyvsp[0].pset) {
	    case UP:
		gwindup_proc();
		break;
	    case DOWN:
		gwinddown_proc();
		break;
	    case RIGHT:
		gwindright_proc();
		break;
	    case LEFT:
		gwindleft_proc();
		break;
	    case IN:
		gwindshrink_proc();
		break;
	    case OUT:
		gwindexpand_proc();
		break;
	    }
	}
break;
case 57:
#line 783 "pars.yacc"
{
	    scroll_proc((int) yyvsp[0].val);
	}
break;
case 58:
#line 786 "pars.yacc"
{
	    scrollinout_proc((int) yyvsp[0].val);
	}
break;
case 59:
#line 789 "pars.yacc"
{
	    scrolling_islinked = yyvsp[0].pset == ON;
	}
break;
case 60:
#line 792 "pars.yacc"
{
#ifndef GRBATCH
	    my_doublebuffer(yyvsp[0].pset == TRUEP);
#endif
	}
break;
case 61:
#line 797 "pars.yacc"
{
#ifndef GRBATCH
	    my_frontbuffer(yyvsp[0].pset == TRUEP);
#endif
	}
break;
case 62:
#line 802 "pars.yacc"
{
#ifndef GRBATCH
	    my_backbuffer(yyvsp[0].pset == TRUEP);
#endif
	}
break;
case 63:
#line 807 "pars.yacc"
{
#ifndef GRBATCH
	    my_swapbuffer();
#endif
	}
break;
case 64:
#line 812 "pars.yacc"
{
	    sleep((int) yyvsp[0].val);
	}
break;
case 65:
#line 815 "pars.yacc"
{	/* TODO add delay function */
	}
break;
case 66:
#line 817 "pars.yacc"
{		/* TODO add abort flag and function */
	}
break;
case 67:
#line 820 "pars.yacc"
{
	    gotparams = TRUE;
	    strcpy(paramfile, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 68:
#line 826 "pars.yacc"
{
	    if (!fexists((char *) yyvsp[0].pset)) {
		FILE *pp = fopen((char *) yyvsp[0].pset, "w");
		if (pp != NULL) {
		    putparms(cg, pp, 0);
		    fclose(pp);
		} else {
		    errmsg("Unable to write parameter file");
		}
	    }
	    free((char *) yyvsp[0].pset);
	}
break;
case 69:
#line 838 "pars.yacc"
{
	    cg = (int) yyvsp[0].pset;
	    g[cg].parmsread = TRUE;
	    change_gno = cg;
	}
break;
case 70:
#line 843 "pars.yacc"
{
	    curset = (int) yyvsp[0].pset;
	}
break;
case 71:
#line 848 "pars.yacc"
{
	    set_hotlink(cg, yyvsp[-3].pset, 1, (char *) yyvsp[0].pset, yyvsp[-1].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 72:
#line 852 "pars.yacc"
{
	    set_hotlink(yyvsp[-5].pset, yyvsp[-3].pset, 1, (char *) yyvsp[0].pset, yyvsp[-1].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 73:
#line 856 "pars.yacc"
{
	    set_hotlink(cg, yyvsp[-2].pset, yyvsp[0].pset == ON, NULL, 0);
	}
break;
case 74:
#line 859 "pars.yacc"
{
	    set_hotlink(yyvsp[-4].pset, yyvsp[-2].pset, yyvsp[0].pset == ON, NULL, 0);
	}
break;
case 75:
#line 862 "pars.yacc"
{
	    do_activateset(cg, yyvsp[-1].pset, (int) yyvsp[0].val);
	}
break;
case 76:
#line 865 "pars.yacc"
{
	    do_activateset(yyvsp[-3].pset, yyvsp[-1].pset, (int) yyvsp[0].val);
	}
break;
case 77:
#line 868 "pars.yacc"
{
	    setlength(cg, yyvsp[-2].pset, (int) yyvsp[0].val);
	    updatesetminmax(cg, yyvsp[-2].pset);
#ifndef GRBATCH
	    update_set_status(cg, yyvsp[-2].pset);
#endif
	}
break;
case 78:
#line 875 "pars.yacc"
{
	    setlength(yyvsp[-4].pset, yyvsp[-2].pset, (int) yyvsp[0].val);
	    updatesetminmax(yyvsp[-4].pset, yyvsp[-2].pset);
#ifndef GRBATCH
	    update_set_status(yyvsp[-4].pset, yyvsp[-2].pset);
#endif
	}
break;
case 79:
#line 882 "pars.yacc"
{
	    add_point(cg, yyvsp[-4].pset, yyvsp[-2].val, yyvsp[0].val, 0.0, 0.0, XY);
	}
break;
case 80:
#line 885 "pars.yacc"
{
	    add_point(yyvsp[-6].pset, yyvsp[-4].pset, yyvsp[-2].val, yyvsp[0].val, 0.0, 0.0, XY);
	}
break;
case 81:
#line 889 "pars.yacc"
{
	    int start = (int) yyvsp[-2].val - 1;
	    int stop = (int) yyvsp[0].val - 1;
	    int dist = stop - start + 1;
	    if (dist > 0 && start >= 0) {
	        droppoints(cg, yyvsp[-4].pset, start, stop, dist);
	    }
	}
break;
case 82:
#line 897 "pars.yacc"
{
	    int start = (int) yyvsp[-2].val - 1;
	    int stop = (int) yyvsp[0].val - 1;
	    int dist = stop - start + 1;
	    if (dist > 0 && start >= 0) {
	        droppoints(yyvsp[-6].pset, yyvsp[-4].pset, start, stop, dist);
	    }
	}
break;
case 83:
#line 905 "pars.yacc"
{
	    if (isactive_set(cg, yyvsp[-2].pset)) {
	        sortset(cg, yyvsp[-2].pset, yyvsp[-1].pset, yyvsp[0].pset == ASCENDING ? 0 : 1);
	    } else {
		errmsg("Set not active!");
	    }
	}
break;
case 84:
#line 912 "pars.yacc"
{
	    do_copyset(cg, yyvsp[-2].pset, cg, yyvsp[0].pset);
	}
break;
case 85:
#line 915 "pars.yacc"
{
	    do_copyset(yyvsp[-6].pset, yyvsp[-4].pset, yyvsp[-2].pset, yyvsp[0].pset);
	}
break;
case 86:
#line 918 "pars.yacc"
{
	    do_moveset(cg, yyvsp[-2].pset, cg, yyvsp[0].pset);
	}
break;
case 87:
#line 921 "pars.yacc"
{
	    do_moveset(yyvsp[-6].pset, yyvsp[-4].pset, yyvsp[-2].pset, yyvsp[0].pset);
	}
break;
case 88:
#line 925 "pars.yacc"
{
	    killset(cg, yyvsp[0].pset);
	}
break;
case 89:
#line 929 "pars.yacc"
{
	    int i;
	    for (i = 0; i < g[cg].maxplot; i++) {
		killset(cg, i);
	    }
	}
break;
case 90:
#line 935 "pars.yacc"
{ softkillset(cg, yyvsp[-1].pset); }
break;
case 91:
#line 937 "pars.yacc"
{
	    int i;
	    for (i = 0; i < g[cg].maxplot; i++) {
		softkillset(cg, i);
	    }
	}
break;
case 92:
#line 943 "pars.yacc"
{ kill_graph(yyvsp[0].pset); }
break;
case 93:
#line 944 "pars.yacc"
{ kill_graph(maxgraph); }
break;
case 94:
#line 945 "pars.yacc"
{ wipeout(0); }
break;
case 95:
#line 946 "pars.yacc"
{ arrange_graphs((int) yyvsp[-2].val, (int) yyvsp[0].val); }
break;
case 96:
#line 948 "pars.yacc"
{
	    int i, ilen = (int) yyvsp[-4].val;
	    if (ilen < 0) {
		yyerror("Length of array < 0");
		return 1;
	    } else if (ilen > maxarr) {
		maxarr = ilen;
		init_scratch_arrays(ilen);
	    }
	    for (i = 0; i < ilen; i++) {
		yyvsp[-5].ptr[i] = yyvsp[-2].val + yyvsp[0].val * i;
	    }
	}
break;
case 97:
#line 962 "pars.yacc"
{
	    int setno = yyvsp[-3].pset, ideg = (int) yyvsp[-1].val;
	    do_regress(setno, ideg, 0, -1, 0);
	}
break;
case 98:
#line 967 "pars.yacc"
{
	    do_running_command(yyvsp[-5].pset, yyvsp[-3].pset, (int) yyvsp[-1].val);
	}
break;
case 99:
#line 971 "pars.yacc"
{
	    do_fourier_command(yyvsp[-5].pset, yyvsp[-3].pset, (int) yyvsp[-1].val);
	}
break;
case 100:
#line 975 "pars.yacc"
{
	    do_spline(yyvsp[-7].pset, yyvsp[-5].val, yyvsp[-3].val, (int) yyvsp[-1].val, SPLINE_CUBIC);
	}
break;
case 101:
#line 979 "pars.yacc"
{
	    do_spline(yyvsp[-7].pset, yyvsp[-5].val, yyvsp[-3].val, (int) yyvsp[-1].val, SPLINE_AKIMA);
	}
break;
case 102:
#line 983 "pars.yacc"
{
	    do_interp(yyvsp[-5].pset, yyvsp[-3].pset, (int) yyvsp[-1].val);
	}
break;
case 103:
#line 987 "pars.yacc"
{
	    do_histo_command(yyvsp[-7].pset, -1, -1, yyvsp[-5].val, yyvsp[-3].val, (int) yyvsp[-1].val);
	}
break;
case 104:
#line 991 "pars.yacc"
{
	    do_differ(yyvsp[-3].pset, (int) yyvsp[-1].val);
	}
break;
case 105:
#line 995 "pars.yacc"
{
	    do_int(yyvsp[-1].pset, 0);
	}
break;
case 106:
#line 999 "pars.yacc"
{
	    if (activeset(cg)) {
		defaultgraph(cg);
		default_axis(cg, g[cg].auto_type, X_AXIS);
		default_axis(cg, g[cg].auto_type, ZX_AXIS);
		default_axis(cg, g[cg].auto_type, Y_AXIS);
		default_axis(cg, g[cg].auto_type, ZY_AXIS);
#ifndef GRBATCH
		update_world(cg);
		drawgraph();
#endif
	    } else {
		errmsg("No active sets!");
	    }
	}
break;
case 107:
#line 1015 "pars.yacc"
{
	    if (activeset(cg)) {
		defaultx(cg, -1);
		default_axis(cg, g[cg].auto_type, X_AXIS);
		default_axis(cg, g[cg].auto_type, ZX_AXIS);
#ifndef GRBATCH
		update_world(cg);
#endif
#ifndef GRBATCH
		drawgraph();
#endif
	    } else {
		errmsg("No active sets!");
	    }
	}
break;
case 108:
#line 1031 "pars.yacc"
{
	    if (activeset(cg)) {
		defaulty(cg, -1);
		default_axis(cg, g[cg].auto_type, Y_AXIS);
		default_axis(cg, g[cg].auto_type, ZY_AXIS);
#ifndef GRBATCH
		update_world(cg);
		drawgraph();
#endif
	    } else {
		errmsg("No active sets!");
	    }
	}
break;
case 109:
#line 1045 "pars.yacc"
{
	    if (isactive_set(cg, yyvsp[0].pset)) {
		defaultsetgraph(cg, yyvsp[0].pset);
		default_axis(cg, g[cg].auto_type, X_AXIS);
		default_axis(cg, g[cg].auto_type, ZX_AXIS);
		default_axis(cg, g[cg].auto_type, Y_AXIS);
		default_axis(cg, g[cg].auto_type, ZY_AXIS);
#ifndef GRBATCH
		update_world(cg);
		drawgraph();
#endif
	    } else {
		errmsg("Set not active");
	    }
	}
break;
case 110:
#line 1061 "pars.yacc"
{
#ifndef GRBATCH
	    extern int go_locateflag;
	    go_locateflag = (yyvsp[0].pset == ON);
#endif
	}
break;
case 111:
#line 1068 "pars.yacc"
{
#ifndef GRBATCH
	    draw_focus(cg);
#endif
	    cg = (int) yyvsp[0].pset;
	    defineworld(g[cg].w.xg1, g[cg].w.yg1, g[cg].w.xg2, g[cg].w.yg2, 
			islogx(cg), islogy(cg));
	    viewport(g[cg].v.xv1, g[cg].v.yv1, g[cg].v.xv2, g[cg].v.yv2);
#ifndef GRBATCH
	    draw_focus(cg);
#endif
	    update_all(cg);
	}
break;
case 112:
#line 1081 "pars.yacc"
{
#ifndef GRBATCH
	    draw_focus_flag = yyvsp[0].pset;
#endif
	}
break;
case 113:
#line 1086 "pars.yacc"
{
	    focus_policy = yyvsp[0].pset;
	}
break;
case 114:
#line 1089 "pars.yacc"
{
	    focus_policy = yyvsp[0].pset;
	}
break;
case 115:
#line 1092 "pars.yacc"
{
	    focus_policy = yyvsp[0].pset;
	}
break;
case 116:
#line 1095 "pars.yacc"
{
	    cursource = yyvsp[0].pset;
	}
break;
case 117:
#line 1098 "pars.yacc"
{
	    curtype = yyvsp[0].pset;
	    change_type = curtype;
	}
break;
case 118:
#line 1103 "pars.yacc"
{
	    readxformat = yyvsp[0].pset;
	}
break;
case 119:
#line 1107 "pars.yacc"
{
	    gotread = TRUE;
	    readtype = curtype;
	    readsrc = cursource;
	    strcpy(readfile, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 120:
#line 1115 "pars.yacc"
{
	    gotbatch = TRUE;
	    strcpy(batchfile, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 121:
#line 1121 "pars.yacc"
{
	    getdata(cg, (char *) yyvsp[0].pset, DISK, BLOCK);
	    free((char *) yyvsp[0].pset);
	}
break;
case 122:
#line 1126 "pars.yacc"
{
	    getdata(cg, (char *) yyvsp[0].pset, yyvsp[-1].pset, BLOCK);
	    free((char *) yyvsp[0].pset);
	}
break;
case 123:
#line 1131 "pars.yacc"
{
	    create_set_fromblock(cg, yyvsp[-1].pset, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 124:
#line 1136 "pars.yacc"
{
	    gotread = TRUE;
	    readtype = yyvsp[-1].pset;
	    readsrc = cursource;
	    strcpy(readfile, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 125:
#line 1144 "pars.yacc"
{
	    gotread = TRUE;
	    strcpy(readfile, (char *) yyvsp[0].pset);
	    readtype = yyvsp[-2].pset;
	    readsrc = yyvsp[-1].pset;
	    free((char *) yyvsp[0].pset);
	}
break;
case 126:
#line 1152 "pars.yacc"
{
#ifndef GRBATCH
	    read_image((char *) yyvsp[0].pset);
#endif
	    free((char *) yyvsp[0].pset);
	}
break;
case 127:
#line 1159 "pars.yacc"
{
#ifndef GRBATCH
	    write_image((char *) yyvsp[0].pset);
#endif
	    free((char *) yyvsp[0].pset);
	}
break;
case 128:
#line 1166 "pars.yacc"
{
	    imagex = (int) yyvsp[-2].val;
	    imagey = (int) yyvsp[0].val;
	}
break;
case 129:
#line 1171 "pars.yacc"
{
	    outputset(cg, yyvsp[0].pset, (char *) NULL, (char *) NULL);
	}
break;
case 130:
#line 1175 "pars.yacc"
{
	    outputset(cg, yyvsp[-2].pset, (char *) NULL, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 131:
#line 1180 "pars.yacc"
{
	    outputset(cg, yyvsp[-2].pset, (char *) yyvsp[0].pset, (char *) NULL);
	    free((char *) yyvsp[0].pset);
	}
break;
case 132:
#line 1185 "pars.yacc"
{
	    outputset(cg, yyvsp[-4].pset, (char *) yyvsp[-2].pset, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[-2].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 133:
#line 1191 "pars.yacc"
{
            extern char sformat[];
            do_writesets(maxgraph, -1, 1, (char *) yyvsp[0].pset, sformat);
            free((char *) yyvsp[0].pset);
        }
break;
case 134:
#line 1196 "pars.yacc"
{
	    push_world();
	}
break;
case 135:
#line 1199 "pars.yacc"
{
	    pop_world();
	}
break;
case 136:
#line 1202 "pars.yacc"
{
	    cycle_world_stack();
	}
break;
case 137:
#line 1205 "pars.yacc"
{
	    if ((int) yyvsp[0].val > 0)
		show_world_stack((int) yyvsp[0].val - 1);
	}
break;
case 138:
#line 1210 "pars.yacc"
{
	    add_world(cg, yyvsp[-14].val, yyvsp[-12].val, yyvsp[-10].val, yyvsp[-8].val, yyvsp[-6].val, yyvsp[-4].val, yyvsp[-2].val, yyvsp[0].val);
	}
break;
case 139:
#line 1213 "pars.yacc"
{
	    clear_world_stack();
	}
break;
case 140:
#line 1216 "pars.yacc"
{
	    do_clear_boxes();
	}
break;
case 141:
#line 1219 "pars.yacc"
{
	    curbox = next_box();
	}
break;
case 142:
#line 1222 "pars.yacc"
{
	    curbox = (int) yyvsp[0].val;
	}
break;
case 143:
#line 1225 "pars.yacc"
{
	    boxes[curbox].active = yyvsp[0].pset;
	}
break;
case 144:
#line 1228 "pars.yacc"
{
	    boxes[curbox].gno = yyvsp[0].pset;
	}
break;
case 145:
#line 1232 "pars.yacc"
{
	    if (curbox >= 0 && curbox < maxboxes) {
		boxes[curbox].x1 = yyvsp[-6].val;
		boxes[curbox].y1 = yyvsp[-4].val;
		boxes[curbox].x2 = yyvsp[-2].val;
		boxes[curbox].y2 = yyvsp[0].val;
	    }
	}
break;
case 146:
#line 1240 "pars.yacc"
{
	    box_loctype = yyvsp[0].pset;
	}
break;
case 147:
#line 1243 "pars.yacc"
{
	    box_lines = checkon(LINESTYLE, box_lines, (int) yyvsp[0].val);
	}
break;
case 148:
#line 1246 "pars.yacc"
{
	    box_linew = checkon(LINEWIDTH, box_linew, (int) yyvsp[0].val);
	}
break;
case 149:
#line 1249 "pars.yacc"
{
	    box_color = checkon(COLOR, box_color, (int) yyvsp[0].val);
	}
break;
case 150:
#line 1252 "pars.yacc"
{
	    box_fill = yyvsp[0].pset;
	}
break;
case 151:
#line 1255 "pars.yacc"
{
	    box_fillcolor = checkon(COLOR, box_fillcolor, (int) yyvsp[0].val);
	}
break;
case 152:
#line 1258 "pars.yacc"
{
	    box_fillpat = checkon(PATTERN, box_fillpat, (int) yyvsp[0].val);
	}
break;
case 153:
#line 1262 "pars.yacc"
{
	    if (curbox >= 0 && curbox < maxboxes) {
		boxes[curbox].lines = box_lines;
		boxes[curbox].linew = box_linew;
		boxes[curbox].color = box_color;
		boxes[curbox].fill = box_fill;
		boxes[curbox].fillcolor = box_fillcolor;
		boxes[curbox].fillpattern = box_fillpat;
		boxes[curbox].loctype = box_loctype;
	    }
	}
break;
case 154:
#line 1273 "pars.yacc"
{
	    do_clear_ellipses();
	}
break;
case 155:
#line 1276 "pars.yacc"
{
		curellipse = next_ellipse();
	}
break;
case 156:
#line 1279 "pars.yacc"
{
	    curellipse = (int) yyvsp[0].val;
	}
break;
case 157:
#line 1282 "pars.yacc"
{
	    ellip[curellipse].active = yyvsp[0].pset;
	}
break;
case 158:
#line 1285 "pars.yacc"
{
	    ellip[curellipse].gno = yyvsp[0].pset;
	}
break;
case 159:
#line 1289 "pars.yacc"
{
	    if (curellipse >= 0 && curellipse < maxellipses) {
		ellip[curellipse].x1 = yyvsp[-6].val;
		ellip[curellipse].y1 = yyvsp[-4].val;
		ellip[curellipse].x2 = yyvsp[-2].val;
		ellip[curellipse].y2 = yyvsp[0].val;
	    }
	}
break;
case 160:
#line 1297 "pars.yacc"
{
	    ellipse_loctype = yyvsp[0].pset;
	}
break;
case 161:
#line 1300 "pars.yacc"
{
	    ellipse_lines = checkon(LINESTYLE, ellipse_lines, (int) yyvsp[0].val);
	}
break;
case 162:
#line 1303 "pars.yacc"
{
	    ellipse_linew = checkon(LINEWIDTH, ellipse_linew, (int) yyvsp[0].val);
	}
break;
case 163:
#line 1306 "pars.yacc"
{
	    ellipse_color = checkon(COLOR, ellipse_color, (int) yyvsp[0].val);
	}
break;
case 164:
#line 1309 "pars.yacc"
{
	    ellipse_fill = yyvsp[0].pset;
	}
break;
case 165:
#line 1312 "pars.yacc"
{
	    ellipse_fillcolor = checkon(COLOR, ellipse_fillcolor, (int) yyvsp[0].val);
	}
break;
case 166:
#line 1315 "pars.yacc"
{
	    ellipse_fillpat = checkon(PATTERN, ellipse_fillpat, (int) yyvsp[0].val);
	}
break;
case 167:
#line 1319 "pars.yacc"
{
	    if (curellipse >= 0 && curellipse < maxellipses) {
		ellip[curellipse].lines = ellipse_lines;
		ellip[curellipse].linew = ellipse_linew;
		ellip[curellipse].color = ellipse_color;
		ellip[curellipse].fill = ellipse_fill;
		ellip[curellipse].fillcolor = ellipse_fillcolor;
		ellip[curellipse].fillpattern = ellipse_fillpat;
		ellip[curellipse].loctype = ellipse_loctype;
	    }
	}
break;
case 168:
#line 1330 "pars.yacc"
{
	    curline = next_line();
	}
break;
case 169:
#line 1333 "pars.yacc"
{
	    curline = (int) yyvsp[0].val;
	}
break;
case 170:
#line 1336 "pars.yacc"
{
	    do_clear_lines();
	}
break;
case 171:
#line 1339 "pars.yacc"
{
	    lines[curline].active = yyvsp[0].pset;
	}
break;
case 172:
#line 1342 "pars.yacc"
{
	    lines[curline].gno = yyvsp[0].pset;
	}
break;
case 173:
#line 1346 "pars.yacc"
{
	    lines[curline].x1 = yyvsp[-6].val;
	    lines[curline].y1 = yyvsp[-4].val;
	    lines[curline].x2 = yyvsp[-2].val;
	    lines[curline].y2 = yyvsp[0].val;
	}
break;
case 174:
#line 1352 "pars.yacc"
{
	    line_loctype = yyvsp[0].pset;
	}
break;
case 175:
#line 1355 "pars.yacc"
{
	    line_linew = checkon(LINEWIDTH, line_linew, (int) yyvsp[0].val);
	}
break;
case 176:
#line 1358 "pars.yacc"
{
	    line_lines = checkon(LINESTYLE, line_lines, (int) yyvsp[0].val);
	}
break;
case 177:
#line 1361 "pars.yacc"
{
	    line_color = checkon(COLOR, line_color, (int) yyvsp[0].val);
	}
break;
case 178:
#line 1364 "pars.yacc"
{
	    line_arrow = checkon(ARROW, line_arrow, (int) yyvsp[0].val);
	}
break;
case 179:
#line 1367 "pars.yacc"
{
	    line_asize = yyvsp[0].val;
	}
break;
case 180:
#line 1370 "pars.yacc"
{
	    line_atype = (int) yyvsp[0].val;
	}
break;
case 181:
#line 1374 "pars.yacc"
{
	    if (curline >= 0 && curline < maxlines) {
		lines[curline].lines = line_lines;
		lines[curline].linew = line_linew;
		lines[curline].color = line_color;
		lines[curline].arrow = line_arrow;
		lines[curline].asize = line_asize;
		lines[curline].atype = line_atype;
		lines[curline].loctype = line_loctype;
	    }
	}
break;
case 182:
#line 1385 "pars.yacc"
{
	    do_clear_text();
	}
break;
case 183:
#line 1388 "pars.yacc"
{ curstring = next_string(); }
break;
case 184:
#line 1389 "pars.yacc"
{ curstring = (int) yyvsp[0].val; }
break;
case 185:
#line 1390 "pars.yacc"
{ pstr[curstring].active = yyvsp[0].pset; }
break;
case 186:
#line 1391 "pars.yacc"
{ pstr[curstring].gno = yyvsp[0].pset; }
break;
case 187:
#line 1393 "pars.yacc"
{
	    pstr[curstring].x = yyvsp[-2].val;
	    pstr[curstring].y = yyvsp[0].val;
	}
break;
case 188:
#line 1397 "pars.yacc"
{ string_loctype = yyvsp[0].pset; }
break;
case 189:
#line 1398 "pars.yacc"
{ string_linew = checkon(LINEWIDTH, string_linew, (int) yyvsp[0].val); }
break;
case 190:
#line 1399 "pars.yacc"
{ string_color = checkon(COLOR, string_color, (int) yyvsp[0].val); }
break;
case 191:
#line 1400 "pars.yacc"
{ string_rot = (int) yyvsp[0].val; }
break;
case 192:
#line 1401 "pars.yacc"
{ string_font = checkon(FONTP, string_font, (int) yyvsp[0].val); }
break;
case 193:
#line 1402 "pars.yacc"
{ string_just = checkon(JUST, string_just, (int) yyvsp[0].val); }
break;
case 194:
#line 1403 "pars.yacc"
{ string_size = yyvsp[0].val; }
break;
case 195:
#line 1405 "pars.yacc"
{
	    set_plotstr_string(&pstr[curstring], (char *) yyvsp[0].pset);
	    pstr[curstring].linew = string_linew;
	    pstr[curstring].color = string_color;
	    pstr[curstring].font = string_font;
	    pstr[curstring].just = string_just;
	    pstr[curstring].loctype = string_loctype;
	    pstr[curstring].rot = string_rot;
	    pstr[curstring].charsize = string_size;
	    free((char *) yyvsp[0].pset);
	}
break;
case 196:
#line 1416 "pars.yacc"
{ timestamp.active = yyvsp[0].pset; }
break;
case 197:
#line 1417 "pars.yacc"
{ timestamp.font = checkon(FONTP, timestamp.font, (int) yyvsp[0].val); }
break;
case 198:
#line 1418 "pars.yacc"
{ timestamp.charsize = yyvsp[0].val; }
break;
case 199:
#line 1419 "pars.yacc"
{ timestamp.color = checkon(COLOR, timestamp.color, (int) yyvsp[0].val); }
break;
case 200:
#line 1420 "pars.yacc"
{ timestamp.linew = checkon(LINEWIDTH, timestamp.linew, (int) yyvsp[-1].pset); }
break;
case 201:
#line 1422 "pars.yacc"
{
	    timestamp.x = yyvsp[-2].val;
	    timestamp.y = yyvsp[0].val;
	}
break;
case 202:
#line 1426 "pars.yacc"
{
	    grdefaults.lines = (int) yyvsp[0].val;
	}
break;
case 203:
#line 1429 "pars.yacc"
{
	    grdefaults.linew = (int) yyvsp[0].val;
	}
break;
case 204:
#line 1432 "pars.yacc"
{
	    grdefaults.color = (int) yyvsp[0].val;
	}
break;
case 205:
#line 1435 "pars.yacc"
{
	    grdefaults.charsize = yyvsp[0].val;
	}
break;
case 206:
#line 1438 "pars.yacc"
{
	    grdefaults.font = (int) yyvsp[0].val;
	}
break;
case 207:
#line 1441 "pars.yacc"
{
	    grdefaults.fontsrc = (int) yyvsp[0].val;
	}
break;
case 208:
#line 1444 "pars.yacc"
{
	    grdefaults.symsize = yyvsp[0].val;
	}
break;
case 209:
#line 1448 "pars.yacc"
{
	    g[cg].w.xg1 = yyvsp[-6].val;
	    g[cg].w.yg1 = yyvsp[-4].val;
	    g[cg].w.xg2 = yyvsp[-2].val;
	    g[cg].w.yg2 = yyvsp[0].val;
	}
break;
case 210:
#line 1454 "pars.yacc"
{
	    g[cg].w.xg1 = yyvsp[0].val;
	}
break;
case 211:
#line 1457 "pars.yacc"
{
	    g[cg].w.xg2 = yyvsp[0].val;
	}
break;
case 212:
#line 1460 "pars.yacc"
{
	    g[cg].w.yg1 = yyvsp[0].val;
	}
break;
case 213:
#line 1463 "pars.yacc"
{
	    g[cg].w.yg2 = yyvsp[0].val;
	}
break;
case 214:
#line 1467 "pars.yacc"
{
            g[cg].rt.xg1 = yyvsp[-2].val;
            g[cg].rt.yg1 = yyvsp[0].val;
        }
break;
case 215:
#line 1472 "pars.yacc"
{
	    g[cg].v.xv1 = yyvsp[-6].val;
	    g[cg].v.yv1 = yyvsp[-4].val;
	    g[cg].v.xv2 = yyvsp[-2].val;
	    g[cg].v.yv2 = yyvsp[0].val;
	}
break;
case 216:
#line 1478 "pars.yacc"
{
	    g[cg].v.xv1 = yyvsp[0].val;
	}
break;
case 217:
#line 1481 "pars.yacc"
{
	    g[cg].v.xv2 = yyvsp[0].val;
	}
break;
case 218:
#line 1484 "pars.yacc"
{
	    g[cg].v.yv1 = yyvsp[0].val;
	}
break;
case 219:
#line 1487 "pars.yacc"
{
	    g[cg].v.yv2 = yyvsp[0].val;
	}
break;
case 220:
#line 1490 "pars.yacc"
{
	    set_plotstr_string(&g[cg].labs.title, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 221:
#line 1494 "pars.yacc"
{
	    g[cg].labs.title.font = checkon(FONTP, g[cg].labs.title.font, (int) yyvsp[0].val);
	}
break;
case 222:
#line 1497 "pars.yacc"
{
	    g[cg].labs.title.charsize = yyvsp[0].val;
	}
break;
case 223:
#line 1500 "pars.yacc"
{
	    g[cg].labs.title.color = checkon(COLOR, g[cg].labs.title.color, (int) yyvsp[0].val);
	}
break;
case 224:
#line 1504 "pars.yacc"
{
	    g[cg].labs.title.linew = checkon(LINEWIDTH, g[cg].labs.title.linew, (int) yyvsp[0].val);
	}
break;
case 225:
#line 1507 "pars.yacc"
{
	    set_plotstr_string(&g[cg].labs.stitle, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 226:
#line 1512 "pars.yacc"
{
	    g[cg].labs.stitle.font = checkon(FONTP, g[cg].labs.stitle.font, (int) yyvsp[0].val);
	}
break;
case 227:
#line 1515 "pars.yacc"
{
	    g[cg].labs.stitle.charsize = yyvsp[0].val;
	}
break;
case 228:
#line 1519 "pars.yacc"
{
	    g[cg].labs.stitle.color = checkon(COLOR, g[cg].labs.stitle.color, (int) yyvsp[0].val);
	}
break;
case 229:
#line 1523 "pars.yacc"
{
	    g[cg].labs.stitle.linew = checkon(LINEWIDTH, g[cg].labs.stitle.color, (int) yyvsp[0].val);
	}
break;
case 230:
#line 1526 "pars.yacc"
{
	    realloc_plots((int) yyvsp[0].val);
	}
break;
case 231:
#line 1529 "pars.yacc"
{
	    g[cg].l.active = yyvsp[0].pset;
	}
break;
case 232:
#line 1532 "pars.yacc"
{
	    g[cg].l.loctype = yyvsp[0].pset;
	}
break;
case 233:
#line 1535 "pars.yacc"
{
	    g[cg].l.layout = (int) yyvsp[0].val;
	}
break;
case 234:
#line 1538 "pars.yacc"
{
	    g[cg].l.vgap = (int) yyvsp[0].val;
	}
break;
case 235:
#line 1541 "pars.yacc"
{
	    g[cg].l.hgap = (int) yyvsp[0].val;
	}
break;
case 236:
#line 1544 "pars.yacc"
{
	    g[cg].l.len = (int) yyvsp[0].val;
	}
break;
case 237:
#line 1547 "pars.yacc"
{
	    g[cg].l.box = yyvsp[0].pset;
	}
break;
case 238:
#line 1550 "pars.yacc"
{
	    g[cg].l.boxfill = yyvsp[0].pset;
	}
break;
case 239:
#line 1553 "pars.yacc"
{
	    g[cg].l.boxfillusing = yyvsp[0].pset;
	}
break;
case 240:
#line 1557 "pars.yacc"
{
	    if (yyvsp[-1].pset == COLOR) {
		g[cg].l.boxfillcolor = (int) yyvsp[0].val;
	    } else {
		g[cg].l.boxfillpat = (int) yyvsp[0].val;
	    }
	}
break;
case 241:
#line 1564 "pars.yacc"
{
	    g[cg].l.boxlcolor = checkon(COLOR, g[cg].l.boxlcolor, (int) yyvsp[0].val);
	}
break;
case 242:
#line 1567 "pars.yacc"
{
	    g[cg].l.boxlines = checkon(LINESTYLE, g[cg].l.boxlines, (int) yyvsp[0].val);
	}
break;
case 243:
#line 1570 "pars.yacc"
{
	    g[cg].l.boxlinew = checkon(LINEWIDTH, g[cg].l.boxlinew, (int) yyvsp[0].val);
	}
break;
case 244:
#line 1573 "pars.yacc"
{
	    g[cg].l.legx = yyvsp[-2].val;
	    g[cg].l.legy = yyvsp[0].val;
	}
break;
case 245:
#line 1577 "pars.yacc"
{
	    g[cg].l.legx = yyvsp[0].val;
	}
break;
case 246:
#line 1580 "pars.yacc"
{
	    g[cg].l.legy = yyvsp[0].val;
	}
break;
case 247:
#line 1583 "pars.yacc"
{
	    g[cg].l.charsize = yyvsp[0].val;
	}
break;
case 248:
#line 1586 "pars.yacc"
{
	    g[cg].l.font = checkon(FONTP, g[cg].l.font, (int) yyvsp[0].val);
	}
break;
case 249:
#line 1589 "pars.yacc"
{
	    g[cg].l.lines = checkon(LINESTYLE, g[cg].l.lines, (int) yyvsp[0].val);
	}
break;
case 250:
#line 1592 "pars.yacc"
{
	    g[cg].l.linew = checkon(LINEWIDTH, g[cg].l.linew, (int) yyvsp[0].val);
	}
break;
case 251:
#line 1595 "pars.yacc"
{
	    g[cg].l.color = checkon(COLOR, g[cg].l.color, (int) yyvsp[0].val);
	}
break;
case 252:
#line 1598 "pars.yacc"
{
	    strcpy(g[cg].p[(int) yyvsp[-1].val].lstr, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 253:
#line 1602 "pars.yacc"
{
	    g[cg].f.active = yyvsp[0].pset;
	}
break;
case 254:
#line 1605 "pars.yacc"
{
	    g[cg].f.type = (int) yyvsp[0].val;
	}
break;
case 255:
#line 1608 "pars.yacc"
{
	    g[cg].f.lines = checkon(LINESTYLE, g[cg].f.lines, (int) yyvsp[0].val);
	}
break;
case 256:
#line 1611 "pars.yacc"
{
	    g[cg].f.linew = checkon(LINEWIDTH, g[cg].f.linew, (int) yyvsp[0].val);
	}
break;
case 257:
#line 1614 "pars.yacc"
{
	    g[cg].f.color = checkon(COLOR, g[cg].f.color, (int) yyvsp[0].val);
	}
break;
case 258:
#line 1617 "pars.yacc"
{ g[cg].f.fillbg = yyvsp[0].pset; }
break;
case 259:
#line 1618 "pars.yacc"
{ g[cg].f.bgcolor = (int) yyvsp[0].val; }
break;
case 260:
#line 1619 "pars.yacc"
{ g[yyvsp[-1].pset].active = yyvsp[0].pset; }
break;
case 261:
#line 1620 "pars.yacc"
{ g[yyvsp[-2].pset].label = yyvsp[0].pset; }
break;
case 262:
#line 1621 "pars.yacc"
{ g[yyvsp[-3].pset].auto_type = yyvsp[0].pset; }
break;
case 263:
#line 1622 "pars.yacc"
{ g[yyvsp[-3].pset].auto_type = yyvsp[0].pset; }
break;
case 264:
#line 1623 "pars.yacc"
{ g[yyvsp[-2].pset].parmsread = (yyvsp[0].pset == FALSEP); }
break;
case 265:
#line 1624 "pars.yacc"
{ g[yyvsp[-2].pset].hidden = (yyvsp[0].pset == TRUEP); }
break;
case 266:
#line 1625 "pars.yacc"
{ g[yyvsp[-2].pset].type = yyvsp[0].pset; }
break;
case 267:
#line 1626 "pars.yacc"
{ g[yyvsp[-3].pset].barwid = yyvsp[0].val; }
break;
case 268:
#line 1627 "pars.yacc"
{ g[yyvsp[-3].pset].sbarwid = yyvsp[0].val; }
break;
case 269:
#line 1628 "pars.yacc"
{ g[yyvsp[-2].pset].pointset = (yyvsp[0].pset == ON); }
break;
case 270:
#line 1630 "pars.yacc"
{
	    g[yyvsp[-4].pset].fx = yyvsp[-1].pset;
	    g[yyvsp[-4].pset].fy = yyvsp[0].pset;
	}
break;
case 271:
#line 1635 "pars.yacc"
{
	    g[yyvsp[-5].pset].px = yyvsp[-2].val;
	    g[yyvsp[-5].pset].py = yyvsp[0].val;
	}
break;
case 272:
#line 1640 "pars.yacc"
{
	    g[yyvsp[-5].pset].dsx = yyvsp[-2].val;
	    g[yyvsp[-5].pset].dsy = yyvsp[0].val;
	}
break;
case 273:
#line 1644 "pars.yacc"
{ g[yyvsp[-3].pset].pt_type = (int) yyvsp[0].val; }
break;
case 274:
#line 1645 "pars.yacc"
{ realloc_graph_plots(yyvsp[-3].pset, (int) yyvsp[0].val); }
break;
case 275:
#line 1649 "pars.yacc"
{ g[cg].vp.vscale = yyvsp[0].val; }
break;
case 276:
#line 1650 "pars.yacc"
{ g[cg].vp.active = yyvsp[0].pset; }
break;
case 277:
#line 1651 "pars.yacc"
{ g[cg].vp.linew = (int) yyvsp[0].val; }
break;
case 278:
#line 1652 "pars.yacc"
{ g[cg].vp.lines = (int) yyvsp[0].val; }
break;
case 279:
#line 1653 "pars.yacc"
{ g[cg].vp.color = (int) yyvsp[0].val; }
break;
case 280:
#line 1654 "pars.yacc"
{ g[cg].vp.loctype = yyvsp[0].pset; }
break;
case 281:
#line 1655 "pars.yacc"
{ g[cg].vp.arrowtype = (int) yyvsp[0].val; }
break;
case 282:
#line 1659 "pars.yacc"
{ yyval.pset = XY; }
break;
case 283:
#line 1660 "pars.yacc"
{ yyval.pset = XYARC; }
break;
case 284:
#line 1661 "pars.yacc"
{ yyval.pset = XYBOX; }
break;
case 285:
#line 1662 "pars.yacc"
{ yyval.pset = XYBOXPLOT; }
break;
case 286:
#line 1663 "pars.yacc"
{ yyval.pset = XYHILO; }
break;
case 287:
#line 1664 "pars.yacc"
{ yyval.pset = XYRT; }
break;
case 288:
#line 1665 "pars.yacc"
{ yyval.pset = XYSEG; }
break;
case 289:
#line 1666 "pars.yacc"
{ yyval.pset = XYSTRING; }
break;
case 290:
#line 1667 "pars.yacc"
{ yyval.pset = XYDX; }
break;
case 291:
#line 1668 "pars.yacc"
{ yyval.pset = XYDY; }
break;
case 292:
#line 1669 "pars.yacc"
{ yyval.pset = XYDXDX; }
break;
case 293:
#line 1670 "pars.yacc"
{ yyval.pset = XYDYDY; }
break;
case 294:
#line 1671 "pars.yacc"
{ yyval.pset = XYDXDY; }
break;
case 295:
#line 1672 "pars.yacc"
{ yyval.pset = XYX2Y2; }
break;
case 296:
#line 1673 "pars.yacc"
{ yyval.pset = XYXX; }
break;
case 297:
#line 1674 "pars.yacc"
{ yyval.pset = XYYY; }
break;
case 298:
#line 1675 "pars.yacc"
{ yyval.pset = XYZ; }
break;
case 299:
#line 1676 "pars.yacc"
{ yyval.pset = XYZW; }
break;
case 300:
#line 1677 "pars.yacc"
{ yyval.pset = XYUV; }
break;
case 301:
#line 1678 "pars.yacc"
{ yyval.pset = TSV; }
break;
case 302:
#line 1679 "pars.yacc"
{ yyval.pset = NXY; }
break;
case 303:
#line 1680 "pars.yacc"
{ yyval.pset = BIN; }
break;
case 304:
#line 1681 "pars.yacc"
{ yyval.pset = POLY; }
break;
case 305:
#line 1682 "pars.yacc"
{ yyval.pset = RAWSPICE; }
break;
case 306:
#line 1686 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 307:
#line 1687 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 308:
#line 1688 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 309:
#line 1689 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 310:
#line 1690 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 311:
#line 1691 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 312:
#line 1692 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 313:
#line 1693 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 314:
#line 1694 "pars.yacc"
{ yyval.pset = XY;		/* not active */ }
break;
case 315:
#line 1695 "pars.yacc"
{ yyval.pset = XY;		/* not active */ }
break;
case 316:
#line 1696 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 317:
#line 1697 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 318:
#line 1698 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 319:
#line 1702 "pars.yacc"
{ yyval.pset = FREE; }
break;
case 320:
#line 1703 "pars.yacc"
{ yyval.pset = LANDSCAPE; }
break;
case 321:
#line 1704 "pars.yacc"
{ yyval.pset = PORTRAIT; }
break;
case 322:
#line 1705 "pars.yacc"
{ yyval.pset = FIXED; }
break;
case 330:
#line 1733 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ACTIVE, yyvsp[0].pset, 0);
	}
break;
case 331:
#line 1736 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ACTIVE, yyvsp[0].pset, 0);
	}
break;
case 332:
#line 1739 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, TYPE, yyvsp[0].pset, 0);
	}
break;
case 333:
#line 1742 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, MISSINGP, yyvsp[0].val, 0);
	}
break;
case 334:
#line 1745 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, PREC, (int) yyvsp[0].val, 0);
	}
break;
case 335:
#line 1748 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, FORMAT, yyvsp[0].pset, 0);
	}
break;
case 336:
#line 1751 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, TYPE, (int) yyvsp[0].val, 0);
	}
break;
case 337:
#line 1754 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, FILL, (int) yyvsp[0].val, 0);
	}
break;
case 338:
#line 1757 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, CENTER, (yyvsp[0].pset == TRUEP), 0);
	}
break;
case 339:
#line 1760 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, SIZE, yyvsp[0].val, 0);
	}
break;
case 340:
#line 1763 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, CHAR, (int) yyvsp[0].val, 0);
	}
break;
case 341:
#line 1766 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, SKIP, (int) yyvsp[0].val, 0);
	}
break;
case 342:
#line 1769 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, COLOR, (int) yyvsp[0].val, 0);
	}
break;
case 343:
#line 1772 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, LINEWIDTH, (int) yyvsp[0].val, 0);
	}
break;
case 344:
#line 1775 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, LINESTYLE, (int) yyvsp[0].val, 0);
	}
break;
case 345:
#line 1778 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, yyvsp[-1].pset, (int) yyvsp[0].val, 0);
	}
break;
case 346:
#line 1781 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, FILL, TYPE, (int) yyvsp[0].val, 0);
	}
break;
case 347:
#line 1784 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, FILL, WITH, yyvsp[0].pset, 0);
	}
break;
case 348:
#line 1787 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, FILL, yyvsp[-1].pset, (int) yyvsp[0].val, 0);
	}
break;
case 349:
#line 1790 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SKIP, (int) yyvsp[0].val, 0);
	}
break;
case 350:
#line 1793 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ERRORBAR, LENGTH, yyvsp[0].val, 0);
	}
break;
case 351:
#line 1796 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ERRORBAR, TYPE, yyvsp[0].pset, 0);
	}
break;
case 352:
#line 1799 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ERRORBAR, LINEWIDTH, (int) yyvsp[0].val, 0);
	}
break;
case 353:
#line 1802 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ERRORBAR, LINESTYLE, (int) yyvsp[0].val, 0);
	}
break;
case 354:
#line 1805 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ERRORBAR, RISER, ACTIVE, yyvsp[0].pset, 0);
	}
break;
case 355:
#line 1808 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ERRORBAR, RISER, LINEWIDTH, (int) yyvsp[0].val, 0);
	}
break;
case 356:
#line 1811 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ERRORBAR, RISER, LINESTYLE, (int) yyvsp[0].val, 0);
	}
break;
case 357:
#line 1814 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, XYZ, yyvsp[-2].val, yyvsp[0].val, 0);
	}
break;
case 358:
#line 1817 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, COMMENT, (char *) yyvsp[0].pset, 0);
	    free((char *) yyvsp[0].pset);
	}
break;
case 374:
#line 1848 "pars.yacc"
{
	    set_axis_prop(whichgraph, naxis, yyvsp[0].pset, 0.0);
	}
break;
case 375:
#line 1851 "pars.yacc"
{
	    set_axis_prop(whichgraph, naxis, yyvsp[-1].pset, yyvsp[0].val);
	}
break;
case 376:
#line 1854 "pars.yacc"
{
	    set_axis_prop(whichgraph, naxis, yyvsp[-1].pset, yyvsp[0].val);
	}
break;
case 377:
#line 1857 "pars.yacc"
{
	    set_axis_prop(whichgraph, naxis, yyvsp[-1].pset, yyvsp[0].val);
	}
break;
case 378:
#line 1860 "pars.yacc"
{
	    set_axis_prop(whichgraph, naxis, yyvsp[-1].pset, yyvsp[0].val);
	}
break;
case 379:
#line 1863 "pars.yacc"
{
	    set_axis_prop(whichgraph, naxis, yyvsp[-2].pset, yyvsp[0].val);
	}
break;
case 380:
#line 1866 "pars.yacc"
{
	    set_axis_prop(whichgraph, naxis, yyvsp[-1].pset, yyvsp[0].pset);
	}
break;
case 385:
#line 1876 "pars.yacc"
{
	    g[cg].t[naxis].active = yyvsp[0].pset;
	}
break;
case 388:
#line 1888 "pars.yacc"
{
	    g[cg].t[naxis].t_flag = yyvsp[0].pset;
	    g[cg].t[naxis].t_mflag = yyvsp[0].pset;
	}
break;
case 389:
#line 1892 "pars.yacc"
{
	    g[cg].t[naxis].t_flag = yyvsp[0].pset;
	}
break;
case 390:
#line 1895 "pars.yacc"
{
	    g[cg].t[naxis].t_mflag = yyvsp[0].pset;
	}
break;
case 391:
#line 1898 "pars.yacc"
{
	    g[cg].t[naxis].tmajor = yyvsp[0].val;
	}
break;
case 392:
#line 1901 "pars.yacc"
{
	    g[cg].t[naxis].tminor = yyvsp[0].val;
	}
break;
case 393:
#line 1904 "pars.yacc"
{
	    g[cg].t[naxis].offsx = yyvsp[0].val;
	}
break;
case 394:
#line 1907 "pars.yacc"
{
	    g[cg].t[naxis].offsy = yyvsp[0].val;
	}
break;
case 395:
#line 1910 "pars.yacc"
{
	    g[cg].t[naxis].alt = yyvsp[0].pset;
	}
break;
case 396:
#line 1913 "pars.yacc"
{
	    g[cg].t[naxis].tmin = yyvsp[0].val;
	}
break;
case 397:
#line 1916 "pars.yacc"
{
	    g[cg].t[naxis].tmax = yyvsp[0].val;
	}
break;
case 398:
#line 1919 "pars.yacc"
{
	    g[cg].t[naxis].t_num = (int) yyvsp[0].val;
	}
break;
case 399:
#line 1922 "pars.yacc"
{
	    g[cg].t[naxis].t_inout = yyvsp[0].pset;
	}
break;
case 400:
#line 1925 "pars.yacc"
{
	    g[cg].t[naxis].t_log = yyvsp[0].pset;
	}
break;
case 401:
#line 1928 "pars.yacc"
{
	    g[cg].t[naxis].t_size = yyvsp[0].val;
	}
break;
case 402:
#line 1931 "pars.yacc"
{
	    g[cg].t[naxis].t_size = yyvsp[0].val;
	}
break;
case 403:
#line 1934 "pars.yacc"
{
	    g[cg].t[naxis].t_msize = yyvsp[0].val;
	}
break;
case 404:
#line 1937 "pars.yacc"
{
	    g[cg].t[naxis].t_color = g[cg].t[naxis].t_mcolor = (int) yyvsp[0].val;
	}
break;
case 405:
#line 1940 "pars.yacc"
{
	    g[cg].t[naxis].t_linew = g[cg].t[naxis].t_mlinew = (int) yyvsp[0].val;
	}
break;
case 406:
#line 1943 "pars.yacc"
{
	    g[cg].t[naxis].t_color = (int) yyvsp[0].val;
	}
break;
case 407:
#line 1946 "pars.yacc"
{
	    g[cg].t[naxis].t_mcolor = (int) yyvsp[0].val;
	}
break;
case 408:
#line 1949 "pars.yacc"
{
	    g[cg].t[naxis].t_linew = (int) yyvsp[0].val;
	}
break;
case 409:
#line 1952 "pars.yacc"
{
	    g[cg].t[naxis].t_mlinew = (int) yyvsp[0].val;
	}
break;
case 410:
#line 1955 "pars.yacc"
{
	    g[cg].t[naxis].t_lines = (int) yyvsp[0].val;
	}
break;
case 411:
#line 1958 "pars.yacc"
{
	    g[cg].t[naxis].t_mlines = (int) yyvsp[0].val;
	}
break;
case 412:
#line 1961 "pars.yacc"
{
	    g[cg].t[naxis].t_gridflag = yyvsp[0].pset;
	}
break;
case 413:
#line 1964 "pars.yacc"
{
	    g[cg].t[naxis].t_mgridflag = yyvsp[0].pset;
	}
break;
case 414:
#line 1967 "pars.yacc"
{
	    g[cg].t[naxis].t_op = yyvsp[0].pset;
	}
break;
case 415:
#line 1970 "pars.yacc"
{
	    g[cg].t[naxis].t_type = AUTO;
	}
break;
case 416:
#line 1973 "pars.yacc"
{
	    g[cg].t[naxis].t_type = SPEC;
	}
break;
case 417:
#line 1976 "pars.yacc"
{
	    g[cg].t[naxis].t_spec = (int) yyvsp[0].val;
	}
break;
case 418:
#line 1979 "pars.yacc"
{
	    g[cg].t[naxis].t_specloc[(int) yyvsp[-2].val] = yyvsp[0].val;
	}
break;
case 421:
#line 1990 "pars.yacc"
{
	    g[cg].t[naxis].tl_flag = yyvsp[0].pset;
	}
break;
case 422:
#line 1993 "pars.yacc"
{
	    g[cg].t[naxis].tl_type = AUTO;
	}
break;
case 423:
#line 1996 "pars.yacc"
{
	    g[cg].t[naxis].tl_type = SPEC;
	}
break;
case 424:
#line 1999 "pars.yacc"
{
	    g[cg].t[naxis].tl_prec = (int) yyvsp[0].val;
	}
break;
case 425:
#line 2002 "pars.yacc"
{
	    g[cg].t[naxis].tl_format = yyvsp[0].pset;
	}
break;
case 426:
#line 2005 "pars.yacc"
{
	    g[cg].t[naxis].tl_format = yyvsp[0].val;
	}
break;
case 427:
#line 2008 "pars.yacc"
{
	    strcpy(g[cg].t[naxis].tl_appstr, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 428:
#line 2012 "pars.yacc"
{
	    strcpy(g[cg].t[naxis].tl_prestr, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 429:
#line 2016 "pars.yacc"
{
	    g[cg].t[naxis].tl_layout = HORIZONTAL;
	}
break;
case 430:
#line 2019 "pars.yacc"
{
	    g[cg].t[naxis].tl_layout = VERTICAL;
	}
break;
case 431:
#line 2022 "pars.yacc"
{
	    g[cg].t[naxis].tl_layout = SPEC;
	}
break;
case 432:
#line 2025 "pars.yacc"
{
	    g[cg].t[naxis].tl_layout = ON;
	}
break;
case 433:
#line 2028 "pars.yacc"
{
	    g[cg].t[naxis].tl_layout = CENTER;
	}
break;
case 434:
#line 2031 "pars.yacc"
{
	    g[cg].t[naxis].tl_layout = LEFT;
	}
break;
case 435:
#line 2034 "pars.yacc"
{
	    g[cg].t[naxis].tl_layout = RIGHT;
	}
break;
case 436:
#line 2037 "pars.yacc"
{
	    g[cg].t[naxis].tl_angle = (int) yyvsp[0].val;
	}
break;
case 437:
#line 2040 "pars.yacc"
{
	    g[cg].t[naxis].tl_just = (int) yyvsp[0].pset;
	}
break;
case 438:
#line 2043 "pars.yacc"
{
	    g[cg].t[naxis].tl_skip = (int) yyvsp[0].val;
	}
break;
case 439:
#line 2046 "pars.yacc"
{
	    g[cg].t[naxis].tl_staggered = (int) yyvsp[0].val;
	}
break;
case 440:
#line 2049 "pars.yacc"
{
	    g[cg].t[naxis].tl_op = yyvsp[0].pset;
	}
break;
case 441:
#line 2052 "pars.yacc"
{
	    g[cg].t[naxis].tl_sign = yyvsp[0].pset;
	}
break;
case 442:
#line 2055 "pars.yacc"
{
	    g[cg].t[naxis].tl_start = yyvsp[0].val;
	}
break;
case 443:
#line 2058 "pars.yacc"
{
	    g[cg].t[naxis].tl_stop = yyvsp[0].val;
	}
break;
case 444:
#line 2061 "pars.yacc"
{
	    g[cg].t[naxis].tl_starttype = (int) yyvsp[0].pset;
	}
break;
case 445:
#line 2064 "pars.yacc"
{
	    g[cg].t[naxis].tl_starttype = (int) yyvsp[0].pset;
	}
break;
case 446:
#line 2067 "pars.yacc"
{
	    g[cg].t[naxis].tl_stoptype = (int) yyvsp[0].pset;
	}
break;
case 447:
#line 2070 "pars.yacc"
{
	    g[cg].t[naxis].tl_stoptype = (int) yyvsp[0].pset;
	}
break;
case 448:
#line 2073 "pars.yacc"
{
	    g[cg].t[naxis].tl_vgap = yyvsp[0].val;
	}
break;
case 449:
#line 2076 "pars.yacc"
{
	    g[cg].t[naxis].tl_hgap = yyvsp[0].val;
	}
break;
case 450:
#line 2079 "pars.yacc"
{
	    g[cg].t[naxis].tl_charsize = yyvsp[0].val;
	}
break;
case 451:
#line 2082 "pars.yacc"
{
	    g[cg].t[naxis].tl_font = (int) yyvsp[0].val;
	}
break;
case 452:
#line 2085 "pars.yacc"
{
	    g[cg].t[naxis].tl_color = (int) yyvsp[0].val;
	}
break;
case 453:
#line 2088 "pars.yacc"
{
	    g[cg].t[naxis].tl_linew = (int) yyvsp[0].val;
	}
break;
case 454:
#line 2091 "pars.yacc"
{
	    set_plotstr_string(&g[cg].t[naxis].t_speclab[(int) yyvsp[-2].val], (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 455:
#line 2098 "pars.yacc"
{
	    set_plotstr_string(&g[cg].t[naxis].label, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 456:
#line 2102 "pars.yacc"
{
	    g[cg].t[naxis].label_layout = PERP;
	}
break;
case 457:
#line 2105 "pars.yacc"
{
	    g[cg].t[naxis].label_layout = PARA;
	}
break;
case 458:
#line 2108 "pars.yacc"
{
	    g[cg].t[naxis].label_place = yyvsp[0].pset;
	}
break;
case 459:
#line 2111 "pars.yacc"
{
	    g[cg].t[naxis].label_place = yyvsp[0].pset;
	}
break;
case 460:
#line 2114 "pars.yacc"
{
	    g[cg].t[naxis].label.x = yyvsp[-2].val;
	    g[cg].t[naxis].label.y = yyvsp[0].val;
	}
break;
case 461:
#line 2118 "pars.yacc"
{
	    g[cg].t[naxis].label.just = (int) yyvsp[0].pset;
	}
break;
case 462:
#line 2121 "pars.yacc"
{
	    g[cg].t[naxis].label.charsize = yyvsp[0].val;
	}
break;
case 463:
#line 2124 "pars.yacc"
{
	    g[cg].t[naxis].label.font = (int) yyvsp[0].val;
	}
break;
case 464:
#line 2127 "pars.yacc"
{
	    g[cg].t[naxis].label.color = (int) yyvsp[0].val;
	}
break;
case 465:
#line 2130 "pars.yacc"
{
	    g[cg].t[naxis].label.linew = (int) yyvsp[0].val;
	}
break;
case 466:
#line 2136 "pars.yacc"
{
	    g[cg].t[naxis].t_drawbar = yyvsp[0].pset;
	}
break;
case 467:
#line 2139 "pars.yacc"
{
	    g[cg].t[naxis].t_drawbarcolor = (int) yyvsp[0].val;
	}
break;
case 468:
#line 2142 "pars.yacc"
{
	    g[cg].t[naxis].t_drawbarlines = (int) yyvsp[0].val;
	}
break;
case 469:
#line 2145 "pars.yacc"
{
	    g[cg].t[naxis].t_drawbarlinew = (int) yyvsp[0].val;
	}
break;
case 470:
#line 2152 "pars.yacc"
{
	    whichgraph = yyvsp[-2].pset;
	    whichset = yyvsp[0].pset;
	}
break;
case 471:
#line 2157 "pars.yacc"
{
	    whichgraph = cg;
	    whichset = yyvsp[0].pset;
	}
break;
case 472:
#line 2162 "pars.yacc"
{
	    whichgraph = cg;
	    whichset = yyvsp[0].pset;
	}
break;
case 473:
#line 2167 "pars.yacc"
{
	    whichgraph = yyvsp[-1].pset;
	    whichset = yyvsp[0].pset;
	}
break;
case 474:
#line 2172 "pars.yacc"
{
	    whichgraph = yyvsp[-1].pset;
	    whichset = yyvsp[0].pset;
	}
break;
case 475:
#line 2177 "pars.yacc"
{
	    whichgraph = yyvsp[-1].pset;
	    whichset = yyvsp[0].pset;
	}
break;
case 476:
#line 2183 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 477:
#line 2184 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 478:
#line 2185 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 479:
#line 2186 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 480:
#line 2187 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 481:
#line 2190 "pars.yacc"
{ yyval.pset = ON; }
break;
case 482:
#line 2191 "pars.yacc"
{ yyval.pset = OFF; }
break;
case 483:
#line 2194 "pars.yacc"
{ yyval.pset = COLOR; }
break;
case 484:
#line 2195 "pars.yacc"
{ yyval.pset = PATTERN; }
break;
case 485:
#line 2198 "pars.yacc"
{ yyval.pset = RUNAVG; }
break;
case 486:
#line 2199 "pars.yacc"
{ yyval.pset = RUNSTD; }
break;
case 487:
#line 2200 "pars.yacc"
{ yyval.pset = RUNMED; }
break;
case 488:
#line 2201 "pars.yacc"
{ yyval.pset = RUNMAX; }
break;
case 489:
#line 2202 "pars.yacc"
{ yyval.pset = RUNMIN; }
break;
case 490:
#line 2205 "pars.yacc"
{ yyval.pset = DFT; }
break;
case 491:
#line 2206 "pars.yacc"
{ yyval.pset = FFT; }
break;
case 492:
#line 2207 "pars.yacc"
{ yyval.pset = INVDFT; }
break;
case 493:
#line 2208 "pars.yacc"
{ yyval.pset = INVFFT; }
break;
case 494:
#line 2211 "pars.yacc"
{ yyval.pset = DISK; }
break;
case 495:
#line 2212 "pars.yacc"
{ yyval.pset = PIPE; }
break;
case 496:
#line 2215 "pars.yacc"
{ yyval.pset = PATTERN; }
break;
case 497:
#line 2216 "pars.yacc"
{ yyval.pset = COLOR; }
break;
case 498:
#line 2217 "pars.yacc"
{ yyval.pset = NONE; }
break;
case 499:
#line 2220 "pars.yacc"
{ yyval.pset = TOP; }
break;
case 500:
#line 2221 "pars.yacc"
{ yyval.pset = BOTTOM; }
break;
case 501:
#line 2222 "pars.yacc"
{ yyval.pset = LEFT; }
break;
case 502:
#line 2223 "pars.yacc"
{ yyval.pset = RIGHT; }
break;
case 503:
#line 2224 "pars.yacc"
{ yyval.pset = BOTH; }
break;
case 504:
#line 2227 "pars.yacc"
{ yyval.pset = RIGHT; }
break;
case 505:
#line 2228 "pars.yacc"
{ yyval.pset = LEFT; }
break;
case 506:
#line 2229 "pars.yacc"
{ yyval.pset = CENTER; }
break;
case 507:
#line 2232 "pars.yacc"
{ yyval.pset = MINP; }
break;
case 508:
#line 2233 "pars.yacc"
{ yyval.pset = MAXP; }
break;
case 509:
#line 2236 "pars.yacc"
{ yyval.pset = TRUEP; }
break;
case 510:
#line 2237 "pars.yacc"
{ yyval.pset = FALSEP; }
break;
case 511:
#line 2240 "pars.yacc"
{ yyval.pset = IN; }
break;
case 512:
#line 2241 "pars.yacc"
{ yyval.pset = OUT; }
break;
case 513:
#line 2242 "pars.yacc"
{ yyval.pset = BOTH; }
break;
case 514:
#line 2245 "pars.yacc"
{ yyval.pset = DECIMAL; }
break;
case 515:
#line 2246 "pars.yacc"
{ yyval.pset = EXPONENTIAL; }
break;
case 516:
#line 2247 "pars.yacc"
{ yyval.pset = POWER; }
break;
case 517:
#line 2248 "pars.yacc"
{ yyval.pset = GENERAL; }
break;
case 518:
#line 2249 "pars.yacc"
{ yyval.pset = DDMMYY; }
break;
case 519:
#line 2250 "pars.yacc"
{ yyval.pset = MMDDYY; }
break;
case 520:
#line 2251 "pars.yacc"
{ yyval.pset = YYMMDD; }
break;
case 521:
#line 2252 "pars.yacc"
{ yyval.pset = MMYY; }
break;
case 522:
#line 2253 "pars.yacc"
{ yyval.pset = MMDD; }
break;
case 523:
#line 2254 "pars.yacc"
{ yyval.pset = MONTHDAY; }
break;
case 524:
#line 2255 "pars.yacc"
{ yyval.pset = DAYMONTH; }
break;
case 525:
#line 2256 "pars.yacc"
{ yyval.pset = MONTHS; }
break;
case 526:
#line 2257 "pars.yacc"
{ yyval.pset = MONTHSY; }
break;
case 527:
#line 2258 "pars.yacc"
{ yyval.pset = MONTHL; }
break;
case 528:
#line 2259 "pars.yacc"
{ yyval.pset = DAYOFWEEKS; }
break;
case 529:
#line 2260 "pars.yacc"
{ yyval.pset = DAYOFWEEKL; }
break;
case 530:
#line 2261 "pars.yacc"
{ yyval.pset = DAYOFYEAR; }
break;
case 531:
#line 2262 "pars.yacc"
{ yyval.pset = HMS; }
break;
case 532:
#line 2263 "pars.yacc"
{ yyval.pset = MMDDHMS; }
break;
case 533:
#line 2264 "pars.yacc"
{ yyval.pset = MMDDYYHMS; }
break;
case 534:
#line 2265 "pars.yacc"
{ yyval.pset = YYMMDDHMS; }
break;
case 535:
#line 2266 "pars.yacc"
{ yyval.pset = DEGREESLON; }
break;
case 536:
#line 2267 "pars.yacc"
{ yyval.pset = DEGREESMMLON; }
break;
case 537:
#line 2268 "pars.yacc"
{ yyval.pset = DEGREESMMSSLON; }
break;
case 538:
#line 2269 "pars.yacc"
{ yyval.pset = MMSSLON; }
break;
case 539:
#line 2270 "pars.yacc"
{ yyval.pset = DEGREESLAT; }
break;
case 540:
#line 2271 "pars.yacc"
{ yyval.pset = DEGREESMMLAT; }
break;
case 541:
#line 2272 "pars.yacc"
{ yyval.pset = DEGREESMMSSLAT; }
break;
case 542:
#line 2273 "pars.yacc"
{ yyval.pset = MMSSLAT; }
break;
case 543:
#line 2276 "pars.yacc"
{ yyval.pset = NORMAL; }
break;
case 544:
#line 2277 "pars.yacc"
{ yyval.pset = ABSOLUTE; }
break;
case 545:
#line 2278 "pars.yacc"
{ yyval.pset = NEGATE; }
break;
case 546:
#line 2281 "pars.yacc"
{ yyval.pset = UP; }
break;
case 547:
#line 2282 "pars.yacc"
{ yyval.pset = DOWN; }
break;
case 548:
#line 2283 "pars.yacc"
{ yyval.pset = RIGHT; }
break;
case 549:
#line 2284 "pars.yacc"
{ yyval.pset = LEFT; }
break;
case 550:
#line 2285 "pars.yacc"
{ yyval.pset = IN; }
break;
case 551:
#line 2286 "pars.yacc"
{ yyval.pset = OUT; }
break;
case 552:
#line 2289 "pars.yacc"
{ yyval.pset = WORLD; }
break;
case 553:
#line 2290 "pars.yacc"
{ yyval.pset = VIEW; }
break;
case 554:
#line 2293 "pars.yacc"
{ yyval.pset = ASCENDING; }
break;
case 555:
#line 2294 "pars.yacc"
{ yyval.pset = DESCENDING; }
break;
case 556:
#line 2297 "pars.yacc"
{ yyval.pset = X; }
break;
case 557:
#line 2298 "pars.yacc"
{ yyval.pset = Y; }
break;
case 558:
#line 2301 "pars.yacc"
{ yyval.pset = X; }
break;
case 559:
#line 2302 "pars.yacc"
{ yyval.pset = Y; }
break;
case 560:
#line 2303 "pars.yacc"
{ yyval.pset = X0; }
break;
case 561:
#line 2304 "pars.yacc"
{ yyval.pset = Y0; }
break;
case 562:
#line 2305 "pars.yacc"
{ yyval.pset = Y1; }
break;
case 563:
#line 2306 "pars.yacc"
{ yyval.pset = Y2; }
break;
case 564:
#line 2307 "pars.yacc"
{ yyval.pset = Y3; }
break;
case 565:
#line 2308 "pars.yacc"
{ yyval.pset = Y4; }
break;
case 566:
#line 2309 "pars.yacc"
{ yyval.pset = Y5; }
break;
case 567:
#line 2314 "pars.yacc"
{
	    int itmp = (int) yyvsp[-3].val - 1;
	    if (itmp >= ls) {
		yyerror("Subscript out of range");
		return 1;
	    } else {
		yyvsp[-5].ptr[itmp] = yyvsp[0].val;
		result = yyvsp[0].val;
	    }
	}
break;
case 568:
#line 2325 "pars.yacc"
{
	    int itmp = (int) yyvsp[-3].val - 1;
	    double *ptr = getvptr(cg, curset, yyvsp[-3].val);
	    if (ptr != NULL) {
	        ptr[itmp] = yyvsp[0].val;
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    result = yyvsp[0].val;
	    updatesetminmax(cg, curset);
#ifndef GRBATCH
	    update_set_status(cg, curset);
#endif
	}
break;
case 569:
#line 2342 "pars.yacc"
{
	    int itmp = (int) yyvsp[-3].val - 1;
	    double *ptr = getvptr(cg, yyvsp[-7].pset, yyvsp[-5].pset);
	    if (ptr != NULL) {
	        ptr[itmp] = yyvsp[0].val;
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    result = yyvsp[0].val;
	    updatesetminmax(cg, yyvsp[-7].pset);
#ifndef GRBATCH
	    update_set_status(cg, yyvsp[-7].pset);
#endif
	}
break;
case 570:
#line 2359 "pars.yacc"
{
	    set_prop(cg, SET, SETNUM, yyvsp[-4].pset, SYMBOL, TYPE, (int) yyvsp[0].val, 0);
	    result = 0;
	}
break;
case 571:
#line 2371 "pars.yacc"
{
	    int itmp = (int) yyvsp[-3].val - 1;
	    double *ptr = getvptr(yyvsp[-9].pset, yyvsp[-7].pset, yyvsp[-5].pset);
	    if (ptr != NULL) {
	        ptr[itmp] = yyvsp[0].val;
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    result = yyvsp[0].val;
	    updatesetminmax(yyvsp[-9].pset, yyvsp[-7].pset);
#ifndef GRBATCH
	    update_set_status(yyvsp[-9].pset, yyvsp[-7].pset);
#endif
	}
break;
case 572:
#line 2391 "pars.yacc"
{
	    if (yyvsp[-2].pset == X) {
		*xx = yyvsp[0].val;
	    } else {
		*yy = yyvsp[0].val;
	    }
	}
break;
case 573:
#line 2402 "pars.yacc"
{
	    int i;
	    if (ls < 0) {
		yyerror("Length of array < 0");
		return 1;
	    } else if (ls > maxarr) {
		maxarr = ls;
		init_scratch_arrays(ls);
	    }
	    for (i = 0; i < lxy; i++) {
		yyvsp[-2].ptr[i] = yyvsp[0].ptr[i];
	    }
	    result = yyvsp[0].ptr[0];
	}
break;
case 574:
#line 2417 "pars.yacc"
{
	    int i;
	    double *ptr;
	    if (!isactive_set(cg, curset)) {
		activateset(cg, curset);
		setlength(cg, curset, lxy);
		setcomment(cg, curset, "Created");
	    }
	    ptr = getvptr(cg, curset, yyvsp[-2].pset);
	    if (ptr != NULL) {
	        for (i = 0; i < lxy; i++) {
		    ptr[i] = yyvsp[0].ptr[i];
	        }
	        result = yyvsp[0].ptr[0];
	        updatesetminmax(cg, curset);
#ifndef GRBATCH
	        update_set_status(cg, curset);
#endif
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 575:
#line 2442 "pars.yacc"
{
	    if (isactive_set(cg, yyvsp[0].pset)) {
	        do_copyset(cg, yyvsp[0].pset, cg, yyvsp[-2].pset);
	    } else {
		yyerror("Right value set not active");
	    }
	    result = 0;
	}
break;
case 576:
#line 2451 "pars.yacc"
{
	    if (isactive_set(cg, yyvsp[0].pset)) {
	        do_copyset(cg, yyvsp[0].pset, yyvsp[-4].pset, yyvsp[-2].pset);
	    } else {
		yyerror("Right value set not active");
	    }
	    result = 0;
	}
break;
case 577:
#line 2460 "pars.yacc"
{
	    if (isactive_set(yyvsp[-2].pset, yyvsp[0].pset)) {
	        do_copyset(yyvsp[-2].pset, yyvsp[0].pset, cg, yyvsp[-4].pset);
	    } else {
		yyerror("Right value set not active");
	    }
	    result = 0;
	}
break;
case 578:
#line 2469 "pars.yacc"
{
	    if (isactive_set(yyvsp[-2].pset, yyvsp[0].pset)) {
	        do_copyset(yyvsp[-2].pset, yyvsp[0].pset, yyvsp[-6].pset, yyvsp[-4].pset);
	    } else {
		yyerror("Right value set not active");
	    }
	    result = 0;
	}
break;
case 579:
#line 2477 "pars.yacc"
{
	    int i;
	    double *ptr;
	    if (!isactive_set(cg, yyvsp[-4].pset)) {
		activateset(cg, yyvsp[-4].pset);
		setlength(cg, yyvsp[-4].pset, lxy);
		setcomment(cg, yyvsp[-4].pset, "Created");
	    }
	    ptr = getvptr(cg, yyvsp[-4].pset, yyvsp[-2].pset);
	    if (ptr != NULL) {
	        for (i = 0; i < lxy; i++) {
		    ptr[i] = yyvsp[0].ptr[i];
	        }
	        result = yyvsp[0].ptr[0];
	        updatesetminmax(cg, yyvsp[-4].pset);
#ifndef GRBATCH
	        update_set_status(cg, yyvsp[-4].pset);
#endif
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 580:
#line 2502 "pars.yacc"
{
	    int i;
	    double *ptr;
	    if (!isactive_set(yyvsp[-6].pset, yyvsp[-4].pset)) {
		activateset(yyvsp[-6].pset, yyvsp[-4].pset);
		setlength(yyvsp[-6].pset, yyvsp[-4].pset, lxy);
		setcomment(yyvsp[-6].pset, yyvsp[-4].pset, "Created");
	    }
	    ptr = getvptr(yyvsp[-6].pset, yyvsp[-4].pset, yyvsp[-2].pset);
	    if (ptr != NULL) {
	        for (i = 0; i < lxy; i++) {
		    ptr[i] = yyvsp[0].ptr[i];
	        }
	        result = yyvsp[0].ptr[0];
	        updatesetminmax(yyvsp[-6].pset, yyvsp[-4].pset);
#ifndef GRBATCH
	        update_set_status(yyvsp[-6].pset, yyvsp[-4].pset);
#endif
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 581:
#line 2527 "pars.yacc"
{
	    int i;
	    if (lxy < 0) {
		yyerror("Length of array < 0");
		return 1;
	    } else if (lxy > maxarr) {
		maxarr = lxy;
		init_scratch_arrays(lxy);
	    }
	    for (i = 0; i < lxy; i++) {
		yyvsp[-2].ptr[i] = yyvsp[0].val;
	    }
	    result = yyvsp[0].val;
	}
break;
case 582:
#line 2542 "pars.yacc"
{
	    int i;
	    double *ptr;
	    if (!isactive_set(cg, curset)) {
		activateset(cg, curset);
		setlength(cg, curset, lxy);
		setcomment(cg, curset, "Created");
	    }
	    ptr = getvptr(cg, curset, yyvsp[-2].pset);
	    if (ptr != NULL) {
	        for (i = 0; i < lxy; i++) {
		    ptr[i] = yyvsp[0].val;
	        }
	        result = yyvsp[0].val;
	        updatesetminmax(cg, curset);
#ifndef GRBATCH
	        update_set_status(cg, curset);
#endif
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 583:
#line 2567 "pars.yacc"
{
	    int i;
	    double *ptr;
	    if (!isactive_set(cg, yyvsp[-4].pset)) {
		activateset(cg, yyvsp[-4].pset);
		setlength(cg, yyvsp[-4].pset, lxy);
		setcomment(cg, yyvsp[-4].pset, "Created");
	    }
	    ptr = getvptr(cg, yyvsp[-4].pset, yyvsp[-2].pset);
	    if (ptr != NULL) {
	        for (i = 0; i < lxy; i++) {
		    ptr[i] = yyvsp[0].val;
	        }
	        result = yyvsp[0].val;
	        updatesetminmax(cg, yyvsp[-4].pset);
#ifndef GRBATCH
	        update_set_status(cg, yyvsp[-4].pset);
#endif
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 584:
#line 2592 "pars.yacc"
{
	    int i;
	    double *ptr;
	    if (!isactive_set(yyvsp[-6].pset, yyvsp[-4].pset)) {
		activateset(yyvsp[-6].pset, yyvsp[-4].pset);
		setlength(yyvsp[-6].pset, yyvsp[-4].pset, lxy);
		setcomment(yyvsp[-6].pset, yyvsp[-4].pset, "Created");
	    }
	    ptr = getvptr(yyvsp[-6].pset, yyvsp[-4].pset, yyvsp[-2].pset);
	    if (ptr != NULL) {
	        for (i = 0; i < lxy; i++) {
		    ptr[i] = yyvsp[0].val;
	        }
	        result = yyvsp[0].val;
	        updatesetminmax(yyvsp[-6].pset, yyvsp[-4].pset);
#ifndef GRBATCH
	        update_set_status(yyvsp[-6].pset, yyvsp[-4].pset);
#endif
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 585:
#line 2620 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    if (lxy < 0) {
		yyerror("Length of array < 0");
		return 1;
	    } else if (lxy > maxarr) {
		maxarr = lxy;
		init_scratch_arrays(lxy);
	    }
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[0].ptr[i];
	    }
	}
break;
case 586:
#line 2636 "pars.yacc"
{
	    int i;
	    double *ptr = getvptr(cg, curset, yyvsp[0].pset);
	    if (ptr == NULL) {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = ptr[i];
	    }
	}
break;
case 587:
#line 2650 "pars.yacc"
{
	    int i;
	    double *ptr = getvptr(cg, yyvsp[-2].pset, yyvsp[0].pset);
	    if (ptr == NULL) {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = ptr[i];
	    }
	}
break;
case 588:
#line 2664 "pars.yacc"
{
	    int i;
	    double *ptr = getvptr(yyvsp[-4].pset, yyvsp[-2].pset, yyvsp[0].pset);
	    if (ptr == NULL) {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = ptr[i];
	    }
	}
break;
case 589:
#line 2678 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[0].val;
	    }
	}
break;
case 590:
#line 2687 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val + yyvsp[0].val;
	    }
	}
break;
case 591:
#line 2696 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] + yyvsp[0].ptr[i];
	    }
	}
break;
case 592:
#line 2705 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val + yyvsp[0].ptr[i];
	    }
	}
break;
case 593:
#line 2714 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] + yyvsp[0].val;
	    }
	}
break;
case 594:
#line 2723 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val - yyvsp[0].val;
	    }
	}
break;
case 595:
#line 2732 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] - yyvsp[0].ptr[i];
	    }
	}
break;
case 596:
#line 2741 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val - yyvsp[0].ptr[i];
	    }
	}
break;
case 597:
#line 2750 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] - yyvsp[0].val;
	    }
	}
break;
case 598:
#line 2759 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val * yyvsp[0].val;
	    }
	}
break;
case 599:
#line 2768 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] * yyvsp[0].ptr[i];
	    }
	}
break;
case 600:
#line 2777 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val * yyvsp[0].ptr[i];
	    }
	}
break;
case 601:
#line 2786 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] * yyvsp[0].val;
	    }
	}
break;
case 602:
#line 2795 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    if (yyvsp[0].val == 0.0) {
		yyerror("Divide by Zero");
		return 1;
	    }
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val / yyvsp[0].val;
	    }
	}
break;
case 603:
#line 2808 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		if (yyvsp[0].ptr[i] == 0.0) {
		    yyerror("Divide by Zero");
		    return 1;
		}
	    }
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] / yyvsp[0].ptr[i];
	    }
	}
break;
case 604:
#line 2823 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		if (yyvsp[0].ptr[i] == 0.0) {
		    yyerror("Divide by Zero");
		    return 1;
		}
	    }
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val / yyvsp[0].ptr[i];
	    }
	}
break;
case 605:
#line 2838 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    if (yyvsp[0].val == 0.0) {
		yyerror("Divide by Zero");
		return 1;
	    }
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] / yyvsp[0].val;
	    }
	}
break;
case 606:
#line 2851 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = pow(yyvsp[-2].val, yyvsp[0].val);
	    }
	}
break;
case 607:
#line 2860 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = pow(yyvsp[-2].val, yyvsp[0].ptr[i]);
	    }
	}
break;
case 608:
#line 2869 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = pow(yyvsp[-2].ptr[i], yyvsp[0].val);
	    }
	}
break;
case 609:
#line 2878 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = pow(yyvsp[-2].ptr[i], yyvsp[0].ptr[i]);
	    }
	}
break;
case 610:
#line 2887 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = fabs(yyvsp[-1].val);
	    }
	}
break;
case 611:
#line 2896 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = fabs(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 612:
#line 2905 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = acos(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 613:
#line 2914 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = acosh(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 614:
#line 2923 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = asin(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 615:
#line 2932 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = asinh(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 616:
#line 2941 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = atan(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 617:
#line 2950 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = atanh(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 618:
#line 2959 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = atan2(yyvsp[-3].ptr[i], yyvsp[-1].ptr[i]);
	    }
	}
break;
case 619:
#line 2968 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = ceil(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 620:
#line 2977 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = cos(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 621:
#line 2986 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = cosh(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 622:
#line 2995 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] *= M_PI / 180.0;
	    }
	}
break;
case 623:
#line 3004 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = erf(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 624:
#line 3013 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = erfc(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 625:
#line 3022 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = exp(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 626:
#line 3031 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = floor(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 627:
#line 3040 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = my_hypot(yyvsp[-3].ptr[i], yyvsp[-1].ptr[i]);
	    }
	}
break;
case 628:
#line 3049 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = my_hypot(yyvsp[-3].val, yyvsp[-1].ptr[i]);
	    }
	}
break;
case 629:
#line 3058 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = my_hypot(yyvsp[-3].ptr[i], yyvsp[-1].val);
	    }
	}
break;
case 630:
#line 3067 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = my_hypot(yyvsp[-3].val, yyvsp[-1].val);
	    }
	}
break;
case 631:
#line 3076 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = i + 1;
	    }
	}
break;
case 632:
#line 3085 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[0].func;
	    }
	}
break;
case 633:
#line 3094 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = (int) yyvsp[-1].ptr[i];
	    }
	}
break;
case 634:
#line 3103 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = invnorm(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 635:
#line 3112 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = invt(yyvsp[-3].val, (int) yyvsp[-1].val);
	    }
	}
break;
case 636:
#line 3121 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = invt(yyvsp[-3].ptr[i], (int) yyvsp[-1].val);
	    }
	}
break;
case 637:
#line 3130 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = lrand48() % (long) (yyvsp[-1].val);
	    }
	}
break;
case 638:
#line 3139 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = lgamma(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 639:
#line 3148 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = log(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 640:
#line 3157 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = log10(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 641:
#line 3166 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = 1.0 / (1.0 + exp(-(yyvsp[-5].ptr[i] - yyvsp[-3].val)/ yyvsp[-1].val));
	    }
	}
break;
case 642:
#line 3175 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-3].ptr[i] >= yyvsp[-1].ptr[i] ? yyvsp[-3].ptr[i] : yyvsp[-1].ptr[i];
	    }
	}
break;
case 643:
#line 3184 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-3].ptr[i] <= yyvsp[-1].ptr[i] ? yyvsp[-3].ptr[i] : yyvsp[-1].ptr[i];
	    }
	}
break;
case 644:
#line 3193 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = fmod(yyvsp[-3].ptr[i], yyvsp[-1].ptr[i]);
	    }
	}
break;
case 645:
#line 3202 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = fx(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 646:
#line 3211 "pars.yacc"
{
	    int i;
	    double tmp;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = normp(yyvsp[-1].ptr[i], &tmp);
	    }
	}
break;
case 647:
#line 3221 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = M_PI;
	    }
	}
break;
case 648:
#line 3230 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = M_PI / 180.0;
	    }
	}
break;
case 649:
#line 3239 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = (double) drand48();
	    }
	}
break;
case 650:
#line 3248 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = rnorm(yyvsp[-3].ptr[i], yyvsp[-1].ptr[i]);
	    }
	}
break;
case 651:
#line 3257 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = rnorm(yyvsp[-3].val, yyvsp[-1].ptr[i]);
	    }
	}
break;
case 652:
#line 3266 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = rnorm(yyvsp[-3].ptr[i], yyvsp[-1].val);
	    }
	}
break;
case 653:
#line 3275 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = rnorm(yyvsp[-3].val, yyvsp[-1].val);
	    }
	}
break;
case 654:
#line 3284 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = sin(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 655:
#line 3293 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = sinh(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 656:
#line 3302 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-1].ptr[i] * yyvsp[-1].ptr[i];
	    }
	}
break;
case 657:
#line 3311 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = sqrt(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 658:
#line 3320 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = tan(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 659:
#line 3329 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = tanh(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 660:
#line 3337 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
	        if ((int) yyvsp[-4].ptr[i]) {
		    yyval.ptr[i] = yyvsp[-2].ptr[i];
	        } else {
		    yyval.ptr[i] = yyvsp[0].ptr[i];
	        }
	    }
	}
break;
case 661:
#line 3350 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] > yyvsp[0].ptr[i];
	    }
	}
break;
case 662:
#line 3359 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] < yyvsp[0].ptr[i];
	    }
	}
break;
case 663:
#line 3368 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] <= yyvsp[0].ptr[i];
	    }
	}
break;
case 664:
#line 3377 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] >= yyvsp[0].ptr[i];
	    }
	}
break;
case 665:
#line 3386 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] == yyvsp[0].ptr[i];
	    }
	}
break;
case 666:
#line 3395 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] != yyvsp[0].ptr[i];
	    }
	}
break;
case 667:
#line 3404 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] && yyvsp[0].ptr[i];
	    }
	}
break;
case 668:
#line 3413 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] || yyvsp[0].ptr[i];
	    }
	}
break;
case 669:
#line 3422 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = !(yyvsp[0].ptr[i]);
	    }
	}
break;
case 670:
#line 3431 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-1].ptr[i];
	    }
	}
break;
case 671:
#line 3439 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = -yyvsp[0].ptr[i];
	    }
	}
break;
case 673:
#line 3450 "pars.yacc"
{
	    yyval.val = yyvsp[0].val;
	}
break;
case 674:
#line 3453 "pars.yacc"
{
	    yyval.val = yyvsp[-3].ptr[(int) yyvsp[-1].val];
	}
break;
case 675:
#line 3456 "pars.yacc"
{
	    yyval.val = (yyvsp[0].pset == X) ? *xx : *yy;
	}
break;
case 676:
#line 3459 "pars.yacc"
{
	    double *ptr = getvptr(cg, curset, yyvsp[-3].pset);
	    if (ptr != NULL) {
		yyval.val = ptr[(int) yyvsp[-1].val - 1];
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 677:
#line 3469 "pars.yacc"
{
	    double *ptr = getvptr(cg, yyvsp[-5].pset, yyvsp[-3].pset);
	    if (ptr != NULL) {
		yyval.val = ptr[(int) yyvsp[-1].val - 1];
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 678:
#line 3479 "pars.yacc"
{
	    double *ptr = getvptr(yyvsp[-7].pset, yyvsp[-5].pset, yyvsp[-3].pset);
	    if (ptr != NULL) {
		yyval.val = ptr[(int) yyvsp[-1].val - 1];
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 679:
#line 3489 "pars.yacc"
{
	    double *ptr = getvptr(cg, yyvsp[-4].pset, yyvsp[-2].pset);
	    if (ptr == NULL) {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    switch (yyvsp[0].pset) {
	    case MINP:
		yyval.val = vmin(ptr, g[cg].p[yyvsp[-4].pset].len);
		break;
	    case MAXP:
		yyval.val = vmax(ptr, g[cg].p[yyvsp[-4].pset].len);
		break;
	    }
	}
break;
case 680:
#line 3504 "pars.yacc"
{
	    double *ptr = getvptr(yyvsp[-6].pset, yyvsp[-4].pset, yyvsp[-2].pset);
	    if (ptr == NULL) {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    switch (yyvsp[0].pset) {
	    case MINP:
		yyval.val = vmin(ptr, g[yyvsp[-6].pset].p[yyvsp[-4].pset].len);
		break;
	    case MAXP:
		yyval.val = vmax(ptr, g[yyvsp[-6].pset].p[yyvsp[-4].pset].len);
		break;
	    }
	}
break;
case 681:
#line 3519 "pars.yacc"
{
	    yyval.val = g[cg].p[yyvsp[-2].pset].len;
	}
break;
case 682:
#line 3523 "pars.yacc"
{
	    double bar, sd;
	    double *ptr = getvptr(cg, yyvsp[-4].pset, yyvsp[-2].pset);
	    if (ptr != NULL) {
		stasum(ptr, getsetlength(cg, yyvsp[-4].pset), &bar, &sd, 0);
	        yyval.val = bar;
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 683:
#line 3535 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val + yyvsp[0].val;
	}
break;
case 684:
#line 3538 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val - yyvsp[0].val;
	}
break;
case 685:
#line 3541 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val * yyvsp[0].val;
	}
break;
case 686:
#line 3545 "pars.yacc"
{
	    if (yyvsp[0].val != 0.0) {
		yyval.val = yyvsp[-2].val / yyvsp[0].val;
	    } else {
		yyerror("Divide by Zero");
		return 1;
	    }
	}
break;
case 687:
#line 3553 "pars.yacc"
{
	    yyval.val = fmod(yyvsp[-2].val, yyvsp[0].val);
	}
break;
case 688:
#line 3556 "pars.yacc"
{
	    yyval.val = pow(yyvsp[-2].val, yyvsp[0].val);
	}
break;
case 689:
#line 3559 "pars.yacc"
{
	    yyval.val = fabs(yyvsp[-1].val);
	}
break;
case 690:
#line 3562 "pars.yacc"
{
	    yyval.val = acos(yyvsp[-1].val);
	}
break;
case 691:
#line 3565 "pars.yacc"
{
	    yyval.val = acosh(yyvsp[-1].val);
	}
break;
case 692:
#line 3568 "pars.yacc"
{
	    yyval.val = asin(yyvsp[-1].val);
	}
break;
case 693:
#line 3571 "pars.yacc"
{
	    yyval.val = asinh(yyvsp[-1].val);
	}
break;
case 694:
#line 3574 "pars.yacc"
{
	    yyval.val = atan(yyvsp[-1].val);
	}
break;
case 695:
#line 3577 "pars.yacc"
{
	    yyval.val = atanh(yyvsp[-1].val);
	}
break;
case 696:
#line 3580 "pars.yacc"
{
	    yyval.val = atan2(yyvsp[-3].val, yyvsp[-1].val);
	}
break;
case 697:
#line 3583 "pars.yacc"
{
	    yyval.val = ceil(yyvsp[-1].val);
	}
break;
case 698:
#line 3586 "pars.yacc"
{
	    yyval.val = cos(yyvsp[-1].val);
	}
break;
case 699:
#line 3589 "pars.yacc"
{
	    yyval.val = cosh(yyvsp[-1].val);
	}
break;
case 700:
#line 3592 "pars.yacc"
{
	    yyval.val = 180.0 / M_PI;
	}
break;
case 701:
#line 3595 "pars.yacc"
{
	    yyval.val = erf(yyvsp[-1].val);
	}
break;
case 702:
#line 3598 "pars.yacc"
{
	    yyval.val = erfc(yyvsp[-1].val);
	}
break;
case 703:
#line 3601 "pars.yacc"
{
	    yyval.val = exp(yyvsp[-1].val);
	}
break;
case 704:
#line 3604 "pars.yacc"
{
	    yyval.val = floor(yyvsp[-1].val);
	}
break;
case 705:
#line 3607 "pars.yacc"
{
	    yyval.val = my_hypot(yyvsp[-3].val, yyvsp[-1].val);
	}
break;
case 706:
#line 3610 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].v.xv1;
	}
break;
case 707:
#line 3613 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].v.xv2;
	}
break;
case 708:
#line 3616 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].v.yv1;
	}
break;
case 709:
#line 3619 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].v.yv2;
	}
break;
case 710:
#line 3622 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].w.xg1;
	}
break;
case 711:
#line 3625 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].w.xg2;
	}
break;
case 712:
#line 3628 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].w.yg1;
	}
break;
case 713:
#line 3631 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].w.yg2;
	}
break;
case 714:
#line 3634 "pars.yacc"
{
	    yyval.val = g[cg].v.xv1;
	}
break;
case 715:
#line 3637 "pars.yacc"
{
	    yyval.val = g[cg].v.xv2;
	}
break;
case 716:
#line 3640 "pars.yacc"
{
	    yyval.val = g[cg].v.yv1;
	}
break;
case 717:
#line 3643 "pars.yacc"
{
	    yyval.val = g[cg].v.yv2;
	}
break;
case 718:
#line 3646 "pars.yacc"
{
	    yyval.val = g[cg].w.xg1;
	}
break;
case 719:
#line 3649 "pars.yacc"
{
	    yyval.val = g[cg].w.xg2;
	}
break;
case 720:
#line 3652 "pars.yacc"
{
	    yyval.val = g[cg].w.yg1;
	}
break;
case 721:
#line 3655 "pars.yacc"
{
	    yyval.val = g[cg].w.yg2;
	}
break;
case 722:
#line 3658 "pars.yacc"
{
	    yyval.val = g[cg].w.xg2 - g[cg].w.xg1;
	}
break;
case 723:
#line 3661 "pars.yacc"
{
	    yyval.val = g[cg].w.yg2 - g[cg].w.yg1;
	}
break;
case 724:
#line 3664 "pars.yacc"
{
	    yyval.val = setindex;
	}
break;
case 725:
#line 3667 "pars.yacc"
{
	    yyval.val = setsetno;
	}
break;
case 726:
#line 3670 "pars.yacc"
{
	    yyval.val = (long) yyvsp[-1].val;
	}
break;
case 727:
#line 3673 "pars.yacc"
{
	    yyval.val = invnorm(yyvsp[-1].val);
	}
break;
case 728:
#line 3676 "pars.yacc"
{
	    yyval.val = invt(yyvsp[-3].val, (int) yyvsp[-1].val);
	}
break;
case 729:
#line 3679 "pars.yacc"
{
	    yyval.val = lrand48() % (long) (yyvsp[-1].val);
	}
break;
case 730:
#line 3682 "pars.yacc"
{ /* yr, mo, day */
	    yyval.val = julday((int) yyvsp[-3].val, (int) yyvsp[-1].val, (int) yyvsp[-5].val, 12, 0, 0.0);
	}
break;
case 731:
#line 3686 "pars.yacc"
{ /* yr, mo, day, hr, min, sec */
	    yyval.val = julday((int) yyvsp[-9].val, (int) yyvsp[-7].val, (int) yyvsp[-11].val, (int) yyvsp[-5].val, (int) yyvsp[-3].val, (double) yyvsp[-1].val);
	}
break;
case 732:
#line 3689 "pars.yacc"
{
	    yyval.val = lgamma(yyvsp[-1].val);
	}
break;
case 733:
#line 3692 "pars.yacc"
{
	    yyval.val = log(yyvsp[-1].val);
	}
break;
case 734:
#line 3695 "pars.yacc"
{
	    yyval.val = log10(yyvsp[-1].val);
	}
break;
case 735:
#line 3699 "pars.yacc"
{
	    yyval.val = 1.0 / (1.0 + exp(-(yyvsp[-5].val - yyvsp[-3].val)/ yyvsp[-1].val));
	}
break;
case 736:
#line 3702 "pars.yacc"
{
	    yyval.val = yyvsp[-3].val >= yyvsp[-1].val ? yyvsp[-3].val : yyvsp[-1].val;
	}
break;
case 737:
#line 3705 "pars.yacc"
{
	    yyval.val = yyvsp[-3].val <= yyvsp[-1].val ? yyvsp[-3].val : yyvsp[-1].val;
	}
break;
case 738:
#line 3708 "pars.yacc"
{
	    yyval.val = fmod(yyvsp[-3].val, yyvsp[-1].val);
	}
break;
case 739:
#line 3711 "pars.yacc"
{
	    yyval.val = fx(yyvsp[-1].val);
	}
break;
case 740:
#line 3714 "pars.yacc"
{
	    double tmp;
	    yyval.val = normp(yyvsp[-1].val, &tmp);
	}
break;
case 741:
#line 3718 "pars.yacc"
{
	    yyval.val = M_PI;
	}
break;
case 742:
#line 3721 "pars.yacc"
{
	    yyval.val = M_PI / 180.0;
	}
break;
case 743:
#line 3724 "pars.yacc"
{
	    yyval.val = (double) drand48();
	}
break;
case 744:
#line 3727 "pars.yacc"
{
	    yyval.val = rnorm(yyvsp[-3].val, yyvsp[-1].val);
	}
break;
case 745:
#line 3730 "pars.yacc"
{
	    yyval.val = sin(yyvsp[-1].val);
	}
break;
case 746:
#line 3733 "pars.yacc"
{
	    yyval.val = sinh(yyvsp[-1].val);
	}
break;
case 747:
#line 3736 "pars.yacc"
{
	    yyval.val = pow(yyvsp[-1].val, 2.0);
	}
break;
case 748:
#line 3739 "pars.yacc"
{
	    yyval.val = sqrt(yyvsp[-1].val);
	}
break;
case 749:
#line 3742 "pars.yacc"
{
	    yyval.val = tan(yyvsp[-1].val);
	}
break;
case 750:
#line 3745 "pars.yacc"
{
	    yyval.val = tanh(yyvsp[-1].val);
	}
break;
case 751:
#line 3748 "pars.yacc"
{
	    if ((int) yyvsp[-4].val) {
		yyval.val = yyvsp[-2].val;
	    } else {
		yyval.val = yyvsp[0].val;
	    }
	}
break;
case 752:
#line 3755 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val > yyvsp[0].val;
	}
break;
case 753:
#line 3758 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val < yyvsp[0].val;
	}
break;
case 754:
#line 3761 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val <= yyvsp[0].val;
	}
break;
case 755:
#line 3764 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val >= yyvsp[0].val;
	}
break;
case 756:
#line 3767 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val == yyvsp[0].val;
	}
break;
case 757:
#line 3770 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val != yyvsp[0].val;
	}
break;
case 758:
#line 3773 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val && yyvsp[0].val;
	}
break;
case 759:
#line 3776 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val || yyvsp[0].val;
	}
break;
case 760:
#line 3779 "pars.yacc"
{
	    yyval.val = !(yyvsp[0].val);
	}
break;
case 761:
#line 3782 "pars.yacc"
{
	    yyval.val = yyvsp[-1].val;
	}
break;
case 762:
#line 3785 "pars.yacc"
{
	    yyval.val = -yyvsp[0].val;
	}
break;
#line 10902 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: after reduction, shifting from state 0 to\
 state %d\n", YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("yydebug: state %d, reading %d (%s)\n",
                        YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("yydebug: after reduction, shifting from state %d \
to state %d\n", *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
